<!-- README.md is generated from README.Rmd. Please edit that file -->

# wk

<!-- badges: start -->

[![R build
status](https://github.com/paleolimbot/wk/workflows/R-CMD-check/badge.svg)](https://github.com/paleolimbot/wk/actions)
[![Codecov test
coverage](https://codecov.io/gh/paleolimbot/wk/branch/master/graph/badge.svg)](https://app.codecov.io/gh/paleolimbot/wk?branch=master)
<!-- badges: end -->

The goal of wk is to provide lightweight R, C, and C++ infrastructure
for a distributed ecosystem of packages that operate on collections of
coordinates. First, wk provides vector classes for points, circles,
rectangles, well-known text (WKT), and well-known binary (WKB). Second,
wk provides a C API and set of S3 generics for event-based iteration
over vectors of geometries.

## Installation

You can install the released version of wk from
[CRAN](https://cran.r-project.org/) with:

``` r
install.packages("wk")
```

You can install the development version from
[GitHub](https://github.com/) with:

``` r
# install.packages("remotes")
remotes::install_github("paleolimbot/wk")
```

If you can load the package, you’re good to go!

``` r
library(wk)
```

## Vector classes

Use `wkt()` to mark a character vector as containing well-known text, or
`wkb()` to mark a vector as well-known binary. Use `xy()`, `xyz()`,
`xym()`, and `xyzm()` to create vectors of points, and `rct()` to create
vectors of rectangles. These classes have full
[vctrs](https://vctrs.r-lib.org) support and `plot()`/`format()` methods
to make them as frictionless as possible working in R and RStudio.

``` r
wkt("POINT (30 10)")
#> <wk_wkt[1]>
#> [1] POINT (30 10)
as_wkb(wkt("POINT (30 10)"))
#> <wk_wkb[1]>
#> [1] <POINT (30 10)>
xy(1, 2)
#> <wk_xy[1]>
#> [1] (1 2)
rct(1, 2, 3, 4)
#> <wk_rct[1]>
#> [1] [1 2 3 4]
crc(0, 0, 1)
#> <wk_crc[1]>
#> [1] [0 0, r = 1]
```

## Generics

The wk package is made up of readers, handlers, and filters. Readers
parse the various formats supported by the wk package, handlers
calculate values based on information from the readers (e.g.,
translating a vector of geometries into another format), and filters
transform information from the readers (e.g., transforming coordinates)
on the fly. The `wk_handle()` and `wk_translate()` generics power
operations for many geometry vector formats without having to explicitly
support each one.

## C API

The distributed nature of the wk framework is powered by a [~100-line
header](https://github.com/paleolimbot/wk/blob/master/inst/include/wk-v1.h)
describing the types of information that parsers typically encounter
when reading geometries and the order in which that information is
typically organized. Detailed information is available in the [C and C++
API
article](https://paleolimbot.github.io/wk/articles/articles/programming.html).

``` r
wk_debug(
  as_wkt("LINESTRING (1 1, 2 2, 3 3)"),
  wkt_format_handler(max_coords = 2)
)
#> initialize (dirty = 0  -> 1)
#> vector_start: <Unknown type / 0>[1] <0x16d75aac0> => WK_CONTINUE
#>   feature_start (1): <0x16d75aac0>  => WK_CONTINUE
#>     geometry_start (<none>): LINESTRING[UNKNOWN] <0x16d75a950> => WK_CONTINUE
#>       coord (1): <0x16d75a950> (1.000000 1.000000)  => WK_CONTINUE
#>       coord (2): <0x16d75a950> (2.000000 2.000000)  => WK_ABORT_FEATURE
#> vector_end: <0x16d75aac0>
#> deinitialize
#> [1] "LINESTRING (1 1, 2 2..."
```

## sf support

The wk package implements a reader and writer for sfc objects so you can
use them wherever you’d use an `xy()`, `rct()`, `crc()`, `wkb()`, or
`wkt()`:

``` r
wk_debug(
  sf::st_sfc(sf::st_linestring(rbind(c(1, 1), c(2, 2), c(3, 3)))),
  wkt_format_handler(max_coords = 2)
)
#> initialize (dirty = 0  -> 1)
#> vector_start: LINESTRING B[1] <0x16d75dac8> => WK_CONTINUE
#>   feature_start (1): <0x16d75dac8>  => WK_CONTINUE
#>     geometry_start (<none>): LINESTRING[3] <0x16d75da10> => WK_CONTINUE
#>       coord (1): <0x16d75da10> (1.000000 1.000000)  => WK_CONTINUE
#>       coord (2): <0x16d75da10> (2.000000 2.000000)  => WK_ABORT_FEATURE
#> vector_end: <0x16d75dac8>
#> deinitialize
#> [1] "LINESTRING (1 1, 2 2..."
```

## Lightweight

The wk package has zero dependencies and compiles in ~10 seconds.

#' Translate geometry vectors
#'
#' @inheritParams wk_handle
#' @param to A prototype object.
#'
#' @export
#'
wk_translate <- function(handleable, to, ...) {
  UseMethod("wk_translate", to)
}

#' @rdname wk_translate
#' @export
wk_translate.default <- function(handleable, to, ...) {
  result <- wk_handle(handleable, wk_writer(to), ...)
  attr(result, "crs") <- wk_crs_output(handleable, to)
  wk_set_geodesic(result, wk_is_geodesic_output(handleable, to))
}

#' Handler interface for grid objects
#'
#' @inheritParams wk_handle
#' @param data_order A vector of length 2 describing the order in which
#'   values should appear. The default, `c("y", "x")`, will output values
#'   in the same order as the default matrix storage in R (column-major).
#'   You can prefix a dimension with `-` to reverse the order of a
#'   dimension (e.g., `c("-y", "x")`).
#'
#' @return The result of the `handler`.
#' @export
#'
#' @examples
#' wk_handle(grd(nx = 3, ny = 3), wkt_writer())
#' wk_handle(grd(nx = 3, ny = 3, type = "centers"), wkt_writer())
#'
wk_handle.wk_grd_xy <- function(handleable, handler, ..., data_order = c("y", "x")) {
  # eventually these will be more efficient and not resolve every cell
  wk_handle(as_xy(handleable, data_order = data_order), handler, ...)
}

#' @rdname wk_handle.wk_grd_xy
#' @export
wk_handle.wk_grd_rct <- function(handleable, handler, ..., data_order = c("y", "x")) {
  # eventually these will be more efficient and not resolve every cell
  wk_handle(as_rct(handleable, data_order = data_order), handler, ...)
}

#' @export
as_xy.wk_grd_xy <- function(x, ..., data_order = c("y", "x")) {
  rct <- unclass(x$bbox)
  nx <- dim(x$data)[2]
  ny <- dim(x$data)[1]
  width <- rct$xmax - rct$xmin
  height <- rct$ymax - rct$ymin

  if (identical(width, -Inf) || identical(height, -Inf)) {
    return(xy(crs = wk_crs(x)))
  }

  if (nx == 1L) {
    xs <- rct$xmin
  } else {
    xs <- seq(rct$xmin, rct$xmax, by = width / (nx - 1))
  }

  if (ny == 1L) {
    ys <- rct$ymin
  } else {
    ys <- seq(rct$ymax, rct$ymin, by = -height / (ny - 1))
  }

  # Custom ordering such that coordinates can match up to data
  dim_order <- gsub("^[+-]", "", data_order)

  if (identical(dim_order, c("y", "x"))) {
    if (startsWith(data_order[1], "-")) {
      ys <- rev(ys)
    }

    if (startsWith(data_order[2], "-")) {
      xs <- rev(xs)
    }

    xy(
      rep(xs, each = length(ys)),
      rep(ys, length(xs)),
      crs = wk_crs(x$bbox)
    )
  } else {
    if (startsWith(data_order[2], "-")) {
      ys <- rev(ys)
    }

    if (startsWith(data_order[1], "-")) {
      xs <- rev(xs)
    }

    xy(
      rep(xs, length(ys)),
      rep(ys, each = length(xs)),
      crs = wk_crs(x$bbox)
    )
  }
}

#' @export
as_rct.wk_grd_rct <- function(x, ..., data_order = c("y", "x")) {
  rct <- unclass(x$bbox)
  nx <- dim(x$data)[2]
  ny <- dim(x$data)[1]
  width <- rct$xmax - rct$xmin
  height <- rct$ymax - rct$ymin

  if (identical(width, -Inf) || identical(height, -Inf)) {
    return(rct(crs = wk_crs(x)))
  }

  # Custom ordering such that coordinates can match up to data
  xs <- seq(rct$xmin, rct$xmax, by = width / nx)
  ys <- seq(rct$ymax, rct$ymin, by = -height / ny)

  dim_order <- gsub("^[+-]", "", data_order)

  if (identical(dim_order, c("y", "x"))) {
    if (startsWith(data_order[1], "-")) {
      ys <- rev(ys)
      ymax <- rep(ys[-1], nx)
      ymin <- rep(ys[-length(ys)], nx)
    } else {
      ymin <- rep(ys[-1], nx)
      ymax <- rep(ys[-length(ys)], nx)
    }

    if (startsWith(data_order[2], "-")) {
      xs <- rev(xs)
      xmax <- rep(xs[-length(xs)], each = ny)
      xmin <- rep(xs[-1], each = ny)
    } else {
      xmin <- rep(xs[-length(xs)], each = ny)
      xmax <- rep(xs[-1], each = ny)
    }

    rct(xmin, ymin, xmax, ymax, crs = wk_crs(x$bbox))
  } else {
    if (startsWith(data_order[2], "-")) {
      ys <- rev(ys)
      ymax <- rep(ys[-1], each = nx)
      ymin <- rep(ys[-length(ys)], each = nx)
    } else {
      ymin <- rep(ys[-1], each = nx)
      ymax <- rep(ys[-length(ys)], each = nx)
    }

    if (startsWith(data_order[1], "-")) {
      xs <- rev(xs)
      xmax <- rep(xs[-length(xs)], ny)
      xmin <- rep(xs[-1], ny)
    } else {
      xmin <- rep(xs[-length(xs)], ny)
      xmax <- rep(xs[-1], ny)
    }
  }

  rct(xmin, ymin, xmax, ymax, crs = wk_crs(x$bbox))
}

#' @export
as_xy.wk_grd_rct <- function(x, ...) {
  as_xy(as_grd_xy(x))
}

#' @export
as_rct.wk_grd_xy <- function(x, ...) {
  as_rct(as_grd_rct(x))
}

# nocov start
.onLoad <- function(...) {

  # Register S3 methods for Suggests
  for (cls in c("wk_wkb", "wk_wkt",
                "wk_xy", "wk_xyz", "wk_xym", "wk_xyzm",
                "wk_rct", "wk_crc")) {
    s3_register("vctrs::vec_proxy", cls)
    s3_register("vctrs::vec_restore", cls)
    s3_register("vctrs::vec_cast", cls)
    s3_register("vctrs::vec_ptype2", cls)

  }

  for (cls in c("wk_wkb", "wk_wkt", "wk_xy", "wk_rct", "wk_crc")) {
    s3_register("sf::st_as_sfc", cls)
    s3_register("sf::st_as_sf", cls)
    s3_register("sf::st_geometry", cls)
    s3_register("sf::st_bbox", cls)
    s3_register("sf::st_crs", cls)
    s3_register("sf::st_crs<-", cls)
    s3_register("readr::output_column", cls)
  }

  # grd is not a vector class, but does have sf methods
  s3_register("sf::st_as_sfc", "wk_grd")
  s3_register("sf::st_as_sf", "wk_grd")
  s3_register("sf::st_geometry", "wk_grd")
  s3_register("sf::st_bbox", "wk_grd")
  s3_register("sf::st_crs", "wk_grd")
  s3_register("sf::st_crs<-", "wk_grd")

  # wkb vec_proxy_equal
  s3_register("vctrs::vec_proxy_equal", "wk_wkb")
}

.onUnload <- function (libpath) {
  library.dynam.unload("wk", libpath)
}

s3_register <- function(generic, class, method = NULL) {
  stopifnot(is.character(generic), length(generic) == 1)
  stopifnot(is.character(class), length(class) == 1)

  pieces <- strsplit(generic, "::")[[1]]
  stopifnot(length(pieces) == 2)
  package <- pieces[[1]]
  generic <- pieces[[2]]

  caller <- parent.frame()

  get_method_env <- function() {
    top <- topenv(caller)
    if (isNamespace(top)) {
      asNamespace(environmentName(top))
    } else {
      caller
    }
  }
  get_method <- function(method, env) {
    if (is.null(method)) {
      get(paste0(generic, ".", class), envir = get_method_env())
    } else {
      method
    }
  }

  method_fn <- get_method(method)
  stopifnot(is.function(method_fn))

  # Always register hook in case package is later unloaded & reloaded
  setHook(
    packageEvent(package, "onLoad"),
    function(...) {
      ns <- asNamespace(package)

      # Refresh the method, it might have been updated by `devtools::load_all()`
      method_fn <- get_method(method)

      registerS3method(generic, class, method_fn, envir = ns)
    }
  )

  # Avoid registration failures during loading (pkgload or regular)
  if (!isNamespaceLoaded(package)) {
    return(invisible())
  }

  envir <- asNamespace(package)

  # Only register if generic can be accessed
  if (exists(generic, envir)) {
    registerS3method(generic, class, method_fn, envir = envir)
  }

  invisible()
}
# nocov end

#' Orient polygon coordinates
#'
#' @inheritParams wk_handle
#' @param direction The winding polygon winding direction
#'
#' @return `handleable` with consistently oriented polygons, in `direction`
#'   winding order.
#' @export
#'
#' @examples
#' wk_orient(wkt("POLYGON ((0 0, 1 0, 1 1, 0 1, 0 0))"))
#' wk_orient(
#'   wkt("POLYGON ((0 0, 0 1, 1 1, 1 0, 0 0))"),
#'   direction = wk_clockwise()
#' )
#'
wk_orient <- function(handleable, ..., direction = wk_counterclockwise()) {
  result <- wk_handle(
    handleable,
    wk_orient_filter(wk_writer(handleable), direction),
    ...
  )
  result <- wk_restore(handleable, result, ...)
  result <- wk_set_geodesic(result, wk_is_geodesic(handleable))
  wk_set_crs(result, wk_crs(handleable))
}

#' @rdname wk_orient
#' @export
wk_orient_filter <- function(handler, direction = wk_counterclockwise()) {
  stopifnot(direction %in% c(wk_clockwise(), wk_counterclockwise()))

  new_wk_handler(
    .Call(
      wk_c_orient_filter_new,
      as_wk_handler(handler),
      as.integer(direction)[1]
    ),
    "wk_orient_filter"
  )
}

#' @rdname wk_orient
#' @export
wk_clockwise <- function() {
  -1L
}

#' @rdname wk_orient
#' @export
wk_counterclockwise <- function() {
  1L
}

#' Compute overview grid tile
#'
#' A useful workflow for raster data in a memory bounded environment is to
#' chunk a grid into sections or tiles. These functions compute tiles
#' suitable for such processing. Use [grd_tile_summary()] to generate
#' statistics for `level` values to choose for your application.
#'
#' @inheritParams grd_summary
#' @param level An integer describing the overview level. This is related to
#'   the `step` value by a power of 2 (i.e., a level of `1` indicates a step of
#'   `2`, a level of `2` indicates a step of `4`, etc.).
#' @param levels A vector of `level` values or `NULL` to use a sequence from
#'   0 to the level that would result in a 1 x 1 grid.
#'
#' @return A [grd()]
#' @export
#'
#' @examples
#' grid <- grd_rct(volcano)
#' grd_tile_summary(grid)
#' grd_tile_template(grid, 3)
#'
grd_tile_template <- function(grid, level) {
  level <- normalize_level(grid, level)
  grid <- as_grd_rct(grid)

  # clamp the step to a reasonable bound
  s <- grd_summary(grid)
  step <- 2 ^ level
  step_clamp <- pmax(1L, pmin(c(s$ny, s$nx), step))
  level_clamp <- ceiling(log2(step_clamp))
  step_final <- 2 ^ level_clamp

  # calculate the new grid parameters
  final_dy <- s$dy * step_final[1]
  final_dx <- s$dx * step_final[2]
  final_ny <- ceiling(s$ny / step_final[1])
  final_nx <- ceiling(s$nx / step_final[2])

  final_bbox <- rct(
    s$xmin,
    s$ymax - final_ny * final_dy,
    s$xmin + final_nx * final_dx,
    s$ymax,
    crs = wk_crs(grid)
  )

  grd_rct(
    array(dim = c(final_ny, final_nx, 0)),
    final_bbox
  )
}

#' @rdname grd_tile_template
#' @export
grd_tile_summary <- function(grid, levels = NULL) {
  if (is.null(levels)) {
    s <- grd_summary(grid)
    level0 <- max(floor(log2(c(s$nx, s$ny)))) + 1L
    levels <- 0:level0
  }

  overviews <- lapply(levels, function(level) grd_tile_template(grid, level))
  summaries <- lapply(overviews, grd_summary)
  summary_df <- lapply(summaries, new_data_frame)
  cbind(level = levels, do.call(rbind, summary_df))
}

#' Extract normalized grid tiles
#'
#' Unlike [grd_tile_template()], which returns a [grd()] whose elements are
#' the boundaries of the specified tiles with no data attached, [grd_tile()]
#' returns the actual tile with the data.
#'
#' @inheritParams grd_tile_summary
#' @inheritParams grd_subset
#'
#' @return A [grd_subset()]ed version
#' @export
#'
#' @examples
#' grid <- grd_rct(volcano)
#' plot(grd_tile(grid, 4, 1, 1))
#'
#' plot(grd_tile(grid, 3, 1, 1), add = TRUE)
#' plot(grd_tile(grid, 3, 1, 2), add = TRUE)
#' plot(grd_tile(grid, 3, 2, 1), add = TRUE)
#' plot(grd_tile(grid, 3, 2, 2), add = TRUE)
#'
#' grid <- as_grd_xy(grd_tile(grid, 4, 1, 1))
#' plot(grid, add = TRUE, pch = ".")
#' plot(grd_tile(grid, 3, 1, 1), add = TRUE, col = "green", pch = ".")
#' plot(grd_tile(grid, 3, 1, 2), add = TRUE, col = "red", pch = ".")
#' plot(grd_tile(grid, 3, 2, 1), add = TRUE, col = "blue", pch = ".")
#' plot(grd_tile(grid, 3, 2, 2), add = TRUE, col = "magenta", pch = ".")
#'
grd_tile <- function(grid, level, i, j = NULL) {
  UseMethod("grd_tile")
}

#' @rdname grd_tile
#' @export
grd_tile.wk_grd_rct <- function(grid, level, i, j = NULL) {
  overview <- grd_tile_template(grid, level)
  bbox <- grd_cell_rct(overview, i, j)
  ranges <- grd_cell_range(grid, bbox, snap = list(grd_snap_next, grd_snap_previous))
  grd_subset(grid, ranges)
}

#' @rdname grd_tile
#' @export
grd_tile.wk_grd_xy <- function(grid, level, i, j = NULL) {
  grid_rct <- as_grd_rct(grid)
  overview <- grd_tile_template(grid_rct, level)
  bbox <- grd_cell_rct(overview, i, j)
  ranges <- grd_cell_range(grid, bbox, snap = list(grd_snap_next, grd_snap_previous))
  grd_subset(grid, ranges)
}

# This could maybe in the future deal with negative levels based on the
# grd_tile_summary() so that one could work down from coarse->fine
normalize_level <- function(grid, level, s = grd_summary(grid)) {
  if (length(level) == 1L) {
    level <- c(level, level)
  }

  level
}

#' Set and get vector CRS
#'
#' The wk package doesn't operate on CRS objects, but does propagate them
#' through subsetting and concatenation. A CRS object can be any R object,
#' and x can be any object whose 'crs' attribute carries a CRS. These functions
#' are S3 generics to keep them from being used
#' on objects that do not use this system of CRS propagation.
#'
#' @param x,... Objects whose "crs" attribute is used to carry a CRS.
#' @param crs An object that can be interpreted as a CRS
#' @param value See `crs`.
#'
#' @export
#'
wk_crs <- function(x) {
  UseMethod("wk_crs")
}

#' @rdname wk_crs
#' @export
wk_crs.wk_vctr <- function(x) {
  attr(x, "crs", exact = TRUE)
}

#' @rdname wk_crs
#' @export
wk_crs.wk_rcrd <- function(x) {
  attr(x, "crs", exact = TRUE)
}

#' @rdname wk_crs
#' @export
`wk_crs<-` <- function(x, value) {
  wk_set_crs(x, value)
}

#' @rdname wk_crs
#' @export
wk_set_crs <- function(x, crs) {
  UseMethod("wk_set_crs")
}

#' @export
wk_set_crs.wk_vctr <- function(x, crs) {
  attr(x, "crs") <- crs
  x
}

#' @export
wk_set_crs.wk_rcrd <- function(x, crs) {
  attr(x, "crs") <- crs
  x
}

#' @rdname wk_crs
#' @export
wk_crs_output <- function(...) {
  dots <- list(...)
  crs <- lapply(dots, wk_crs)
  Reduce(wk_crs2, crs)
}

#' @rdname wk_crs
#' @export
wk_is_geodesic_output <- function(...) {
  dots <- list(...)
  geodesic <- lapply(dots, wk_is_geodesic)
  Reduce(wk_is_geodesic2, geodesic)
}

wk_crs2 <- function(x, y) {
  if (inherits(y, "wk_crs_inherit")) {
    x
  } else if (inherits(x, "wk_crs_inherit")) {
    y
  } else if (wk_crs_equal(x, y)) {
    x
  } else {
    stop(sprintf("CRS objects '%s' and '%s' are not equal.", format(x), format(y)), call. = FALSE)
  }
}

wk_is_geodesic2 <- function(x, y) {
  if (identical(x, y)) {
    x
  } else if (identical(x, NA)) {
    y
  } else if (identical(y, NA)) {
    x
  } else {
    stop("objects have differing values for geodesic", call. = FALSE)
  }
}

#' Compare CRS objects
#'
#' The [wk_crs_equal()] function uses special S3 dispatch on [wk_crs_equal_generic()]
#' to evaluate whether or not two CRS values can be considered equal. When implementing
#' [wk_crs_equal_generic()], every attempt should be made to make `wk_crs_equal(x, y)`
#' and `wk_crs_equal(y, x)` return identically.
#'
#' @param x,y Objects stored in the `crs` attribute of a vector.
#' @param ... Unused
#'
#' @return `TRUE` if `x` and `y` can be considered equal, `FALSE` otherwise.
#' @export
#'
wk_crs_equal <- function(x, y) {
  if (is.object(y)) {
    wk_crs_equal_generic(y, x)
  } else {
    wk_crs_equal_generic(x, y)
  }
}

#' @rdname wk_crs_equal
#' @export
wk_crs_equal_generic <- function(x, y, ...) {
  UseMethod("wk_crs_equal_generic")
}

#' @export
wk_crs_equal_generic.default <- function(x, y, ...) {
  identical(x, y)
}

#' @export
wk_crs_equal_generic.integer <- function(x, y, ...) {
  isTRUE(x == y)
}

#' @export
wk_crs_equal_generic.double <- function(x, y, ...) {
  isTRUE(x == y)
}


#' Set and get vector geodesic edge interpolation
#'
#' @param x An R object that contains edges
#' @param geodesic `TRUE` if edges must be interpolated as geodesics when
#'   coordinates are spherical, `FALSE` otherwise.
#' @param value See `geodesic`.
#'
#' @return `TRUE` if edges must be interpolated as geodesics when
#'   coordinates are spherical, `FALSE` otherwise.
#' @export
#'
wk_is_geodesic <- function(x) {
  UseMethod("wk_is_geodesic")
}

#' @rdname wk_is_geodesic
#' @export
wk_set_geodesic <- function(x, geodesic) {
  UseMethod("wk_set_geodesic")
}

#' @rdname wk_is_geodesic
#' @export
`wk_is_geodesic<-` <- function(x, value) {
 wk_set_geodesic(x, value)
}

#' @rdname wk_is_geodesic
#' @export
wk_geodesic_inherit <- function() {
  NA
}

#' @export
wk_is_geodesic.default <- function(x) {
  FALSE
}

#' @export
wk_is_geodesic.wk_wkb <- function(x) {
  attr(x, "geodesic", exact = TRUE) %||% FALSE
}

#' @export
wk_is_geodesic.wk_wkt <- function(x) {
  attr(x, "geodesic", exact = TRUE) %||% FALSE
}

#' @export
wk_set_geodesic.default <- function(x, geodesic) {
  if (geodesic) {
    warning(
      sprintf(
        "Ignoring wk_set_geodesic(x, TRUE) for object of class '%s'",
        class(x)[1]
      )
    )
  }

  x
}

#' @export
wk_set_geodesic.wk_wkb <- function(x, geodesic) {
  attr(x, "geodesic") <- geodesic_attr(geodesic)
  x
}

#' @export
wk_set_geodesic.wk_wkt <- function(x, geodesic) {
  attr(x, "geodesic") <- geodesic_attr(geodesic)
  x
}

geodesic_attr <- function(geodesic) {
  if (!is.logical(geodesic) || (length(geodesic) != 1L)) {
    stop("`geodesic` must be TRUE, FALSE, or NA", call. = FALSE)
  }

  if (identical(geodesic, FALSE)) {
    NULL
  } else {
    geodesic
  }
}

#' CRS object generic methods
#'
#' @param crs An arbitrary R object
#' @param verbose Use `TRUE` to request a more verbose version of the
#'   PROJ definition (e.g., PROJJSON). The default of `FALSE` should return
#'   the most compact version that completely describes the CRS. An
#'   authority:code string (e.g., "OGC:CRS84") is the recommended way
#'   to represent a CRS when `verbose` is `FALSE`, if possible, falling
#'   back to the most recent version of WKT2 or PROJJSON.
#' @param proj_version A [package_version()] of the PROJ version, or
#'   `NULL` if the PROJ version is unknown.
#'
#' @return
#'   - `wk_crs_proj_definition()` Returns a string used to represent the
#'     CRS in PROJ. For recent PROJ version you'll want to return PROJJSON;
#'     however you should check `proj_version` if you want this to work with
#'     older versions of PROJ.
#'   - `wk_crs_projjson()` Returns a PROJJSON string or NA_character_ if this
#'     representation is unknown or can't be calculated.
#' @export
#'
#' @examples
#' wk_crs_proj_definition("EPSG:4326")
#'
wk_crs_proj_definition <- function(crs, proj_version = NULL, verbose = FALSE) {
  UseMethod("wk_crs_proj_definition")
}

#' @rdname wk_crs_proj_definition
#' @export
wk_crs_projjson <- function(crs) {
  UseMethod("wk_crs_projjson")
}

#' @export
wk_crs_projjson.default <- function(crs) {
  maybe_auth_code_or_json <- wk_crs_proj_definition(crs, verbose = FALSE)

  # check for most probably JSON
  if (isTRUE(grepl("^\\{.*?\\}$", maybe_auth_code_or_json))) {
    return(maybe_auth_code_or_json)
  }

  # look up by auth_name / code
  split <- strsplit(maybe_auth_code_or_json, ":", fixed = TRUE)[[1]]
  query <- new_data_frame(list(auth_name = split[1], code = split[2]))
  merge(query, wk::wk_proj_crs_json, all.x = TRUE)$projjson
}

#' @rdname wk_crs_proj_definition
#' @export
wk_crs_proj_definition.NULL <- function(crs, proj_version = NULL, verbose = FALSE) {
  NA_character_
}

#' @rdname wk_crs_proj_definition
#' @export
wk_crs_proj_definition.wk_crs_inherit <- function(crs, proj_version = NULL,
                                                  verbose = FALSE) {
  NA_character_
}

#' @rdname wk_crs_proj_definition
#' @export
wk_crs_proj_definition.character <- function(crs, proj_version = NULL, verbose = FALSE) {
  stopifnot(length(crs) == 1)
  crs
}

#' @rdname wk_crs_proj_definition
#' @export
wk_crs_proj_definition.double <- function(crs, proj_version = NULL, verbose = FALSE) {
  stopifnot(length(crs) == 1)
  if (is.na(crs)) wk_crs_proj_definition(NULL) else paste0("EPSG:", crs)
}

#' @rdname wk_crs_proj_definition
#' @export
wk_crs_proj_definition.integer <- function(crs, proj_version = NULL, verbose = FALSE) {
  stopifnot(length(crs) == 1)
  if (is.na(crs)) wk_crs_proj_definition(NULL) else paste0("EPSG:", crs)
}

#' Special CRS values
#'
#' The CRS handling in the wk package requires two sentinel CRS values.
#' The first, [wk_crs_inherit()], signals that the vector should inherit
#' a CRS of another vector if combined. This is useful for empty, `NULL`,
#' and/or zero-length geometries. The second, [wk_crs_auto()], is used
#' as the default argument of `crs` for constructors so that zero-length
#' geometries are assigned a CRS of `wk_crs_inherit()` by default.
#'
#' @param x A raw input to a construuctor whose length and crs attributte
#'   is used to determine the default CRS returned by [wk_crs_auto()].
#' @param crs A value for the coordinate reference system supplied by
#'   the user.
#'
#' @export
#'
#' @examples
#' wk_crs_auto_value(list(), wk_crs_auto())
#' wk_crs_auto_value(list(), 1234)
#' wk_crs_auto_value(list(NULL), wk_crs_auto())
#'
wk_crs_inherit <- function() {
  structure(list(), class = "wk_crs_inherit")
}

#' @rdname wk_crs_inherit
#' @export
wk_crs_longlat <- function(crs = NULL) {
  if (inherits(crs, "wk_crs_inherit") || is.null(crs) || identical(crs, "WGS84")) {
    return("OGC:CRS84")
  }

  crs_proj <- wk_crs_proj_definition(crs)
  switch(
    crs_proj,
    "OGC:CRS84" = ,
    "EPSG:4326" = ,
    "WGS84" = "OGC:CRS84",
    "OGC:CRS27" = ,
    "EPSG:4267" = ,
    "NAD27" = "OGC:CRS27",
    "OGC:CRS83" = ,
    "EPSG:4269" = ,
    "NAD83" = "OGC:CRS83",
    stop(
      sprintf(
        "Can't guess authority-compliant long/lat definition from CRS '%s'",
        format(crs_proj)
      )
    )
  )
}

#' @rdname wk_crs_inherit
#' @export
wk_crs_auto <- function() {
  structure(list(), class = "wk_crs_auto")
}

#' @rdname wk_crs_inherit
#' @export
wk_crs_auto_value <- function(x, crs) {
  if (inherits(crs, "wk_crs_auto")) {
    if (length(x) == 0) wk_crs_inherit() else attr(x, "crs", exact = TRUE)
  } else {
    crs
  }
}

#' @export
format.wk_crs_inherit <- function(x, ...) {
  format("wk_crs_inherit()", ...)
}

#' @export
print.wk_crs_inherit <- function(x, ...) {
  cat("<wk_crs_inherit>\n")
}

wk_crs_format <- function(x, ...) {
  tryCatch(
    wk_crs_proj_definition(x, verbose = FALSE),
    error = function(e) format(x, ...)
  )
}

#' Create lines, polygons, and collections
#'
#' @inheritParams wk_handle
#' @param feature_id An identifier where changes in sequential
#'   values indicate a new feature. This is recycled silently
#'   as needed.
#' @param ring_id An identifier where changes in sequential
#'   values indicate a new ring. Rings are automatically
#'   closed. This is recycled silently as needed.
#' @param geometry_type The collection type to create.
#' @param geodesic Use `TRUE` or `FALSE` to explicitly force
#'   the geodesic-ness of the output.
#'
#' @return An object of the same class as `handleable` with
#'   whose coordinates have been assembled into the given
#'   type.
#' @export
#'
#' @examples
#' wk_linestring(xy(c(1, 1), c(2, 3)))
#' wk_polygon(xy(c(0, 1, 0), c(0, 0, 1)))
#' wk_collection(xy(c(1, 1), c(2, 3)))
#'
wk_linestring <- function(handleable, feature_id = 1L, ..., geodesic = NULL) {
  writer <- wk_writer(handleable, generic = TRUE)
  result <- wk_handle(handleable, wk_linestring_filter(writer, as.integer(feature_id)), ...)

  wk_crs(result) <- wk_crs(handleable)
  wk_is_geodesic(result) <- geodesic %||% wk_is_geodesic(handleable)

  result
}

#' @rdname wk_linestring
#' @export
wk_polygon <- function(handleable, feature_id = 1L, ring_id = 1L, ..., geodesic = NULL) {
  writer <- wk_writer(handleable, generic = TRUE)
  result <- wk_handle(
    handleable,
    wk_polygon_filter(
      writer,
      as.integer(feature_id),
      as.integer(ring_id)
    ),
    ...
  )

  wk_crs(result) <- wk_crs(handleable)
  wk_is_geodesic(result) <- geodesic %||% wk_is_geodesic(handleable)

  result
}

#' @rdname wk_linestring
#' @export
wk_collection <- function(handleable, geometry_type = wk_geometry_type("geometrycollection"),
                               feature_id = 1L, ...) {
  writer <- wk_writer(handleable, generic = TRUE)
  result <- wk_handle(
    handleable,
    wk_collection_filter(
      writer,
      as.integer(geometry_type)[1],
      as.integer(feature_id)
    ),
    ...
  )

  result <- wk_set_crs(result, wk_crs(handleable))
  wk_set_geodesic(result, wk_is_geodesic(handleable))
}

#' @rdname wk_linestring
#' @export
wk_linestring_filter <- function(handler, feature_id = 1L) {
  new_wk_handler(
    .Call(wk_c_linestring_filter_new, as_wk_handler(handler), feature_id),
    "wk_linestring_filter"
  )
}

#' @rdname wk_linestring
#' @export
wk_polygon_filter <- function(handler, feature_id = 1L, ring_id = 1L) {
  new_wk_handler(
    .Call(wk_c_polygon_filter_new, handler, feature_id, ring_id),
    "wk_polygon_filter"
  )
}

#' @rdname wk_linestring
#' @export
wk_collection_filter <- function(handler, geometry_type = wk_geometry_type("geometrycollection"),
                                 feature_id = 1L) {
  new_wk_handler(
    .Call(wk_c_collection_filter_new, as_wk_handler(handler), geometry_type, feature_id),
    "wk_collection_filter"
  )
}

#' Vctrs methods
#'
#' @param x,y,to,... See [vctrs::vec_cast()] and [vctrs::vec_ptype2()].
#' @rdname vctrs-methods
#' @name vctrs-methods
#'
NULL

# wkb() --------

vec_proxy.wk_wkb <- function(x, ...) {
  unclass(x)
}

vec_proxy_equal.wk_wkb <- function(x, ...) {
  wkb_to_hex(x)
}

vec_restore.wk_wkb <- function(x, to, ...) {
  crs_out <- attr(to, "crs", exact = TRUE) %||% attr(x, "crs", exact = TRUE)
  geodesic_out <- attr(to, "geodesic", exact = TRUE) %||% attr(x, "geodesic", exact = TRUE)
  attr(x, "crs") <- NULL
  attr(x, "geodesic") <- NULL
  new_wk_wkb(x, crs = crs_out, geodesic = geodesic_out)
}

#' @rdname vctrs-methods
#' @export vec_cast.wk_wkb
vec_cast.wk_wkb <- function(x, to, ...) {
  UseMethod("vec_cast.wk_wkb") # nocov
}

#' @method vec_cast.wk_wkb default
#' @export
vec_cast.wk_wkb.default <- function(x, to, ...) {
  vctrs::vec_default_cast(x, to) # nocov
}

#' @method vec_cast.wk_wkb wk_wkb
#' @export
vec_cast.wk_wkb.wk_wkb <- function(x, to, ...) {
  wk_crs_output(x, to)
  wk_is_geodesic_output(x, to)
  x
}

#' @method vec_cast.wk_wkb wk_wkt
#' @export
vec_cast.wk_wkb.wk_wkt <- function(x, to, ...) {
  wk_crs_output(x, to)
  wk_is_geodesic_output(x, to)
  as_wkb(x)
}

#' @method vec_cast.wk_wkb wk_xy
#' @export
vec_cast.wk_wkb.wk_xy <- function(x, to, ...) {
  wk_translate(x, to)
}

#' @method vec_cast.wk_wkb wk_xyz
#' @export
vec_cast.wk_wkb.wk_xyz <- function(x, to, ...) {
  wk_translate(x, to)
}

#' @method vec_cast.wk_wkb wk_xym
#' @export
vec_cast.wk_wkb.wk_xym <- function(x, to, ...) {
  wk_translate(x, to)
}

#' @method vec_cast.wk_wkb wk_xyzm
#' @export
vec_cast.wk_wkb.wk_xyzm <- function(x, to, ...) {
  wk_translate(x, to)
}

#' @method vec_cast.wk_wkb wk_rct
#' @export
vec_cast.wk_wkb.wk_rct <- function(x, to, ...) {
  wk_translate(x, to)
}

#' @method vec_cast.wk_wkb wk_crc
#' @export
vec_cast.wk_wkb.wk_crc <- function(x, to, ...) {
  wk_crs_output(x, to)
  as_wkb(x)
}

#' @rdname vctrs-methods
#' @export vec_ptype2.wk_wkb
vec_ptype2.wk_wkb <- function(x, y, ...) {
  UseMethod("vec_ptype2.wk_wkb", y) # nocov
}

#' @method vec_ptype2.wk_wkb default
#' @export
vec_ptype2.wk_wkb.default <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  vctrs::vec_default_ptype2(x, y, x_arg = x_arg, y_arg = y_arg) # nocov
}

#' @method vec_ptype2.wk_wkb wk_wkb
#' @export
vec_ptype2.wk_wkb.wk_wkb <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_wkb(crs = wk_crs_output(x, y), geodesic = geodesic_attr(wk_is_geodesic_output(x, y)))
}

#' @method vec_ptype2.wk_wkb wk_wkt
#' @export
vec_ptype2.wk_wkb.wk_wkt <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_wkt(crs = wk_crs_output(x, y), geodesic = geodesic_attr(wk_is_geodesic_output(x, y)))
}

#' @method vec_ptype2.wk_wkb wk_xy
#' @export
vec_ptype2.wk_wkb.wk_xy <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_wkb(crs = wk_crs_output(x, y), geodesic = attr(x, "geodesic", exact = TRUE))
}

#' @method vec_ptype2.wk_wkb wk_xyz
#' @export
vec_ptype2.wk_wkb.wk_xyz <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_wkb(crs = wk_crs_output(x, y), geodesic = attr(x, "geodesic", exact = TRUE))
}

#' @method vec_ptype2.wk_wkb wk_xym
#' @export
vec_ptype2.wk_wkb.wk_xym <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_wkb(crs = wk_crs_output(x, y), geodesic = attr(x, "geodesic", exact = TRUE))
}

#' @method vec_ptype2.wk_wkb wk_xyzm
#' @export
vec_ptype2.wk_wkb.wk_xyzm <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_wkb(crs = wk_crs_output(x, y), geodesic = attr(x, "geodesic", exact = TRUE))
}

#' @method vec_ptype2.wk_wkb wk_rct
#' @export
vec_ptype2.wk_wkb.wk_rct <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_wkb(crs = wk_crs_output(x, y), geodesic = geodesic_attr(wk_is_geodesic_output(x, y)))
}

#' @method vec_ptype2.wk_wkb wk_crc
#' @export
vec_ptype2.wk_wkb.wk_crc <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_wkb(crs = wk_crs_output(x, y), geodesic = attr(x, "geodesic", exact = TRUE))
}

# wkt() --------

vec_proxy.wk_wkt <- function(x, ...) {
  unclass(x)
}

vec_restore.wk_wkt <- function(x, to, ...) {
  crs_out <- attr(to, "crs", exact = TRUE) %||% attr(x, "crs", exact = TRUE)
  geodesic_out <- attr(to, "geodesic", exact = TRUE) %||% attr(x, "geodesic", exact = TRUE)
  attr(x, "crs") <- NULL
  attr(x, "geodesic") <- NULL
  new_wk_wkt(x, crs = crs_out, geodesic = geodesic_out)
}

#' @rdname vctrs-methods
#' @export vec_cast.wk_wkt
vec_cast.wk_wkt <- function(x, to, ...) {
  UseMethod("vec_cast.wk_wkt") # nocov
}

#' @method vec_cast.wk_wkt default
#' @export
vec_cast.wk_wkt.default <- function(x, to, ...) {
  vctrs::vec_default_cast(x, to) # nocov
}

#' @method vec_cast.wk_wkt wk_wkt
#' @export
vec_cast.wk_wkt.wk_wkt <- function(x, to, ...) {
  wk_crs_output(x, to)
  wk_is_geodesic_output(x, to)
  x
}

#' @method vec_cast.wk_wkt wk_wkb
#' @export
vec_cast.wk_wkt.wk_wkb <- function(x, to, ...) {
  wk_crs_output(x, to)
  wk_is_geodesic_output(x, to)
  as_wkt(x)
}

#' @method vec_cast.wk_wkt wk_xy
#' @export
vec_cast.wk_wkt.wk_xy <- function(x, to, ...) {
  wk_translate(x, to)
}

#' @method vec_cast.wk_wkt wk_xyz
#' @export
vec_cast.wk_wkt.wk_xyz <- function(x, to, ...) {
  wk_translate(x, to)
}

#' @method vec_cast.wk_wkt wk_xym
#' @export
vec_cast.wk_wkt.wk_xym <- function(x, to, ...) {
  wk_translate(x, to)
}

#' @method vec_cast.wk_wkt wk_xyzm
#' @export
vec_cast.wk_wkt.wk_xyzm <- function(x, to, ...) {
  wk_translate(x, to)
}

#' @method vec_cast.wk_wkt wk_rct
#' @export
vec_cast.wk_wkt.wk_rct <- function(x, to, ...) {
  wk_translate(x, to)
}

#' @method vec_cast.wk_wkt wk_crc
#' @export
vec_cast.wk_wkt.wk_crc <- function(x, to, ...) {
  wk_translate(x, to)
}

#' @rdname vctrs-methods
#' @export vec_ptype2.wk_wkt
vec_ptype2.wk_wkt <- function(x, y, ...) {
  UseMethod("vec_ptype2.wk_wkt", y) # nocov
}

#' @method vec_ptype2.wk_wkt default
#' @export
vec_ptype2.wk_wkt.default <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  vctrs::vec_default_ptype2(x, y, x_arg = x_arg, y_arg = y_arg) # nocov
}

#' @method vec_ptype2.wk_wkt wk_wkt
#' @export
vec_ptype2.wk_wkt.wk_wkt <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_wkt(crs = wk_crs_output(x, y), geodesic = geodesic_attr(wk_is_geodesic_output(x, y)))
}

#' @method vec_ptype2.wk_wkt wk_wkb
#' @export
vec_ptype2.wk_wkt.wk_wkb <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_wkt(crs = wk_crs_output(x, y), geodesic = geodesic_attr(wk_is_geodesic_output(x, y)))
}

#' @method vec_ptype2.wk_wkt wk_xy
#' @export
vec_ptype2.wk_wkt.wk_xy <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_wkt(crs = wk_crs_output(x, y), geodesic = attr(x, "geodesic", exact = TRUE))
}

#' @method vec_ptype2.wk_wkt wk_xyz
#' @export
vec_ptype2.wk_wkt.wk_xyz <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_wkt(crs = wk_crs_output(x, y), geodesic = attr(x, "geodesic", exact = TRUE))
}

#' @method vec_ptype2.wk_wkt wk_xym
#' @export
vec_ptype2.wk_wkt.wk_xym <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_wkt(crs = wk_crs_output(x, y), geodesic = attr(x, "geodesic", exact = TRUE))
}

#' @method vec_ptype2.wk_wkt wk_xyzm
#' @export
vec_ptype2.wk_wkt.wk_xyzm <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_wkt(crs = wk_crs_output(x, y), geodesic = attr(x, "geodesic", exact = TRUE))
}

#' @method vec_ptype2.wk_wkt wk_rct
#' @export
vec_ptype2.wk_wkt.wk_rct <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  wk_is_geodesic_output(x, y)
  new_wk_wkt(crs = wk_crs_output(x, y))
}

#' @method vec_ptype2.wk_wkt wk_crc
#' @export
vec_ptype2.wk_wkt.wk_crc <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_wkt(crs = wk_crs_output(x, y), geodesic = attr(x, "geodesic", exact = TRUE))
}

# xy() --------

vec_proxy.wk_xy <- function(x, ...) {
  new_data_frame(unclass(x))
}

vec_restore.wk_xy <- function(x, to, ...) {
  crs_out <- attr(to, "crs", exact = TRUE) %||% attr(x, "crs", exact = TRUE)
  attr(x, "crs") <- NULL
  attr(x, "row.names") <- NULL
  new_wk_xy(x, crs = crs_out)
}

#' @rdname vctrs-methods
#' @export vec_cast.wk_xy
vec_cast.wk_xy <- function(x, to, ...) {
  UseMethod("vec_cast.wk_xy") # nocov
}

#' @method vec_cast.wk_xy default
#' @export
vec_cast.wk_xy.default <- function(x, to, ...) {
  vctrs::vec_default_cast(x, to) # nocov
}

#' @method vec_cast.wk_xy wk_xy
#' @export
vec_cast.wk_xy.wk_xy <- function(x, to, ...) {
  wk_crs_output(x, to)
  x
}

#' @method vec_cast.wk_xy wk_wkb
#' @export
vec_cast.wk_xy.wk_wkb <- function(x, to, ...) {
  wk_crs_output(x, to)
  as_xy(x)
}

#' @method vec_cast.wk_xy wk_wkt
#' @export
vec_cast.wk_xy.wk_wkt <- function(x, to, ...) {
  wk_crs_output(x, to)
  as_xy(x)
}

#' @method vec_cast.wk_xy wk_xyz
#' @export
vec_cast.wk_xy.wk_xyz <- function(x, to, ...) {
  wk_crs_output(x, to)
  vctrs::maybe_lossy_cast(
    as_xy(x, dims = c("x", "y")),
    x, to,
    !is.na(unclass(x)$z)
  )
}

#' @method vec_cast.wk_xy wk_xym
#' @export
vec_cast.wk_xy.wk_xym <- function(x, to, ...) {
  wk_crs_output(x, to)
  vctrs::maybe_lossy_cast(
    as_xy(x, dims = c("x", "y")),
    x, to,
    !is.na(unclass(x)$m)
  )
}

#' @method vec_cast.wk_xy wk_xyzm
#' @export
vec_cast.wk_xy.wk_xyzm <- function(x, to, ...) {
  wk_crs_output(x, to)
  vctrs::maybe_lossy_cast(
    as_xy(x, dims = c("x", "y")),
    x, to,
    !is.na(unclass(x)$z) & !is.na(unclass(x)$m)
  )
}

#' @rdname vctrs-methods
#' @export vec_ptype2.wk_xy
vec_ptype2.wk_xy <- function(x, y, ...) {
  UseMethod("vec_ptype2.wk_xy", y) # nocov
}

#' @method vec_ptype2.wk_xy wk_xy
#' @export
vec_ptype2.wk_xy.wk_xy <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_xy(crs = wk_crs_output(x, y))
}

#' @method vec_ptype2.wk_xy wk_wkb
#' @export
vec_ptype2.wk_xy.wk_wkb <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_wkb(crs = wk_crs_output(x, y), geodesic = attr(y, "geodesic", exact = TRUE))
}

#' @method vec_ptype2.wk_xy wk_wkt
#' @export
vec_ptype2.wk_xy.wk_wkt <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_wkt(crs = wk_crs_output(x, y), geodesic = attr(y, "geodesic", exact = TRUE))
}

#' @method vec_ptype2.wk_xy wk_xyz
#' @export
vec_ptype2.wk_xy.wk_xyz <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_xyz(crs = wk_crs_output(x, y))
}

#' @method vec_ptype2.wk_xy wk_xym
#' @export
vec_ptype2.wk_xy.wk_xym <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_xym(crs = wk_crs_output(x, y))
}

#' @method vec_ptype2.wk_xy wk_xyzm
#' @export
vec_ptype2.wk_xy.wk_xyzm <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_xyzm(crs = wk_crs_output(x, y))
}

#' @method vec_ptype2.wk_xy wk_rct
#' @export
vec_ptype2.wk_xy.wk_rct <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_wkb(crs = wk_crs_output(x, y))
}

#' @method vec_ptype2.wk_xy wk_crc
#' @export
vec_ptype2.wk_xy.wk_crc <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_wkb(crs = wk_crs_output(x, y))
}

# xyz() --------

vec_proxy.wk_xyz <- function(x, ...) {
  new_data_frame(unclass(x))
}

vec_restore.wk_xyz <- function(x, to, ...) {
  crs_out <- attr(to, "crs", exact = TRUE) %||% attr(x, "crs", exact = TRUE)
  attr(x, "crs") <- NULL
  attr(x, "row.names") <- NULL
  new_wk_xyz(x, crs = crs_out)
}

#' @rdname vctrs-methods
#' @export vec_cast.wk_xyz
vec_cast.wk_xyz <- function(x, to, ...) {
  UseMethod("vec_cast.wk_xyz") # nocov
}

#' @method vec_cast.wk_xyz default
#' @export
vec_cast.wk_xyz.default <- function(x, to, ...) {
  vctrs::vec_default_cast(x, to) # nocov
}

#' @method vec_cast.wk_xyz wk_xyz
#' @export
vec_cast.wk_xyz.wk_xyz <- function(x, to, ...) {
  wk_crs_output(x, to)
  x
}

#' @method vec_cast.wk_xyz wk_wkb
#' @export
vec_cast.wk_xyz.wk_wkb <- function(x, to, ...) {
  wk_crs_output(x, to)
  as_xy(x, dims = c("x", "y", "z"))
}

#' @method vec_cast.wk_xyz wk_wkt
#' @export
vec_cast.wk_xyz.wk_wkt <- function(x, to, ...) {
  wk_crs_output(x, to)
  as_xy(x, dims = c("x", "y", "z"))
}

#' @method vec_cast.wk_xyz wk_xy
#' @export
vec_cast.wk_xyz.wk_xy <- function(x, to, ...) {
  wk_crs_output(x, to)
  as_xy(x, dims = c("x", "y", "z"))
}

#' @method vec_cast.wk_xyz wk_xym
#' @export
vec_cast.wk_xyz.wk_xym <- function(x, to, ...) {
  wk_crs_output(x, to)
  vctrs::maybe_lossy_cast(
    as_xy(x, dims = c("x", "y", "z")),
    x, to,
    !is.na(unclass(x)$m)
  )
}

#' @method vec_cast.wk_xyz wk_xyzm
#' @export
vec_cast.wk_xyz.wk_xyzm <- function(x, to, ...) {
  wk_crs_output(x, to)
  vctrs::maybe_lossy_cast(
    as_xy(x, dims = c("x", "y", "z")),
    x, to,
    !is.na(unclass(x)$m)
  )
}

#' @rdname vctrs-methods
#' @export vec_ptype2.wk_xyz
vec_ptype2.wk_xyz <- function(x, y, ...) {
  UseMethod("vec_ptype2.wk_xyz", y) # nocov
}

#' @method vec_ptype2.wk_xyz wk_xyz
#' @export
vec_ptype2.wk_xyz.wk_xyz <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_xyz(crs = wk_crs_output(x, y))
}

#' @method vec_ptype2.wk_xyz wk_wkb
#' @export
vec_ptype2.wk_xyz.wk_wkb <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_wkb(crs = wk_crs_output(x, y), geodesic = attr(y, "geodesic", exact = TRUE))
}

#' @method vec_ptype2.wk_xyz wk_wkt
#' @export
vec_ptype2.wk_xyz.wk_wkt <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_wkt(crs = wk_crs_output(x, y), geodesic = attr(y, "geodesic", exact = TRUE))
}

#' @method vec_ptype2.wk_xyz wk_xy
#' @export
vec_ptype2.wk_xyz.wk_xy <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_xyz(crs = wk_crs_output(x, y))
}

#' @method vec_ptype2.wk_xyz wk_xym
#' @export
vec_ptype2.wk_xyz.wk_xym <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_xyzm(crs = wk_crs_output(x, y))
}

#' @method vec_ptype2.wk_xyz wk_xyzm
#' @export
vec_ptype2.wk_xyz.wk_xyzm <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_xyzm(crs = wk_crs_output(x, y))
}

#' @method vec_ptype2.wk_xyz wk_rct
#' @export
vec_ptype2.wk_xyz.wk_rct <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_wkb(crs = wk_crs_output(x, y))
}

#' @method vec_ptype2.wk_xyz wk_crc
#' @export
vec_ptype2.wk_xyz.wk_crc <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_wkb(crs = wk_crs_output(x, y))
}

# xym() --------

vec_proxy.wk_xym <- function(x, ...) {
  new_data_frame(unclass(x))
}

vec_restore.wk_xym <- function(x, to, ...) {
  crs_out <- attr(to, "crs", exact = TRUE) %||% attr(x, "crs", exact = TRUE)
  attr(x, "crs") <- NULL
  attr(x, "row.names") <- NULL
  new_wk_xym(x, crs = crs_out)
}

#' @rdname vctrs-methods
#' @export vec_cast.wk_xym
vec_cast.wk_xym <- function(x, to, ...) {
  UseMethod("vec_cast.wk_xym") # nocov
}

#' @method vec_cast.wk_xym default
#' @export
vec_cast.wk_xym.default <- function(x, to, ...) {
  vctrs::vec_default_cast(x, to) # nocov
}

#' @method vec_cast.wk_xym wk_xym
#' @export
vec_cast.wk_xym.wk_xym <- function(x, to, ...) {
  wk_crs_output(x, to)
  x
}

#' @method vec_cast.wk_xym wk_wkb
#' @export
vec_cast.wk_xym.wk_wkb <- function(x, to, ...) {
  wk_crs_output(x, to)
  as_xy(x, dims = c("x", "y", "m"))
}

#' @method vec_cast.wk_xym wk_wkt
#' @export
vec_cast.wk_xym.wk_wkt <- function(x, to, ...) {
  wk_crs_output(x, to)
  as_xy(x, dims = c("x", "y", "m"))
}

#' @method vec_cast.wk_xym wk_xy
#' @export
vec_cast.wk_xym.wk_xy <- function(x, to, ...) {
  wk_crs_output(x, to)
  as_xy(x, dims = c("x", "y", "m"))
}

#' @method vec_cast.wk_xym wk_xyz
#' @export
vec_cast.wk_xym.wk_xyz <- function(x, to, ...) {
  wk_crs_output(x, to)
  vctrs::maybe_lossy_cast(
    as_xy(x, dims = c("x", "y", "m")),
    x, to,
    !is.na(unclass(x)$z)
  )
}

#' @method vec_cast.wk_xym wk_xyzm
#' @export
vec_cast.wk_xym.wk_xyzm <- function(x, to, ...) {
  wk_crs_output(x, to)
  vctrs::maybe_lossy_cast(
    as_xy(x, dims = c("x", "y", "m")),
    x, to,
    !is.na(unclass(x)$z)
  )
}

#' @rdname vctrs-methods
#' @export vec_ptype2.wk_xym
vec_ptype2.wk_xym <- function(x, y, ...) {
  UseMethod("vec_ptype2.wk_xym", y) # nocov
}

#' @method vec_ptype2.wk_xym wk_xym
#' @export
vec_ptype2.wk_xym.wk_xym <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_xym(crs = wk_crs_output(x, y))
}

#' @method vec_ptype2.wk_xym wk_wkb
#' @export
vec_ptype2.wk_xym.wk_wkb <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_wkb(crs = wk_crs_output(x, y), geodesic = attr(y, "geodesic", exact = TRUE))
}

#' @method vec_ptype2.wk_xym wk_wkt
#' @export
vec_ptype2.wk_xym.wk_wkt <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_wkt(crs = wk_crs_output(x, y), geodesic = attr(y, "geodesic", exact = TRUE))
}

#' @method vec_ptype2.wk_xym wk_xy
#' @export
vec_ptype2.wk_xym.wk_xy <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_xym(crs = wk_crs_output(x, y))
}

#' @method vec_ptype2.wk_xym wk_xyz
#' @export
vec_ptype2.wk_xym.wk_xyz <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_xyzm(crs = wk_crs_output(x, y))
}

#' @method vec_ptype2.wk_xym wk_xyzm
#' @export
vec_ptype2.wk_xym.wk_xyzm <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_xyzm(crs = wk_crs_output(x, y))
}

#' @method vec_ptype2.wk_xym wk_rct
#' @export
vec_ptype2.wk_xym.wk_rct <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_wkb(crs = wk_crs_output(x, y))
}

#' @method vec_ptype2.wk_xym wk_crc
#' @export
vec_ptype2.wk_xym.wk_crc <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_wkb(crs = wk_crs_output(x, y))
}

# xyzm() --------

vec_proxy.wk_xyzm <- function(x, ...) {
  new_data_frame(unclass(x))
}

vec_restore.wk_xyzm <- function(x, to, ...) {
  crs_out <- attr(to, "crs", exact = TRUE) %||% attr(x, "crs", exact = TRUE)
  attr(x, "crs") <- NULL
  attr(x, "row.names") <- NULL
  new_wk_xyzm(x, crs = crs_out)
}

#' @rdname vctrs-methods
#' @export vec_cast.wk_xyzm
vec_cast.wk_xyzm <- function(x, to, ...) {
  UseMethod("vec_cast.wk_xyzm") # nocov
}

#' @method vec_cast.wk_xyzm default
#' @export
vec_cast.wk_xyzm.default <- function(x, to, ...) {
  vctrs::vec_default_cast(x, to) # nocov
}

#' @method vec_cast.wk_xyzm wk_xyzm
#' @export
vec_cast.wk_xyzm.wk_xyzm <- function(x, to, ...) {
  wk_crs_output(x, to)
  x
}

#' @method vec_cast.wk_xyzm wk_wkb
#' @export
vec_cast.wk_xyzm.wk_wkb <- function(x, to, ...) {
  wk_crs_output(x, to)
  as_xy(x, dims = c("x", "y", "z", "m"))
}

#' @method vec_cast.wk_xyzm wk_wkt
#' @export
vec_cast.wk_xyzm.wk_wkt <- function(x, to, ...) {
  wk_crs_output(x, to)
  as_xy(x, dims = c("x", "y", "z", "m"))
}

#' @method vec_cast.wk_xyzm wk_xy
#' @export
vec_cast.wk_xyzm.wk_xy <- function(x, to, ...) {
  wk_crs_output(x, to)
  as_xy(x, dims = c("x", "y", "z", "m"))
}

#' @method vec_cast.wk_xyzm wk_xyz
#' @export
vec_cast.wk_xyzm.wk_xyz <- function(x, to, ...) {
  wk_crs_output(x, to)
  as_xy(x, dims = c("x", "y", "z", "m"))
}

#' @method vec_cast.wk_xyzm wk_xym
#' @export
vec_cast.wk_xyzm.wk_xym <- function(x, to, ...) {
  wk_crs_output(x, to)
  as_xy(x, dims = c("x", "y", "z", "m"))
}

#' @rdname vctrs-methods
#' @export vec_ptype2.wk_xyzm
vec_ptype2.wk_xyzm <- function(x, y, ...) {
  UseMethod("vec_ptype2.wk_xyzm", y) # nocov
}

#' @method vec_ptype2.wk_xyzm wk_xyzm
#' @export
vec_ptype2.wk_xyzm.wk_xyzm <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_xyzm(crs = wk_crs_output(x, y))
}

#' @method vec_ptype2.wk_xyzm wk_wkb
#' @export
vec_ptype2.wk_xyzm.wk_wkb <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_wkb(crs = wk_crs_output(x, y), geodesic = attr(y, "geodesic", exact = TRUE))
}

#' @method vec_ptype2.wk_xyzm wk_wkt
#' @export
vec_ptype2.wk_xyzm.wk_wkt <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_wkt(crs = wk_crs_output(x, y), geodesic = attr(y, "geodesic", exact = TRUE))
}

#' @method vec_ptype2.wk_xyzm wk_xy
#' @export
vec_ptype2.wk_xyzm.wk_xy <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_xyzm(crs = wk_crs_output(x, y))
}

#' @method vec_ptype2.wk_xyzm wk_xyz
#' @export
vec_ptype2.wk_xyzm.wk_xyz <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_xyzm(crs = wk_crs_output(x, y))
}

#' @method vec_ptype2.wk_xyzm wk_xym
#' @export
vec_ptype2.wk_xyzm.wk_xym <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_xyzm(crs = wk_crs_output(x, y))
}

#' @method vec_ptype2.wk_xyzm wk_rct
#' @export
vec_ptype2.wk_xyzm.wk_rct <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_wkb(crs = wk_crs_output(x, y))
}

#' @method vec_ptype2.wk_xyzm wk_crc
#' @export
vec_ptype2.wk_xyzm.wk_crc <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_wkb(crs = wk_crs_output(x, y))
}

# rct() --------

vec_proxy.wk_rct <- function(x, ...) {
  new_data_frame(unclass(x))
}

vec_restore.wk_rct <- function(x, to, ...) {
  crs_out <- attr(to, "crs", exact = TRUE) %||% attr(x, "crs", exact = TRUE)
  attr(x, "crs") <- NULL
  attr(x, "row.names") <- NULL
  new_wk_rct(x, crs = crs_out)
}

#' @rdname vctrs-methods
#' @export vec_cast.wk_rct
vec_cast.wk_rct <- function(x, to, ...) {
  UseMethod("vec_cast.wk_rct") # nocov
}

#' @method vec_cast.wk_rct default
#' @export
vec_cast.wk_rct.default <- function(x, to, ...) {
  vctrs::vec_default_cast(x, to) # nocov
}

#' @rdname vctrs-methods
#' @export vec_ptype2.wk_rct
vec_ptype2.wk_rct <- function(x, y, ...) {
  UseMethod("vec_ptype2.wk_rct", y) # nocov
}

#' @method vec_ptype2.wk_rct wk_rct
#' @export
vec_ptype2.wk_rct.wk_rct <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_rct(crs = wk_crs_output(x, y))
}

#' @method vec_ptype2.wk_rct wk_wkb
#' @export
vec_ptype2.wk_rct.wk_wkb <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_wkb(crs = wk_crs_output(x, y))
}

#' @method vec_ptype2.wk_rct wk_wkt
#' @export
vec_ptype2.wk_rct.wk_wkt <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_wkt(crs = wk_crs_output(x, y))
}

#' @method vec_ptype2.wk_rct wk_xy
#' @export
vec_ptype2.wk_rct.wk_xy <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_wkb(crs = wk_crs_output(x, y))
}

#' @method vec_ptype2.wk_rct wk_xyz
#' @export
vec_ptype2.wk_rct.wk_xyz <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_wkb(crs = wk_crs_output(x, y))
}

#' @method vec_ptype2.wk_rct wk_xym
#' @export
vec_ptype2.wk_rct.wk_xym <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_wkb(crs = wk_crs_output(x, y))
}

#' @method vec_ptype2.wk_rct wk_xyzm
#' @export
vec_ptype2.wk_rct.wk_xyzm <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_wkb(crs = wk_crs_output(x, y))
}

#' @method vec_ptype2.wk_rct wk_crc
#' @export
vec_ptype2.wk_rct.wk_crc <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_wkb(crs = wk_crs_output(x, y))
}

# crc() --------

vec_proxy.wk_crc <- function(x, ...) {
  new_data_frame(unclass(x))
}

vec_restore.wk_crc <- function(x, to, ...) {
  crs_out <- attr(to, "crs", exact = TRUE) %||% attr(x, "crs", exact = TRUE)
  attr(x, "crs") <- NULL
  attr(x, "row.names") <- NULL
  new_wk_crc(x, crs = crs_out)
}

#' @rdname vctrs-methods
#' @export vec_cast.wk_crc
vec_cast.wk_crc <- function(x, to, ...) {
  UseMethod("vec_cast.wk_crc") # nocov
}

#' @method vec_cast.wk_crc default
#' @export
vec_cast.wk_crc.default <- function(x, to, ...) {
  vctrs::vec_default_cast(x, to) # nocov
}

#' @rdname vctrs-methods
#' @export vec_ptype2.wk_crc
vec_ptype2.wk_crc <- function(x, y, ...) {
  UseMethod("vec_ptype2.wk_crc", y) # nocov
}

#' @method vec_ptype2.wk_crc wk_crc
#' @export
vec_ptype2.wk_crc.wk_crc <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_crc(crs = wk_crs_output(x, y))
}

#' @method vec_ptype2.wk_crc wk_wkb
#' @export
vec_ptype2.wk_crc.wk_wkb <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_wkb(crs = wk_crs_output(x, y), geodesic = attr(y, "geodesic", exact = TRUE))
}

#' @method vec_ptype2.wk_crc wk_wkt
#' @export
vec_ptype2.wk_crc.wk_wkt <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_wkt(crs = wk_crs_output(x, y), geodesic = attr(y, "geodesic", exact = TRUE))
}

#' @method vec_ptype2.wk_crc wk_xy
#' @export
vec_ptype2.wk_crc.wk_xy <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_wkb(crs = wk_crs_output(x, y))
}

#' @method vec_ptype2.wk_crc wk_xyz
#' @export
vec_ptype2.wk_crc.wk_xyz <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_wkb(crs = wk_crs_output(x, y))
}

#' @method vec_ptype2.wk_crc wk_xym
#' @export
vec_ptype2.wk_crc.wk_xym <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_wkb(crs = wk_crs_output(x, y))
}

#' @method vec_ptype2.wk_crc wk_xyzm
#' @export
vec_ptype2.wk_crc.wk_xyzm <- function(x, y, ..., x_arg = "x", y_arg = "y") {
  new_wk_wkb(crs = wk_crs_output(x, y))
}

#' Raster-like objects
#'
#' [grd()] objects are just an array (any object with more than
#' two [dim()]s) and a bounding box (a [rct()], which may or
#' may not have a [wk_crs()] attached). The ordering of the dimensions
#' is y (indices increasing downwards), x (indices increasing to the right).
#' This follows the ordering of [as.raster()]/[rasterImage()] and aligns
#' with the printing of matrices.
#'
#' @param data An object with two or more dimensions. Most usefully, a matrix.
#' @param bbox A [rct()] containing the bounds and CRS of the object. You can
#'   specify a [rct()] with `xmin > xmax` or `ymin > ymax` which will flip
#'   the underlying data and return an object with a normalized bounding
#'   box and data.
#' @param nx,ny,dx,dy Either a number of cells in the x- and y- directions
#'   or delta in the x- and y-directions (in which case `bbox` must
#'   be specified).
#' @param type Use "polygons" to return a grid whose objects can be
#'   represented using an [rct()]; use "centers" to return a grid whose
#'   objects are the center of the [rct()] grid; use "corners" to return
#'   a grid along the corners of `bbox`.
#' @param x An object to convert to a grid
#' @param ... Passed to S3 methods
#'
#' @return
#'   - `grd()` returns a `grd_rct()` for `type == "polygons` or
#'     a `grd_xy()` otherwise.
#'   - `grd_rct()` returns an object of class "wk_grd_rct".
#'   - `grd_xy()` returns an object of class "wk_grd_xy".
#' @export
#'
#' @examples
#' # create a grid with no data (just for coordinates)
#' (grid <- grd(nx = 2, ny = 2))
#' as_rct(grid)
#' as_xy(grid)
#' plot(grid, border = "black")
#'
#' # more usefully, wraps a matrix or nd array + bbox
#' # approx volcano in New Zealand Transverse Mercator
#' bbox <- rct(
#'   5917000,       1757000 + 870,
#'   5917000 + 610, 1757000,
#'   crs = "EPSG:2193"
#' )
#' (grid <- grd_rct(volcano, bbox))
#'
#' # these come with a reasonable default plot method for matrix data
#' plot(grid)
#'
#' # you can set the data or the bounding box after creation
#' grid$bbox <- rct(0, 0, 1, 1)
#'
#' # subset by indices or rct
#' plot(grid[1:2, 1:2])
#' plot(grid[c(start = NA, stop = NA, step = 2), c(start = NA, stop = NA, step = 2)])
#' plot(grid[rct(0, 0, 0.5, 0.5)])
#'
grd <- function(bbox = NULL, nx = NULL, ny = NULL, dx = NULL, dy = NULL,
                type = c("polygons", "corners", "centers")) {
  if (is.null(bbox)) {
    bbox <- NULL
  } else if (inherits(bbox, "wk_rct")) {
    bbox
  } else {
    wk_bbox(bbox)
  }
  type <- match.arg(type)

  if (is.null(nx) && is.null(ny) && !is.null(dx) && !is.null(dy) && !is.null(bbox)) {
    rct <- unclass(bbox)
    width <- rct$xmax - rct$xmin
    height <- rct$ymax - rct$ymin

    if (type == "polygons") {
      nx <- width / dx
      ny <- height / dy
    } else if (type == "corners") {
      nx <- width / dx + 1
      ny <- height / dy + 1
    } else if (type == "centers") {
      nx <- width / dx
      ny <- height / dy
      bbox <- rct(
        rct$xmin + dx / 2,
        rct$ymin + dy / 2,
        rct$xmax - dx / 2,
        rct$ymax - dy / 2,
        crs = wk_crs(bbox)
      )
    }
  } else if (is.null(dx) && is.null(dy) && !is.null(nx) && !is.null(ny)) {
    if (is.null(bbox)) {
      bbox <- rct(0, 0, nx, ny)
    }

    nx <- nx
    ny <- ny

    if (type == "centers") {
      rct <- unclass(bbox)
      width <- rct$xmax - rct$xmin
      height <- rct$ymax - rct$ymin
      dx <- width / nx
      dy <- height / ny

      bbox <- rct(
        rct$xmin + dx / 2,
        rct$ymin + dy / 2,
        rct$xmax - dx / 2,
        rct$ymax - dy / 2,
        crs = wk_crs(bbox)
      )
    } else if (type == "corners") {
      nx <- nx + 1
      ny <- ny + 1
    }
  } else {
    stop(
      "Must specify dx, dy, and bbox OR nx and ny.",
      call. = FALSE
    )
  }

  # use a length-zero logical() with correct x and y dims
  data <- array(dim = c(ny, nx, 0))

  if (type == "polygons") {
    grd_rct(data, bbox)
  } else {
    grd_xy(data, bbox)
  }
}

#' @rdname grd
#' @export
grd_rct <- function(data, bbox = rct(0, 0, dim(data)[2], dim(data)[1])) {
  bbox <- if (inherits(bbox, "wk_rct")) bbox else wk_bbox(bbox)

  # normalize data and bbox so that max > min
  normalized <- grd_internal_normalize(data, bbox)
  data <- normalized[[1]]
  bbox <- normalized[[2]]

  # with zero values, bbox in that direction is empty
  rct <- unclass(bbox)
  if (dim(data)[2] == 0) {
    rct$xmin <- Inf
    rct$xmax <- -Inf
  }

  if (dim(data)[1] == 0) {
    rct$ymin <- Inf
    rct$ymax <- -Inf
  }

  bbox <- new_wk_rct(rct, crs = wk_crs(bbox))

  new_wk_grd(list(data = data, bbox = bbox), "wk_grd_rct")
}

#' @rdname grd
#' @export
grd_xy <- function(data, bbox = rct(0, 0, dim(data)[2] - 1, dim(data)[1] - 1)) {
  bbox <- if (inherits(bbox, "wk_rct")) bbox else wk_bbox(bbox)

  # normalize data and bbox so that max > min
  normalized <- grd_internal_normalize(data, bbox)
  data <- normalized[[1]]
  bbox <- normalized[[2]]

  # with zero values, bbox in that direction is empty
  rct <- unclass(bbox)
  if (dim(data)[2] == 0) {
    rct$xmin <- Inf
    rct$xmax <- -Inf
  }

  if (dim(data)[1] == 0) {
    rct$ymin <- Inf
    rct$ymax <- -Inf
  }

  bbox <- new_wk_rct(rct, crs = wk_crs(bbox))

  # with one value in the x dimension, we need a zero width bbox
  if (dim(data)[2] == 1) {
    stopifnot(
      unclass(bbox)$xmax == unclass(bbox)$xmin
    )
  }

  # with one value in the y dimension, we need a zero height bbox
  if (dim(data)[1] == 1) {
    stopifnot(
      unclass(bbox)$ymax == unclass(bbox)$ymin
    )
  }

  new_wk_grd(list(data = data, bbox = bbox), "wk_grd_xy")
}

#' @rdname grd
#' @export
as_grd_rct <- function(x, ...) {
  UseMethod("as_grd_rct")
}

#' @rdname grd
#' @export
as_grd_rct.wk_grd_rct <- function(x, ...) {
  x
}

#' @rdname grd
#' @export
as_grd_rct.wk_grd_xy <- function(x, ...) {
  # from a grd_xy, we assume these were the centres
  s <- grd_summary(x)

  bbox <- rct(
    s$xmin - s$dx / 2,
    s$ymin - s$dy / 2,
    s$xmax + s$dx / 2,
    s$ymax + s$dy / 2,
    crs = wk_crs(x$bbox)
  )

  grd_rct(x$data, bbox = bbox)
}

#' @rdname grd
#' @export
as_grd_xy <- function(x, ...) {
  UseMethod("as_grd_xy")
}

#' @rdname grd
#' @export
as_grd_xy.wk_grd_xy <- function(x, ...) {
  x
}

#' @rdname grd
#' @export
as_grd_xy.wk_grd_rct <- function(x, ...) {
  # from a grid_rct() we take the centers
  s <- grd_summary(x)

  bbox <- rct(
    s$xmin + s$dx / 2,
    s$ymin + s$dy / 2,
    s$xmax - s$dx / 2,
    s$ymax - s$dy / 2,
    crs = wk_crs(x$bbox)
  )

  grd_xy(x$data, bbox = bbox)
}

#' S3 details for grid objects
#'
#' @param x A [grd()]
#' @param subclass An optional subclass.
#'
#' @return An object inheriting from 'grd'
#'
#' @export
#'
new_wk_grd <- function(x, subclass = character()) {
  structure(x, class = union(subclass, "wk_grd"))
}


#' Grid information
#'
#' @param grid A [grd_xy()], [grd_rct()], or other object
#'   implementing `grd_*()` methods.
#' @return
#'   - `grd_summary()` returns a `list()` with components
#'     `xmin`, `ymin`, `xmax`, `ymax`,
#'     `nx`, `ny`, `dx`, `dy`, `width`, and `height`.
#' @export
#'
#' @examples
#' grd_summary(grd(nx = 3, ny = 2))
#'
grd_summary <- function(grid) {
  UseMethod("grd_summary")
}

#' @export
grd_summary.wk_grd_rct <- function(grid) {
  nx <- dim(grid$data)[2]
  ny <- dim(grid$data)[1]
  rct <- unclass(grid$bbox)
  width <- rct$xmax - rct$xmin
  height <- rct$ymax - rct$ymin
  dx <- width / nx
  dy <- height / ny

  list(
    xmin = rct$xmin,
    ymin = rct$ymin,
    xmax = rct$xmax,
    ymax = rct$ymax,
    nx = nx,
    ny = ny,
    dx = dx,
    dy = dy,
    width = width,
    height = height
  )
}

#' @export
grd_summary.wk_grd_xy <- function(grid) {
  nx <- dim(grid$data)[2]
  ny <- dim(grid$data)[1]
  rct <- unclass(grid$bbox)
  width <- rct$xmax - rct$xmin
  height <- rct$ymax - rct$ymin
  dx <- if (nx > 1) width / (nx - 1) else 0
  dy <- if (ny > 1) height / (ny - 1) else 0

  list(
    xmin = rct$xmin,
    ymin = rct$ymin,
    xmax = rct$xmax,
    ymax = rct$ymax,
    nx = nx,
    ny = ny,
    dx = dx,
    dy = dy,
    width = width,
    height = height
  )
}

# interface for wk methods

#' @export
wk_bbox.wk_grd <- function(handleable, ...) {
  handleable$bbox
}

#' @export
wk_crs.wk_grd <- function(x) {
  attr(x$bbox, "crs", exact = TRUE)
}

#' @export
wk_set_crs.wk_grd <- function(x, crs) {
  x$bbox <- wk_set_crs(x$bbox, crs)
  x
}

# interface for setting data and bbox

#' @export
`[[<-.wk_grd` <- function(x, i, value) {
  x_bare <- unclass(x)
  if (identical(i, "data")) {
    stopifnot(length(dim(value)) >= 2)
    x_bare$data <- value
  } else if (identical(i, "bbox")) {
    if (inherits(value, "wk_rct")) {
      # normalize so that max > min, but empty (Inf -Inf) is OK
      rct <- unclass(value)

      # missings make no sense in this context
      if (any(vapply(rct, is.na, logical(1)))) {
        stop("Can't set missing bounding box for grd objects", call. = FALSE)
      }

      if ((rct$xmin > rct$xmax) && (rct$xmin != Inf) && (rct$xmax != -Inf)) {
        rct[c("xmin", "xmax")] <- rct[c("xmax", "xmin")]
      }
      if ((rct$ymin > rct$ymax) && (rct$ymin != Inf) && (rct$ymax != -Inf)) {
        rct[c("ymin", "ymax")] <- rct[c("ymax", "ymin")]
      }

      value <- new_wk_rct(rct, crs = wk_crs(value))
    } else {
      value <- wk_bbox(value)
    }

    x_bare$bbox <- value
  } else {
    stop("Can't set element of a grd that is not 'data' or 'bbox'", call. = FALSE)
  }

  class(x_bare) <- class(x)
  x_bare
}

#' @export
`$<-.wk_grd` <- function(x, i, value) {
  x[[i]] <- value
  x
}

# interface for matrix-like extraction and subsetting
#' @export
dim.wk_grd <- function(x) {
  dim(x$data)
}

#' @export
`[.wk_grd` <- function(x, i, j, ..., drop = FALSE) {
  # for this method we never drop dimensions (can use $data[] to do this)
  stopifnot(identical(drop, FALSE))

  bbox <- NULL

  if (missing(i)) {
    i <- NULL
  }

  if (missing(j)) {
    j <- NULL
  }

  # allow combination of i, j to be a rct() instead
  if (inherits(i, "wk_rct") && is.null(j)) {
    result_xy <- grd_crop(x, bbox = i)
    if (length(dim(x$data)) > 2) {
      result_xy$data <- result_xy$data[, , , ..., drop = FALSE]
    } else {
      result_xy$data <- result_xy$data[, , ..., drop = FALSE]
    }
  } else if (inherits(i, "wk_rct")) {
    result_xy <- grd_crop(x, bbox = i)
    result_xy$data <- result_xy$data[, , j, ..., drop = FALSE]
  } else {
    result_xy <- grd_subset(x, i = i, j = j)
    result_xy$data <- result_xy$data[, , ..., drop = FALSE]
  }

  result_xy
}

#' @export
format.wk_grd <- function(x, ...) {
  crs <- wk_crs(x)
  sprintf(
    "<%s [%s] => %s%s>",
    class(x)[1],
    paste0(dim(x$data), collapse = " x "),
    wk_bbox(x),
    if (is.null(crs)) "" else paste0(" with crs=", format(crs))
  )
}

#' @export
print.wk_grd <- function(x, ...) {
  cat(paste0(format(x), "\n"))
  utils::str(x)
  invisible(x)
}

# normalize the data and the bbox such that xmax > xmin and ymax > ymin
grd_internal_normalize <- function(x, bbox) {
  rct <- unclass(bbox)
  new_rct <- rct

  if ((rct$ymin > rct$ymax) && (dim(x)[1] > 0)) {
    new_rct$ymin <- rct$ymax
    new_rct$ymax <- rct$ymin

    if (inherits(x, "nativeRaster")) {
      # the dimensions of a nativeRaster are lying in the sense that
      # they are row-major but are being stored column-major in the way
      # that R's indexing functions work
      attrs <- attributes(x)
      dim(x) <- rev(dim(x))
      x <- x[, ncol(x):1, drop = FALSE]
      attributes(x) <- attrs
    } else {
      x <- x[nrow(x):1, , drop = FALSE]
    }
  }

  if ((rct$xmin > rct$xmax) && (dim(x)[2] > 0)) {
    new_rct$xmin <- rct$xmax
    new_rct$xmax <- rct$xmin

    if (inherits(x, "nativeRaster")) {
      attrs <- attributes(x)
      dim(x) <- rev(dim(x))
      x <- x[nrow(x):1, , drop = FALSE]
      attributes(x) <- attrs
    } else {
      x <- x[, ncol(x):1, drop = FALSE]
    }
  }

  list(x = x, bbox = new_wk_rct(new_rct, crs = wk_crs(bbox)))
}

#' @rdname wk_handle
#' @export
wk_handle.wk_wkt <- function(handleable, handler, ...) {
  handler <- as_wk_handler(handler)
  .Call(
    wk_c_read_wkt,
    list(handleable, TRUE),
    handler
  )
}

#' Test handlers for handling of unknown size vectors
#'
#' @inheritParams wk_handle
#' @export
#'
#' @examples
#' handle_wkt_without_vector_size(wkt(), wk_vector_meta_handler())
#'
handle_wkt_without_vector_size <- function(handleable, handler) {
  handler <- as_wk_handler(handler)
  .Call(
    wk_c_read_wkt,
    list(handleable, FALSE),
    handler
  )
}

#' Debug filters and handlers
#'
#' @inheritParams wk_handle
#'
#' @return The result of the `handler`.
#' @export
#'
#' @examples
#' wk_debug(wkt("POINT (1 1)"))
#' wk_handle(wkt("POINT (1 1)"), wk_debug_filter())
#'
wk_debug <- function(handleable, handler = wk_void_handler(), ...) {
  wk_handle(handleable, wk_debug_filter(handler))
}

#' @rdname wk_debug
#' @export
wk_debug_filter <- function(handler = wk_void_handler()) {
  new_wk_handler(.Call(wk_c_debug_filter_new, handler), "wk_debug_filter")
}

#' Format well-known geometry for printing
#'
#' Provides an abbreviated version of the well-known text
#' representation of a geometry. This returns a constant
#' number of coordinates for each geometry, so is safe to
#' use for geometry vectors with many (potentially large)
#' features. Parse errors are passed on to the format string
#' and do not cause this handler to error.
#'
#' @inheritParams wk_handle
#' @inheritParams wk_writer
#' @param max_coords The maximum number of coordinates to include
#'   in the output.
#'
#' @return A character vector of abbreviated well-known text.
#' @export
#'
#' @examples
#' wk_format(wkt("MULTIPOLYGON (((0 0, 10 0, 0 10, 0 0)))"))
#' wk_format(new_wk_wkt("POINT ENTPY"))
#' wk_handle(
#'   wkt("MULTIPOLYGON (((0 0, 10 0, 0 10, 0 0)))"),
#'   wkt_format_handler()
#' )
#'
wk_format <- function(handleable, precision = 7, trim = TRUE, max_coords = 6, ...) {
  wk_handle(
    handleable,
    wkt_format_handler(precision = precision, trim = trim, max_coords = max_coords),
    ...
  )
}

#' @rdname wk_format
#' @export
wkt_format_handler <- function(precision = 7, trim = TRUE, max_coords = 6) {
  new_wk_handler(
    .Call(
      wk_c_wkt_formatter,
      as.integer(precision)[1],
      as.logical(trim)[1],
      as.integer(max_coords)[1]
    ),
    "wk_wkt_formatter"
  )
}

#' @rdname wk_handle
#' @export
wk_handle.sfg <- function(handleable, handler, ...) {
  wk_handle(sf::st_sfc(handleable), handler, ...)
}

#' @rdname wk_handle
#' @export
wk_handle.sf <- function(handleable, handler, ...) {
  wk_handle(sf::st_geometry(handleable), handler, ...)
}

#' @rdname wk_handle
#' @export
wk_handle.bbox <- function(handleable, handler, ...) {
  wk_handle(as_rct(handleable), handler, ...)
}

#' @rdname wk_writer
#' @export
wk_writer.sfc <- function(handleable, ...) {
  sfc_writer()
}

#' @rdname wk_writer
#' @export
wk_writer.sf <- function(handleable, ...) {
  sfc_writer()
}

#' @rdname wk_translate
#' @export
wk_translate.sfc <- function(handleable, to, ...) {
  result <- wk_handle(handleable, sfc_writer(), ...)
  attr(result, "crs") <- sf::st_crs(wk_crs_output(handleable, to))
  result
}

#' @rdname wk_handle.data.frame
#' @export
wk_translate.sf <- function(handleable, to, ...) {
  col_value <- wk_handle(handleable, sfc_writer(), ...)
  crs_out <- sf::st_crs(wk_crs_output(handleable, to))

  if (inherits(handleable, "sf")) {
    sf::st_geometry(handleable) <- col_value
  } else if (inherits(handleable, "data.frame")) {
    col <- handleable_column_name(handleable)
    handleable[col] <- list(col_value)
    handleable <- sf::st_as_sf(handleable, sf_column_name = col)
  } else {
    handleable <- sf::st_as_sf(data.frame(geometry = col_value))
  }

  sf::st_crs(handleable) <- crs_out
  handleable
}

#' @rdname wk_handle.data.frame
#' @export
wk_restore.sf <- function(handleable, result, ...) {
  col <- handleable_column_name(handleable)

  if(nrow(handleable) == length(result)) {
    sf::st_geometry(handleable) <- result
    handleable
  } else if (nrow(handleable) == 1) {
    handleable <- handleable[rep(1L, length(result)), , drop = FALSE]
    sf::st_geometry(handleable) <- result
    handleable
  } else {
    stop(
      sprintf(
        "Can't assign result of length %d to sf with %d rows",
        length(result), nrow(handleable)
      ),
      call. = FALSE
    )
  }
}

#' @export
wk_crs.sfc <- function(x) {
  sf::st_crs(x)
}

#' @export
wk_set_crs.sfc <- function(x, crs) {
  sf::st_crs(x) <- sf::st_crs(crs)
  x
}

#' @export
wk_crs.sf <- function(x) {
  sf::st_crs(x)
}

#' @export
wk_set_crs.sf <- function(x, crs) {
  sf::st_crs(x) <- sf::st_crs(crs)
  x
}

#' @export
wk_crs.sfg <- function(x) {
  sf::NA_crs_
}

#' @export
wk_crs.bbox <- function(x) {
  sf::st_crs(x)
}

#' @export
wk_set_crs.bbox <- function(x, crs) {
  sf::st_crs(x) <- sf::st_crs(crs)
  x
}

#' @export
as_wkb.sfc <- function(x, ...) {
  wk_translate(x, new_wk_wkb(crs = wk_crs_inherit()))
}

#' @export
as_wkb.sfg <- function(x, ...) {
  wk_translate(x, new_wk_wkb(crs = wk_crs_inherit()))
}

#' @export
wk_crs_equal_generic.crs <- function(x, y, ...) {
  x == sf::st_crs(y)
}

#' @export
wk_crs_proj_definition.crs <- function(crs, proj_version = NULL, verbose = FALSE) {
  if (is.na(crs)) {
    wk_crs_proj_definition(NULL)
  } else if (isTRUE(verbose)) {
    crs$Wkt %||% crs$wkt
  } else if (isTRUE(is.na(crs$epsg)) || isTRUE(grepl("^[0-9A-Za-z]+:[0-9A-Za-z]+$", crs$input))) {
    wk_crs_proj_definition(crs$input)
  } else {
    paste0("EPSG:", crs$epsg)
  }
}

#' @export
wk_crs_projjson.crs <- function(crs) {
  json <- crs$ProjJson
  if (is.null(json)) {
    # i.e., GDAL is not >= 3.1.0
    NextMethod()
  } else {
    json
  }
}

wk_crs_from_sf <- function(x) {
  crs <- sf::st_crs(x)
  if (is.na(crs)) NULL else crs
}

sf_crs_from_wk <- function(x) {
  sf::st_crs(wk_crs(x))
}

#' @export
as_xy.sfc <- function(x, ...) {
  if (length(x) == 0) {
    xy(crs = wk_crs_from_sf(x))
  } else if (inherits(x, "sfc_POINT")) {
    coords <- sf::st_coordinates(x)
    dims <- colnames(coords)
    dimnames(coords) <- NULL
    if (anyNA(coords)) {
      coords[is.na(coords)] <- NaN
    }

    if (identical(dims, c("X", "Y"))) {
      new_wk_xy(
        list(
          x = coords[, 1, drop = TRUE],
          y = coords[, 2, drop = TRUE]
        ),
        crs = wk_crs_from_sf(x)
      )
    } else if (identical(dims, c("X", "Y", "Z"))) {
      new_wk_xyz(
        list(
          x = coords[, 1, drop = TRUE],
          y = coords[, 2, drop = TRUE],
          z = coords[, 3, drop = TRUE]
        ),
        crs = wk_crs_from_sf(x)
      )
    } else if (identical(dims, c("X", "Y", "M"))) {
      new_wk_xym(
        list(
          x = coords[, 1, drop = TRUE],
          y = coords[, 2, drop = TRUE],
          m = coords[, 3, drop = TRUE]
        ),
        crs = wk_crs_from_sf(x)
      )
    } else if (identical(dims, c("X", "Y", "Z", "M"))) {
      new_wk_xyzm(
        list(
          x = coords[, 1, drop = TRUE],
          y = coords[, 2, drop = TRUE],
          z = coords[, 3, drop = TRUE],
          m = coords[, 4, drop = TRUE]
        ),
        crs = wk_crs_from_sf(x)
      )
    } else {
      stop("Unknown dimensions.", call. = FALSE) # nocov
    }
  } else {
    NextMethod()
  }
}

#' @export
as_rct.bbox <- function(x, ...) {
  x_bare <- unclass(x)
  new_wk_rct(as.list(x_bare[c("xmin", "ymin", "xmax", "ymax")]), crs = wk_crs_from_sf(x))
}

#' @export
as_wkb.sf <- function(x, ...) {
  as_wkb(sf::st_geometry(x), ...)
}

#' @export
as_wkt.sf <- function(x, ...) {
  as_wkt(sf::st_geometry(x), ...)
}

#' @export
as_xy.sf <- function(x, ..., dims = NULL) {
  as_xy(sf::st_geometry(x), ..., dims = dims)
}

# dynamically exported
st_as_sfc.wk_wkb <- function(x, ...) {
  sf::st_set_crs(wk_handle(x, sfc_writer()), sf_crs_from_wk(x))
}

st_as_sf.wk_wkb <- function(x, ...) {
  sf::st_as_sf(
    new_data_frame(
      list(geometry = st_as_sfc.wk_wkb(x, ...))
    )
  )
}

st_as_sfc.wk_wkt <- function(x, ...) {
  sf::st_set_crs(wk_handle(x, sfc_writer()), sf_crs_from_wk(x))
}

st_as_sf.wk_wkt <- function(x, ...) {
  sf::st_as_sf(
    new_data_frame(
      list(geometry = st_as_sfc.wk_wkt(x, ...))
    )
  )
}

st_as_sfc.wk_xy <- function(x, ...) {
  if (all(!is.na(x))) {
    st_as_sf.wk_xy(x, ...)$geometry
  } else {
    sf::st_as_sfc(as_wkb(x), ...)
  }
}

st_as_sf.wk_xy <- function(x, ...) {
  is_na_or_nan <- Reduce("&", lapply(unclass(x), is.na))
  if ((length(x) > 0) && all(!is_na_or_nan)) {
    sf::st_as_sf(as.data.frame(x), coords = xy_dims(x), crs = sf_crs_from_wk(x))
  } else {
    sf::st_as_sf(
      new_data_frame(
        list(geometry = sf::st_as_sfc(as_wkb(x), ...))
      )
    )
  }
}

st_as_sfc.wk_rct <- function(x, ...) {
  out <- sf::st_set_crs(wk_handle(x, sfc_writer()), sf_crs_from_wk(x))
  attr(out, "oriented") <- TRUE
  out
}

st_as_sfc.wk_crc <- function(x, ...) {
  out <- sf::st_set_crs(wk_handle(x, sfc_writer()), sf_crs_from_wk(x))
  attr(out, "oriented") <- TRUE
  out
}

st_as_sf.wk_rct <- function(x, ...) {
  sf::st_as_sf(
    new_data_frame(
      list(geometry = st_as_sfc.wk_rct(x, ...))
    )
  )
}

st_as_sf.wk_crc <- function(x, ...) {
  sf::st_as_sf(
    new_data_frame(
      list(geometry = st_as_sfc.wk_crc(x, ...))
    )
  )
}

st_as_sfc.wk_grd <- function(x, ...) {
  result <- wk_handle(x, sfc_writer())
  sf::st_crs(result) <- sf::st_crs(wk_crs(x))
  result
}

st_as_sf.wk_grd <- function(x, ...) {
  sf::st_as_sf(data.frame(geometry = st_as_sfc.wk_grd(x)))
}

# st_geometry methods()

st_geometry.wk_wkb <- function(x, ...) {
  st_as_sfc.wk_wkb(x, ...)
}

st_geometry.wk_wkt <- function(x, ...) {
  st_as_sfc.wk_wkt(x, ...)
}

st_geometry.wk_xy <- function(x, ...) {
  st_as_sfc.wk_xy(x, ...)
}

st_geometry.wk_rct <- function(x, ...) {
  st_as_sfc.wk_rct(x, ...)
}

st_geometry.wk_crc <- function(x, ...) {
  st_as_sfc.wk_crc(x, ...)
}

st_geometry.wk_grd <- function(x, ...) {
  st_as_sfc.wk_grd(x)
}

# st_bbox() methods

st_bbox.wk_wkb <- function(x, ...) {
  sf::st_bbox(wk_bbox(x))
}

st_bbox.wk_wkt <- function(x, ...) {
  sf::st_bbox(wk_bbox(x))
}

st_bbox.wk_xy <- function(x, ...) {
  sf::st_bbox(wk_bbox(x))
}

st_bbox.wk_rct <- function(x, ...) {
  sf::st_bbox(unlist(x), crs = wk_crs(x))
}

st_bbox.wk_crc <- function(x, ...) {
  sf::st_bbox(wk_bbox(x))
}

st_bbox.wk_grd <- function(x, ...) {
  sf::st_bbox(wk_bbox(x))
}

# st_crs() methods

st_crs.wk_wkb <- function(x, ...) {
  sf::st_crs(wk_crs(x))
}

st_crs.wk_wkt <- function(x, ...) {
  sf::st_crs(wk_crs(x))
}

st_crs.wk_xy <- function(x, ...) {
  sf::st_crs(wk_crs(x))
}

st_crs.wk_rct <- function(x, ...) {
  sf::st_crs(wk_crs(x))
}

st_crs.wk_crc <- function(x, ...) {
  sf::st_crs(wk_crs(x))
}

st_crs.wk_grd <- function(x, ...) {
  sf::st_crs(wk_crs(x$bbox))
}

# st_crs<-() methods

`st_crs<-.wk_wkb` <- function(x, value) {
  wk_set_crs(x, sf::st_crs(value))
}

`st_crs<-.wk_wkt` <- function(x, value) {
  wk_set_crs(x, sf::st_crs(value))
}

`st_crs<-.wk_xy` <- function(x, value) {
  wk_set_crs(x, sf::st_crs(value))
}

`st_crs<-.wk_rct` <- function(x, value) {
  wk_set_crs(x, sf::st_crs(value))
}

`st_crs<-.wk_crc` <- function(x, value) {
  wk_set_crs(x, sf::st_crs(value))
}

`st_crs<-.wk_grd` <- function(x, value) {
  wk_set_crs(x, sf::st_crs(value))
}

new_wk_rcrd <- function(x, template) {
  stopifnot(
    is.list(x),
    is.null(attr(x, "class")),
    !is.null(names(x)),
    all(names(x) != "")
  )

  structure(
    x,
    class = unique(class(template)),
    crs = attr(template, "crs", exact = TRUE),
    geodesic = attr(template, "geodesic", exact = TRUE)
  )
}

validate_wk_rcrd <- function(x) {
  x_bare <- unclass(x)
  stopifnot(
    typeof(x) == "list",
    !is.null(names(x_bare)),
    all(names(x_bare) != ""),
    all(vapply(x_bare, is.double, logical(1)))
  )

  invisible(x)
}

#' @export
format.wk_rcrd <- function(x, ...) {
  vapply(x, function(item) paste0(format(unclass(item), ...), collapse = "\n"), character(1))
}

#' @export
print.wk_rcrd <- function(x, ...) {
  crs <- wk_crs(x)
  is_geodesic <- wk_is_geodesic(x)
  header <- sprintf("%s[%s]", class(x)[1], length(x))

  if (!is.null(crs)) {
    header <- paste0(header, " with CRS=", wk_crs_format(crs))
  }

  if (isTRUE(is_geodesic)) {
    header <- paste0("geodesic ", header)
  }

  cat(sprintf("<%s>\n", header))

  if (length(x) == 0) {
    return(invisible(x))
  }

  max_print <- getOption("max.print", 1000)
  x_head <- format(utils::head(x, max_print))
  out <- format(x_head)

  print(out, quote = FALSE)

  if (length(x) > max_print) {
    cat(sprintf("Reached max.print (%s)\n", max_print))
  }

  invisible(x)
}

#' @export
str.wk_rcrd <- function(object, ...) {
  str.wk_vctr(object, ...)
}

#' @export
as.character.wk_rcrd <- function(x, ...) {
  format(x, ...)
}

#' @export
is.na.wk_rcrd <- function(x, ...) {
  is_na <- lapply(unclass(x), is.na)
  Reduce("&", is_na)
}

#' @export
`[.wk_rcrd` <- function(x, i) {
  new_wk_rcrd(lapply(unclass(x), "[", i), x)
}

#' @export
`[[.wk_rcrd` <- function(x, i) {
  x[i]
}

#' @export
`$.wk_rcrd` <- function(x, i) {
  stop("`$` is not meaningful for 'wk_rcrd' objects", call. = FALSE)
}

#' @export
`[[<-.wk_rcrd` <- function(x, i, value) {
  x[i] <- value
  x
}

#' @export
names.wk_rcrd <- function(x) {
  NULL
}

#' @export
`names<-.wk_rcrd` <- function(x, value) {
  if (is.null(value)) {
    x
  } else {
    stop("Names of a 'wk_rcrd' must be NULL.")
  }
}

#' @export
length.wk_rcrd <- function(x) {
  length(unclass(x)[[1]])
}

#' @export
rep.wk_rcrd <- function(x, ...) {
  new_wk_rcrd(lapply(unclass(x), rep, ...), x)
}

#' @method rep_len wk_rcrd
#' @export
rep_len.wk_rcrd <- function(x, ...) {
  new_wk_rcrd(lapply(unclass(x), rep_len, ...), x)
}

#' @export
c.wk_rcrd <- function(...) {
  dots <- list(...)
  classes <- lapply(dots, class)
  first_class <- classes[[1]]
  if (!all(vapply(classes, identical, first_class, FUN.VALUE = logical(1)))) {
    stop("Can't combine 'wk_rcrd' objects that do not have identical classes.", call. = FALSE)
  }

  # compute output crs
  attr(dots[[1]], "crs") <- wk_crs_output(...)
  geodesic <- wk_is_geodesic_output(...)
  attr(dots[[1]], "geodesic") <- if (geodesic) TRUE else NULL

  new_wk_vctr(do.call(Map, c(list(c), lapply(dots, unclass))), dots[[1]])
}

# data.frame() will call as.data.frame() with optional = TRUE
#' @export
as.data.frame.wk_rcrd <- function(x, ..., optional = FALSE) {
  if (!optional) {
    new_data_frame(unclass(x))
  } else {
    new_data_frame(list(x))
  }
}

#' @export
as.matrix.wk_rcrd <- function(x, ...) {
  x_bare <- unclass(x)
  matrix(
    unlist(x_bare, use.names = FALSE),
    nrow = length(x),
    ncol = length(x_bare),
    byrow = FALSE,
    dimnames = list(NULL, names(x_bare))
  )
}

#' Write geometry vectors
#'
#' When writing transformation functions, it is often useful to know which
#' handler should be used to create a (potentially modified) version
#' of an object. Some transformers (e.g., [wk_vertices()]) modify
#' the geometry type of an object, in which case a generic writer is needed.
#' This defaults to [wkb_writer()] because it is fast and can handle
#' all geometry types.
#'
#' @inheritParams wk_handle
#' @param precision If `trim` is `TRUE`, the total number of significant digits to keep
#'   for each result or the number of digits after the decimal place otherwise.
#' @param trim Use `FALSE` to keep trailing zeroes after the decimal place.
#' @param endian Use 1 for little endian, 0 for big endian, or NA for
#'   system endian.
#' @param generic Use `TRUE` to obtain a writer that can write all geometry
#'   types.
#' @param buffer_size Control the initial buffer size used when writing WKB.
#' @param promote_multi Use TRUE to promote all simple geometries to a multi
#'   type when reading to sfc. This is useful to increase the likelihood that
#'   the sfc will contain a single geometry type.
#' @param ... Passed to the writer constructor.
#'
#' @return A [wk_handler][wk_handle].
#' @export
#'
wk_writer <- function(handleable, ..., generic = FALSE) {
  UseMethod("wk_writer")
}

#' @rdname wk_writer
#' @export
wk_writer.default <- function(handleable, ...) {
  wkb_writer()
}

#' @rdname wk_writer
#' @export
wk_writer.wk_wkt <- function(handleable, ..., precision = 16, trim = TRUE) {
  wkt_writer(precision, trim)
}

#' @rdname wk_writer
#' @export
wk_writer.wk_wkb <- function(handleable, ...) {
  wkb_writer()
}

#' @rdname wk_writer
#' @export
wk_writer.wk_xy <- function(handleable, ..., generic = FALSE) {
  if (generic) wkb_writer() else xy_writer()
}

`%||%` <- function(x, y) {
  if (is.null(x)) y else x
}

new_data_frame <- function(x) {
  structure(x, row.names = c(NA, length(x[[1]])), class = "data.frame")
}

# rep_len became an S3 generic in R 3.6, so we need to use
# something else to make sure recycle_common() works on old
# R versions
rep_len_compat <- function(x, length_out) {
  rep(x, length.out = length_out)
}

recycle_common <- function(...) {
  dots <- list(...)
  lengths <- vapply(dots, length, integer(1))
  non_constant_lengths <- unique(lengths[lengths != 1])
  if (length(non_constant_lengths) == 0) {
    final_length <- 1
  } else if(length(non_constant_lengths) == 1) {
    final_length <- non_constant_lengths
  } else {
    lengths_label <- paste0(non_constant_lengths, collapse = ", ")
    stop(sprintf("Incompatible lengths: %s", lengths_label))
  }

  dots[lengths != final_length] <- lapply(dots[lengths != final_length], rep_len_compat, final_length)
  dots
}

is_vector_class <- function(x) {
  identical(class(x[integer(0)]), class(x))
}

#' Affine transformer
#'
#' @param trans_matrix A 3x3 transformation matrix
#' @param x A [wk_trans_affine()]
#' @param dx,dy Coordinate offsets in the x and y direction
#' @param scale_x,scale_y Scale factor to apply in the x and y directions, respectively
#' @param rct_in,rct_out The input and output bounds
#' @param rotation_deg A rotation to apply in degrees counterclockwise.
#' @param src,dst Point vectors of control points used to estimate the affine mapping
#'   (using [base::qr.solve()]).
#' @param ... Zero or more transforms in the order they should be applied.
#'
#' @export
#'
wk_trans_affine <- function(trans_matrix) {
  new_wk_trans(.Call(wk_c_trans_affine_new, trans_matrix), "wk_trans_affine")
}

#' @export
wk_trans_inverse.wk_trans_affine <- function(trans, ...) {
  wk_affine_invert(trans)
}

#' @rdname wk_trans_affine
#' @export
wk_affine_identity <- function() {
  wk_affine_translate(0, 0)
}

#' @rdname wk_trans_affine
#' @export
wk_affine_rotate <- function(rotation_deg) {
  theta <- -rotation_deg * pi / 180
  trans_matrix <- matrix(
    c(
      cos(theta), +sin(theta), 0,
      -sin(theta), cos(theta), 0,
      0, 0, 1
    ),
    nrow = 3,
    byrow = TRUE
  )

  wk_trans_affine(trans_matrix)
}

#' @rdname wk_trans_affine
#' @export
wk_affine_scale <- function(scale_x = 1, scale_y = 1) {
  wk_trans_affine(matrix(c(scale_x, 0, 0, 0, scale_y, 0, 0, 0, 1), ncol = 3))
}

#' @rdname wk_trans_affine
#' @export
wk_affine_translate <- function(dx = 0, dy = 0) {
  wk_trans_affine(matrix(c(1, 0, 0, 0, 1, 0, dx, dy, 1), ncol = 3))
}

#' @rdname wk_trans_affine
#' @export
wk_affine_fit <- function(src, dst) {
  src <- as_xy(src)
  dst <- as_xy(dst)
  n <- length(src)
  stopifnot(length(src) == length(dst))
  src <- unclass(src)
  dst <- unclass(dst)

  src_mat <- cbind(src$x, src$y, rep_len(1, n))
  dst_mat <- cbind(dst$x, dst$y, rep_len(1, n))

  wk_trans_affine(t(qr.solve(src_mat, dst_mat)))
}

#' @rdname wk_trans_affine
#' @export
wk_affine_rescale <- function(rct_in, rct_out) {
  # use bbox to sanitize input as rct of length 1
  rct_in <- unclass(wk_bbox(rct_in))
  rct_out <- unclass(wk_bbox(rct_out))

  width_in <- rct_in$xmax - rct_in$xmin
  height_in <- rct_in$ymax - rct_in$ymin
  width_out <- rct_out$xmax - rct_out$xmin
  height_out <- rct_out$ymax - rct_out$ymin

  dx <- rct_out$xmin - rct_in$xmin
  dy <- rct_out$ymin - rct_in$ymin

  wk_affine_compose(
    wk_affine_scale(width_out / width_in, height_out / height_in),
    wk_affine_translate(dx, dy)
  )
}

#' @rdname wk_trans_affine
#' @export
wk_affine_compose <- function(...) {
  trans_matrix <- Reduce(
    `%*%`,
    lapply(rev(list(...)), as.matrix),
    init = as.matrix(wk_affine_identity())
  )
  wk_trans_affine(trans_matrix)
}

#' @rdname wk_trans_affine
#' @export
wk_affine_invert <- function(x) {
  wk_trans_affine(solve(as.matrix(x)))
}

#' @export
as.matrix.wk_trans_affine <- function(x, ...) {
  .Call(wk_c_trans_affine_as_matrix, x)
}

#' @export
format.wk_trans_affine <- function(x, ...) {
  format(as.matrix(x), ...)
}

#' @export
print.wk_trans_affine <- function(x, ...) {
  cat("<wk_trans_affine>\n")
  print(as.matrix(x), ...)
  invisible(x)
}

#' Extract feature-level meta
#'
#' These functions return the non-coordinate information of a geometry
#' and/or vector. They do not parse an entire geometry/vector and are
#' intended to be very fast even for large vectors.
#'
#' @inheritParams wk_handle
#' @param geometry_type An integer code for the geometry type. These
#'   integers follow the WKB specification (e.g., 1 for point,
#'   7 for geometrycollection).
#' @param geometry_type_label A character vector of (lowercase)
#'   geometry type labels as would be found in WKT (e.g., point,
#'   geometrycollection).
#'
#' @return A data.frame with columns:
#'   - `geometry_type`: An integer identifying the geometry type.
#'     A value of 0 indicates that the types of geometry in the vector
#'     are not known without parsing the entire vector.
#'   - `size`: For points and linestrings, the number of coordinates; for
#'     polygons, the number of rings; for collections, the number of
#'     child geometries. A value of zero indicates an EMPTY geometry.
#'     A value of `NA` means this value is unknown without parsing the
#'     entire geometry.
#'   - `has_z`: `TRUE` if coordinates contain a Z value. A value of `NA`
#'     means this value is unknown without parsing the entire vector.
#'   - `has_m`: `TRUE` if coordinates contain an M value. A value of `NA`
#'     means this value is unknown without parsing the entire vector.
#'   - `srid`: An integer identifying a CRS or NA if this value was not
#'     provided.
#'   - `precision`: A grid size or 0.0 if a grid size was not provided.
#'     Note that coordinate values may not have been rounded; the grid
#'     size only refers to the level of detail with which they should
#'     be interpreted.
#'   - `is_empty`: `TRUE` if there is at least one non-empty coordinate.
#'     For the purposes of this value, a non-empty coordinate is one that
#'     contains at least one value that is not `NA` or `NaN`.
#'
#' @export
#'
#' @examples
#' wk_vector_meta(as_wkt("LINESTRING (0 0, 1 1)"))
#' wk_meta(as_wkt("LINESTRING (0 0, 1 1)"))
#' wk_meta(as_wkb("LINESTRING (0 0, 1 1)"))
#'
#' wk_geometry_type_label(1:7)
#' wk_geometry_type(c("point", "geometrycollection"))
#'
wk_meta <- function(handleable, ...) {
  UseMethod("wk_meta")
}

#' @rdname wk_meta
#' @export
wk_meta.default <- function(handleable, ...) {
  new_data_frame(wk_handle(handleable, wk_meta_handler(), ...))
}

#' @rdname wk_meta
#' @export
wk_vector_meta <- function(handleable, ...) {
  UseMethod("wk_vector_meta")
}

#' @rdname wk_meta
#' @export
wk_vector_meta.default <- function(handleable, ...) {
  new_data_frame(wk_handle(handleable, wk_vector_meta_handler(), ...))
}

#' @rdname wk_meta
#' @export
wk_meta_handler <- function() {
  new_wk_handler(.Call(wk_c_meta_handler_new), "wk_meta_handler")
}

#' @rdname wk_meta
#' @export
wk_vector_meta_handler <- function() {
  new_wk_handler(.Call(wk_c_vector_meta_handler_new), "wk_vector_meta_handler")
}

#' @rdname wk_meta
#' @export
wk_geometry_type_label <- function(geometry_type) {
  c(
    "point", "linestring", "polygon",
    "multipoint", "multilinestring", "multipolygon",
    "geometrycollection"
  )[as.integer(geometry_type)]
}

#' @rdname wk_meta
#' @export
wk_geometry_type <- function(geometry_type_label) {
  match(
    geometry_type_label,
    c(
      "point", "linestring", "polygon",
      "multipoint", "multilinestring", "multipolygon",
      "geometrycollection"
    )
  )
}

#' Do nothing
#'
#' This handler does nothing and returns `NULL`. It is useful for
#' benchmarking readers and handlers and when using filters
#' that have side-effects (e.g., [wk_debug()]). Note that this
#' handler stops on the first parse error; to see a list of parse
#' errors see the [wk_problems()] handler.
#'
#' @inheritParams wk_handle
#'
#' @return `NULL`
#' @export
#'
#' @examples
#' wk_void(wkt("POINT (1 4)"))
#' wk_handle(wkt("POINT (1 4)"), wk_void_handler())
#'
wk_void <- function(handleable, ...) {
  invisible(wk_handle(handleable, wk_void_handler(), ...))
}

#' @rdname wk_void
#' @export
wk_void_handler <- function() {
  new_wk_handler(.Call(wk_c_handler_void_new), "wk_void_handler")
}

#' Mark character vectors as well-known text
#'
#' @param x A [character()] vector containing well-known text.
#' @inheritParams new_wk_wkb
#' @param ... Unused
#'
#' @return A [new_wk_wkt()]
#' @export
#'
#' @examples
#' wkt("POINT (20 10)")
#'
wkt <- function(x = character(), crs = wk_crs_auto(), geodesic = FALSE) {
  x <- as.character(x)
  crs <- wk_crs_auto_value(x, crs)
  wkt <- new_wk_wkt(x, crs = crs, geodesic = geodesic_attr(geodesic))
  validate_wk_wkt(wkt)
  wkt
}

#' @rdname wkt
#' @export
parse_wkt <- function(x, crs = wk_crs_auto(), geodesic = FALSE) {
  x <- as.character(x)
  crs <- wk_crs_auto_value(x, crs)
  wkt <- new_wk_wkt(x, crs = crs, geodesic = geodesic_attr(geodesic))
  parse_base(wkt, wk_problems(wkt))
}

#' @rdname wkt
#' @export
as_wkt <- function(x, ...) {
  UseMethod("as_wkt")
}

#' @rdname wkt
#' @export
as_wkt.default <- function(x, ...) {
  wk_translate(
    x,
    new_wk_wkt(crs = wk_crs_inherit(), geodesic = wk_geodesic_inherit())
  )
}

#' @rdname wkt
#' @export
as_wkt.character <- function(x, ..., crs = NULL, geodesic = FALSE) {
  wkt(x, crs = crs, geodesic = geodesic)
}

#' @rdname wkt
#' @export
as_wkt.wk_wkt <- function(x, ...) {
  x
}

#' S3 Details for wk_wkt
#'
#' @param x A (possibly) [wkt()] vector
#' @inheritParams new_wk_wkb
#'
#' @export
#'
new_wk_wkt <- function(x = character(), crs = NULL, geodesic = NULL) {
  if (typeof(x) != "character" || !is.null(attributes(x))) {
    stop("wkt input must be a character() without attributes",  call. = FALSE)
  }

  structure(x, class = c("wk_wkt", "wk_vctr"), crs = crs, geodesic = geodesic)
}

#' @rdname new_wk_wkt
#' @export
is_wk_wkt <- function(x) {
  inherits(x, "wk_wkt")
}

#' @rdname new_wk_wkt
#' @export
validate_wk_wkt <- function(x) {
  if (typeof(x) != "character") {
    stop("wkt() must be of type character()", call. = FALSE)
  }

  if (!inherits(x, "wk_wkt") || !inherits(x, "wk_vctr")) {
    stop('wkt() must inherit from c("wk_wkt", "wk_vctr")', call. = FALSE)
  } else {
    problems <- wk_problems(x)
  }

  stop_for_problems(problems)

  invisible(x)
}

#' @export
`[<-.wk_wkt` <- function(x, i, value) {
  replacement <- as_wkt(value)
  crs_out <- wk_crs_output(x, replacement)
  geodesic_out <- wk_is_geodesic_output(x, replacement)
  x <- unclass(x)
  x[i] <- replacement
  attr(x, "crs") <- NULL
  attr(x, "geodesic") <- NULL
  new_wk_wkt(x, crs = crs_out, geodesic = geodesic_attr(geodesic_out))
}

#' @export
format.wk_wkt <- function(x, ..., max_coords = 6) {
  wk_format(x, max_coords = max_coords)
}

#' @export
as.character.wk_wkt <- function(x, ...) {
  attr(x, "crs") <- NULL
  unclass(x)
}

#' @rdname wk_writer
#' @export
wkb_writer <- function(buffer_size = 2048L, endian = NA_integer_) {
  new_wk_handler(
    .Call(wk_c_wkb_writer_new, as.integer(buffer_size), as.integer(endian)),
    "wk_wkb_writer"
  )
}

#' Extract simple geometries
#'
#' @inheritParams wk_handle
#' @param max_depth The maximum (outer) depth to remove.
#' @param add_details Use `TRUE` to add a "wk_details" attribute, which
#'   contains columns `feature_id`, `part_id`, and `ring_id`.
#'
#' @return `handleable` transformed such that collections have been
#'   expanded and only simple geometries (point, linestring, polygon)
#'   remain.
#' @export
#'
#' @examples
#' wk_flatten(wkt("MULTIPOINT (1 1, 2 2, 3 3)"))
#' wk_flatten(
#'   wkt("GEOMETRYCOLLECTION (GEOMETRYCOLLECTION (GEOMETRYCOLLECTION (POINT (0 1))))"),
#'   max_depth = 2
#' )
#'
wk_flatten <- function(handleable, ..., max_depth = 1) {
  if (is.data.frame(handleable))  {
    result <- wk_handle(
      handleable,
      wk_flatten_filter(wk_writer(handleable), max_depth, add_details = TRUE),
      ...
    )
    feature_id <- attr(result, "wk_details", exact = TRUE)$feature_id
    attr(result, "wk_details") <- NULL
    result <- wk_restore(handleable[feature_id, , drop = FALSE], result, ...)
  } else {
    result <- wk_handle(handleable, wk_flatten_filter(wk_writer(handleable, generic = TRUE), max_depth), ...)
    result <- wk_restore(handleable, result, ...)
  }

  result <- wk_set_crs(result, wk_crs(handleable))
  wk_set_geodesic(result, wk_is_geodesic(handleable))
}

#' @rdname wk_flatten
#' @export
wk_flatten_filter <- function(handler, max_depth = 1L, add_details = FALSE) {
  new_wk_handler(
    .Call(
      "wk_c_flatten_filter_new",
      as_wk_handler(handler),
      as.integer(max_depth)[1],
      as.logical(add_details)[1]
    ),
    "wk_flatten_filter"
  )
}

#' Deprecated functions
#'
#' These functions are deprecated and will be removed in a future version.
#'
#' @param wkb A `list()` of [raw()] vectors, such as that
#'   returned by `sf::st_as_binary()`.
#' @param wkt A character vector containing well-known text.
#' @param trim Trim unnecessary zeroes in the output?
#' @param precision The rounding precision to use when writing
#'   (number of decimal places).
#' @param endian Force the endian of the resulting WKB.
#' @param ... Used to keep backward compatibility with previous
#'   versions of these functions.
#'
#' @export
#' @rdname deprecated
#'
wkb_translate_wkt <- function(wkb, ..., precision = 16, trim = TRUE) {
  unclass(wk_handle.wk_wkb(wkb, wkt_writer(precision, trim)))
}

#' @rdname deprecated
#' @export
wkb_translate_wkb <- function(wkb, ..., endian = NA_integer_) {
  unclass(wk_handle.wk_wkb(wkb, wkb_writer(endian = endian)))
}

#' @rdname deprecated
#' @export
wkt_translate_wkt <- function(wkt, ..., precision = 16, trim = TRUE) {
  unclass(wk_handle.wk_wkt(wkt, wkt_writer(precision, trim)))
}

#' @rdname deprecated
#' @export
wkt_translate_wkb <- function(wkt, ..., endian = NA_integer_) {
  unclass(wk_handle.wk_wkt(wkt, wkb_writer(endian = endian)))
}

#' Read geometry vectors
#'
#' The handler is the basic building block of the wk package. In
#' particular, the [wk_handle()] generic allows operations written
#' as handlers to "just work" with many different input types. The
#' wk package provides the [wk_void()] handler, the [wk_format()]
#' handler, the [wk_debug()] handler, the [wk_problems()] handler,
#' and [wk_writer()]s for [wkb()], [wkt()], [xy()], and [sf::st_sfc()])
#' vectors.
#'
#' @param handler_ptr An external pointer to a newly created WK handler
#' @param handler A [wk_handler][wk_handle] object.
#' @param subclass The handler subclass
#' @param handleable A geometry vector (e.g., [wkb()], [wkt()], [xy()],
#'   [rct()], or [sf::st_sfc()]) for which [wk_handle()] is defined.
#' @param n_segments,resolution The number of segments to use when approximating
#'   a circle. The default uses `getOption("wk.crc_n_segments")` so that
#'   this value can be set for implicit conversions (e.g., `as_wkb()`).
#'   Alternatively, set the minimum distance between points on the circle
#'   (used to estimate `n_segments`). The default is obtained
#'   using `getOption("wk.crc_resolution")`.
#' @param ... Passed to the [wk_handle()] method.
#'
#' @return A WK handler.
#' @export
#'
wk_handle <- function(handleable, handler, ...) {
  UseMethod("wk_handle")
}

#' @rdname wk_handle
#' @export
is_handleable <- function(handleable) {
  force(handleable)
  # use vector_meta because it doesn't ever iterate over an entire vector
  tryCatch({wk_vector_meta(handleable); TRUE}, error = function(e) FALSE)
}

#' @rdname wk_handle
#' @export
new_wk_handler <- function(handler_ptr, subclass = character()) {
  stopifnot(typeof(handler_ptr) == "externalptr")
  structure(handler_ptr, class = union(subclass, "wk_handler"))
}

#' @rdname wk_handle
#' @export
is_wk_handler <- function(handler) {
  inherits(handler, "wk_handler")
}

#' @rdname wk_handle
#' @export
as_wk_handler <- function(handler, ...) {
  if (is.function(handler)) {
    handler()
  } else if (is_wk_handler(handler)) {
    handler
  } else {
    stop("`handler` must be a wk handler object",  call. = FALSE)
  }
}

#' @export
print.wk_handler <- function(x, ...) {
  cat(sprintf("<%s at %s>\n", class(x)[1], .Call(wk_c_handler_addr, x)))
  invisible(x)
}

#' Validate well-known binary and well-known text
#'
#' The problems handler returns a character vector of parse
#' errors and can be used to validate input of any type
#' for which [wk_handle()] is defined.
#'
#' @inheritParams wk_handle
#'
#' @return A character vector of parsing errors. `NA` signifies
#'   that there was no parsing error.
#' @export
#'
#' @examples
#' wk_problems(new_wk_wkt(c("POINT EMTPY", "POINT (20 30)")))
#' wk_handle(
#'   new_wk_wkt(c("POINT EMTPY", "POINT (20 30)")),
#'   wk_problems_handler()
#' )
#'
wk_problems <- function(handleable, ...) {
  wk_handle(handleable, wk_problems_handler(), ...)
}

#' @rdname wk_problems
#' @export
wk_problems_handler <- function() {
  new_wk_handler(.Call(wk_c_problems_handler_new), "wk_problems_handler")
}

#' @rdname wk_handle
#' @export
wk_handle.wk_crc <- function(handleable, handler, ...,
                             n_segments = getOption("wk.crc_n_segments", NULL),
                             resolution = getOption("wk.crc_resolution", NULL)) {
  if (is.null(n_segments) && is.null(resolution)) {
    n_segments <- 100L
  } else if (is.null(n_segments)) {
    n_segments <- ceiling(2 * pi / (resolution / unclass(handleable)$r))
  }

  n_segments <- as.integer(pmax(4L, n_segments))
  n_segments[is.na(n_segments)] <- 4L

  if ((length(n_segments) != 1) && (length(n_segments) != length(handleable))) {
    stop(
      sprintf(
        "`n_segments`/`resolution` must be length 1 or length of data (%s)",
        length(handleable)
      ),
      call. = FALSE
    )
  }

  handler <- as_wk_handler(handler)
  .Call(wk_c_read_crc, handleable, handler, n_segments)
}

#' Count geometry components
#'
#' Counts the number of geometries, rings, and coordinates found within
#' each feature. As opposed to [wk_meta()], this handler will iterate
#' over the entire geometry.
#'
#' @inheritParams wk_handle
#'
#' @return A data.frame with one row for every feature encountered and
#'   columns:
#'   - `n_geom`: The number of geometries encountered, including the
#'     root geometry. Will be zero for a null feature.
#'   - `n_ring`: The number of rings encountered. Will be zero for a
#'     null feature.
#'   - `n_coord`: The number of coordinates encountered. Will be zero
#'     for a null feature.
#' @export
#'
#' @examples
#' wk_count(as_wkt("LINESTRING (0 0, 1 1)"))
#' wk_count(as_wkb("LINESTRING (0 0, 1 1)"))
#'
wk_count <- function(handleable, ...) {
  UseMethod("wk_count")
}

#' @rdname wk_count
#' @export
wk_count.default <- function(handleable, ...) {
  new_data_frame(wk_handle(handleable, wk_count_handler(), ...))
}

#' @rdname wk_count
#' @export
wk_count_handler <- function() {
  new_wk_handler(.Call(wk_c_count_handler_new), "wk_count_handler")
}

#' Subset grid objects
#'
#' The [grd_subset()] method handles the subsetting of a [grd()]
#' in x-y space. Ordering of indices is not considered and logical
#' indies are recycled silently along dimensions. The result of
#' a [grd_subset()] is always a [grd()] of the same type whose
#' relationship to x-y space has not changed.
#'
#' @inheritParams grd_cell
#' @inheritParams grd_summary
#' @param grid_data The `data` member of a [grd()]. This is typically an
#'   array but can also be an S3 object with an array-like subset method.
#'   The [native raster][grDevices::as.raster] is special-cased as its
#'   subset method requires non-standard handling.
#' @param i,j 1-based index values. `i` indices correspond to decreasing
#'   `y` values; `j` indices correspond to increasing `x` values.
#'   Values outside the range `1:nrow|ncol(data)` will be censored to
#'   `NA` including 0 and negative values.
#' @param ... Passed to subset methods
#'
#' @return A modified `grid` whose cell centres have not changed location
#'   as a result of the subset.
#' @export
#'
#' @examples
#' grid <- grd_rct(volcano)
#' grd_subset(grid, 1:20, 1:30)
#' grd_crop(grid, rct(-10, -10, 10, 10))
#' grd_extend(grid, rct(-10, -10, 10, 10))
#'
grd_subset <- function(grid, i = NULL, j = NULL, ...) {
  UseMethod("grd_subset")
}

#' @rdname grd_subset
#' @export
grd_crop <- function(grid, bbox, ..., step = 1L, snap = NULL) {
  UseMethod("grd_crop")
}

#' @rdname grd_subset
#' @export
grd_extend <- function(grid, bbox, ..., step = 1L, snap = NULL) {
  UseMethod("grd_extend")
}

#' @export
grd_subset.wk_grd_rct <- function(grid, i = NULL, j = NULL, ...) {
  grd_subset_grd_internal(grid, i, j)
}

#' @export
grd_subset.wk_grd_xy <- function(grid, i = NULL, j = NULL, ...) {
  grd_subset_grd_internal(grid, i, j)
}

grd_subset_grd_internal <- function(grid, i = NULL, j = NULL) {
  ij <- ij_from_args(i, j)

  # convert i and j into start, stop, step
  i <- ij_to_slice_one(ij$i, dim(grid)[1])
  j <- ij_to_slice_one(ij$j, dim(grid)[2])

  # calculate bbox
  s <- grd_summary(grid)
  dx <- unname(j["step"] * s$dx)
  dy <- unname(i["step"] * s$dy)
  center_min <- unclass(grd_cell_xy(grid, i["stop"], j["start"] + 1L))
  center_max <- unclass(grd_cell_xy(grid, i["start"] + 1L, j["stop"]))
  rct_new <- list(
    xmin = center_min$x, ymin = center_min$y,
    xmax = center_max$x, ymax = center_max$y
  )

  # check for empty subsets in both directions
  if (!is.finite(rct_new$xmax - rct_new$xmin)) {
    rct_new$xmin <- Inf
    rct_new$xmax <- -Inf
  } else if (inherits(grid, "wk_grd_rct")) {
    rct_new$xmin <- rct_new$xmin - dx / 2
    rct_new$xmax <- rct_new$xmax + dx / 2
  }

  if (!is.finite(rct_new$ymax - rct_new$ymin)) {
    rct_new$ymin <- Inf
    rct_new$ymax <- -Inf
  } else if (inherits(grid, "wk_grd_rct")) {
    rct_new$ymin <- rct_new$ymin - dy / 2
    rct_new$ymax <- rct_new$ymax + dy / 2
  }

  grid$data <- grd_data_subset(grid$data, i, j)
  grid$bbox <- new_wk_rct(rct_new, crs = wk_crs(grid))
  grid
}

#' @rdname grd_subset
#' @export
grd_crop.wk_grd_rct <- function(grid, bbox, ..., step = 1L, snap = NULL) {
  snap <- snap %||% list(grd_snap_next, grd_snap_previous)
  ij <- grd_cell_range(grid, bbox, step = step, snap = snap)

  ij$i["start"] <- max(ij$i["start"], 0L)
  ij$i["stop"] <- min(ij$i["stop"], dim(grid)[1])
  ij$j["start"] <- max(ij$j["start"], 0L)
  ij$j["stop"] <- min(ij$j["stop"], dim(grid)[2])

  grd_subset(grid, ij)
}

#' @rdname grd_subset
#' @export
grd_crop.wk_grd_xy <- function(grid, bbox, ..., step = 1L, snap = NULL) {
  snap <- snap %||% list(ceiling, floor)
  ij <- grd_cell_range(grid, bbox, step = step, snap = snap)

  ij$i["start"] <- max(ij$i["start"], 0L)
  ij$i["stop"] <- min(ij$i["stop"], dim(grid)[1])
  ij$j["start"] <- max(ij$j["start"], 0L)
  ij$j["stop"] <- min(ij$j["stop"], dim(grid)[2])

  grd_subset(grid, ij)
}

#' @rdname grd_subset
#' @export
grd_extend.wk_grd_rct <- function(grid, bbox, ..., step = 1L, snap = NULL) {
  snap <- snap %||% list(grd_snap_next, grd_snap_previous)
  grd_subset(grid, grd_cell_range(grid, bbox, step = step, snap = snap))
}

#' @rdname grd_subset
#' @export
grd_extend.wk_grd_xy <- function(grid, bbox, ...,  step = 1L, snap = NULL) {
  snap <- snap %||% list(ceiling, floor)
  grd_subset(grid, grd_cell_range(grid, bbox, step = step, snap = snap))
}

#' @rdname grd_subset
#' @export
grd_data_subset <- function(grid_data, i = NULL, j = NULL) {
  ij <- ij_from_args(i, j)
  ij$i <- ij_expand_one(ij$i, dim(grid_data)[1], out_of_bounds = "censor")
  ij$j <- ij_expand_one(ij$j, dim(grid_data)[2], out_of_bounds = "censor")

  if (inherits(grid_data, "nativeRaster")) {
    # special case the nativeRaster, whose dims are lying about
    # the ordering needed to index it
    attrs <- attributes(grid_data)
    dim(grid_data) <- rev(dim(grid_data))
    grid_data <- grid_data[ij$j, ij$i, drop = FALSE]
    attrs$dim <- rev(dim(grid_data))
    attributes(grid_data) <- attrs
    grid_data
  } else {
    # we want to keep everything for existing dimensions
    # this means generating a list of missings to fill
    # the correct number of additional dimensions
    n_more_dims <- length(dim(grid_data)) - 2L
    more_dims <- alist(1, )[rep(2, n_more_dims)]
    do.call("[", c(list(grid_data, ij$i, ij$j), more_dims, list(drop = FALSE)))
  }
}

#' Grid cell operators
#'
#' @inheritParams grd_summary
#' @inheritParams grd_subset
#' @param bbox An [rct()] object.
#' @param out_of_bounds One of 'keep', 'censor', 'discard', or 'squish'
#' @param step The difference between adjascent indices in the output
#' @param point A [handleable][wk_handle] of points.
#' @param snap A function that transforms real-valued indices to integer
#'   indices (e.g., [floor()], [ceiling()], or [round()]).
#'   For [grd_cell_range()], a `list()` with exactly two elements to be called
#'   for the minimum and maximum index values, respectively.
#' @param ... Unused
#'
#' @return
#'   - `grd_cell()`: returns a `list(i, j)` of index values corresponding
#'     to the input points and adjusted according to `snap`. Index values
#'     will be outside `dim(grid)` for points outside `wk_bbox(grid)` including
#'     negative values.
#'   - `grd_cell_range()` returns a slice describing the range of indices
#'     in the `i` and `j` directions.
#'   - `grd_cell_rct()` returns a [rct()] of the cell extent at `i, j`.
#'   - `grd_cell_xy()` returns a [xy()] of the cell center at `i, j`.
#' @export
#'
#' @examples
#' grid <- grd(nx = 3, ny = 2)
#' grd_cell(grid, xy(0.5, 0.5))
#' grd_cell_range(grid, grid$bbox)
#' grd_cell_rct(grid, 1, 1)
#' grd_cell_xy(grid, 1, 1)
#'
grd_cell <- function(grid, point, ..., snap = grd_snap_next) {
  UseMethod("grd_cell")
}

#' @export
grd_cell.wk_grd_rct <- function(grid, point, ..., snap = grd_snap_next) {
  s <- grd_summary(grid)
  point <- unclass(as_xy(point))
  i <- if (s$width == -Inf) rep(NA_real_, length(point$x)) else (s$ymax - point$y) / s$dy
  j <- if (s$height == -Inf) rep(NA_real_, length(point$x)) else (point$x - s$xmin) / s$dx
  new_data_frame(list(i = unname(snap(i - 0.5) + 1L), j = unname(snap(j - 0.5) + 1L)))
}

#' @export
grd_cell.wk_grd_xy <- function(grid, point, ..., snap = grd_snap_next) {
  grd_cell(as_grd_rct(grid), point, snap = snap)
}

#' @rdname grd_cell
#' @export
grd_cell_range <- function(grid, bbox = wk_bbox(grid), ..., step = 1L, snap = grd_snap_next) {
  UseMethod("grd_cell_range")
}

#' @export
grd_cell_range.default <- function(grid, bbox = wk_bbox(grid), ..., step = 1L, snap = grd_snap_next) {
  # normalized so that xmin < xmax, ymin < ymax
  if (inherits(bbox, "wk_rct")) {
    bbox <- wk_bbox(as_wkb(bbox))
  } else {
    bbox <- wk_bbox(bbox)
  }

  # step can be length to for i, j steps
  if (length(step) == 1L) {
    step <- step[c(1L, 1L)]
  }

  if (is.function(snap)) {
    snap <- list(snap, snap)
  }

  indices <- grd_cell(grid, as_xy(wk_vertices(bbox)))

  # return a consistent value for an empty grid subset
  s <- grd_summary(grid)
  rct_target <- unclass(bbox)
  rct_target_width <- rct_target$xmax - rct_target$xmin
  rct_target_height <- rct_target$ymax - rct_target$ymin

  indices_min <- grd_cell(grid, xy(rct_target$xmin, rct_target$ymax), snap = snap[[1]])
  indices_max <- grd_cell(grid, xy(rct_target$xmax, rct_target$ymin), snap = snap[[2]])

  if (rct_target_height == -Inf || s$height == -Inf) {
    i <- integer()
  } else {
    i <- c(start = indices_min$i - 1L, stop = indices_max$i, step = 1L)
  }

  if (rct_target_width == -Inf || s$width == -Inf) {
    j <- integer()
  } else {
    j <- c(start = indices_min$j - 1L, stop = indices_max$j, step = 1L)
  }

  # process downsample if requested
  if (!identical(step, c(1L, 1L))) {
    n <- c(0L, 0L)
    if (!identical(i, integer())) {
      n[1] <- i["stop"] - i["start"]
    }

    if (!identical(j, integer())) {
      n[2] <- j["stop"] - j["start"]
    }

    step <- pmin(n, pmax(1L, step))

    if (!identical(i, integer())) {
      i["step"] <- step[1]
      i["start"] <- i["start"] + (step[1] %/% 2L)
      i["stop"] <- i["stop"] - ((step[1] + 1L) %/% 2L)
    }

    if (!identical(j, integer())) {
      j["step"] <- step[2]
      j["start"] <- j["start"] + (step[2] %/% 2L)
      j["stop"] <- j["stop"] - ((step[2] + 1L) %/% 2L)
    }
  }

  list(i = i, j = j)
}

#' @rdname grd_cell
#' @export
grd_cell_rct <- function(grid, i, j = NULL, ...) {
  UseMethod("grd_cell_rct")
}

#' @rdname grd_cell
#' @export
grd_cell_rct.wk_grd_rct <- function(grid, i, j = NULL, ..., out_of_bounds = "keep") {
  s <- grd_summary(grid)

  # non-numeric values don't make sense here because i and j are vectorized
  # instead of crossed to form the final values
  ij <- ij_from_args(i, j)
  if (!is.numeric(ij$i) || !is.numeric(ij$j)) {
    stop("`i` and `j` must be numeric index vectors in grd_cell_rct()")
  }

  # recycle to a common length
  ij[] <- recycle_common(ij$i, ij$j)

  # handle out_of_bounds
  ij <- ij_handle_out_of_bounds2(ij, list(s$ny, s$nx), out_of_bounds)

  xmin <- s$xmin + (ij$j - 1) * s$dx
  xmax <- s$xmin + ij$j * s$dx
  ymin <- s$ymax - ij$i * s$dy
  ymax <- s$ymax - (ij$i - 1) * s$dy

  rct(xmin, ymin, xmax, ymax, crs = wk_crs(grid))
}

#' @rdname grd_cell
#' @export
grd_cell_rct.wk_grd_xy <- function(grid, i, j = NULL, ..., out_of_bounds = "keep") {
  grd_cell_rct(as_grd_rct(grid), i, j, out_of_bounds = out_of_bounds)
}

#' @rdname grd_cell
#' @export
grd_cell_xy <- function(grid, i, j = NULL, ...) {
  UseMethod("grd_cell_xy")
}

#' @rdname grd_cell
#' @export
grd_cell_xy.wk_grd_rct <- function(grid, i, j = NULL, ..., out_of_bounds = "keep") {
  s <- grd_summary(grid)

  # non-numeric values don't make sense here because i and j are vectorized
  # instead of crossed to form the final values
  ij <- ij_from_args(i, j)
  if (!is.numeric(ij$i) || !is.numeric(ij$j)) {
    stop("`i` and `j` must be numeric index vectors in grd_cell_rct()")
  }

  # recycle to a common length
  ij[] <- recycle_common(ij$i, ij$j)

  # handle out_of_bounds
  ij <- ij_handle_out_of_bounds2(ij, list(s$ny, s$nx), out_of_bounds)

  x <- s$xmin + (ij$j - 1) * s$dx + s$dx / 2
  y <- s$ymax - (ij$i - 1) * s$dy - s$dy / 2

  xy(x, y, crs = wk_crs(grid))
}

#' @rdname grd_cell
#' @export
grd_cell_xy.wk_grd_xy <- function(grid, i, j = NULL, ..., out_of_bounds = "keep") {
  grd_cell_xy(as_grd_rct(grid), i, j, out_of_bounds = out_of_bounds)
}


ij_from_args <- function(i, j = NULL) {
  if (is.null(i) && is.null(j)) {
    list(i = NULL, j = NULL)
  } else if (is.null(j) && is.list(i)) {
    i
  } else {
    list(i = i, j = j)
  }
}

ij_expand_one <- function(i, n, out_of_bounds = "keep") {
  if (is.null(i)) {
    i <- if (n > 0) seq(1L, n) else integer()
  } else if (identical(names(i), c("start", "stop", "step"))) {
    value_na <- is.na(i)
    i[value_na] <- c(0L, n, 1L)[value_na]
    if (i["stop"] > i["start"]) {
      i <- unname(seq(i["start"] + 1L, i["stop"], by = i["step"]))
    } else {
      i <- integer()
    }
  } else if (is.numeric(i)) {
    i <- i
  } else {
    stop(
      "index vectors must be NULL, numeric, or c(start = , stop =, step =)",
      call. = FALSE
    )
  }

  if (out_of_bounds == "censor") {
    i[(i > n) | (i < 1)] <- NA_integer_
  } else if (out_of_bounds == "keep") {
    # do nothing
  } else if (out_of_bounds == "discard") {
    i <- i[(i <= n) & (i >= 1)]
  } else if (out_of_bounds == "squish") {
    i[i < 1L] <- 1L
    i[i > n] <- n
  } else {
    stop(
      "`out_of_bounds` must be one of 'censor', 'keep', 'discard', or 'squish'",
      call. = FALSE
    )
  }

  i
}

ij_to_slice_one <- function(i, n) {
  if (is.null(i)) {
    i <- if (n == 0L) integer() else c(start = 0L, stop = n, step = 1L)
  } else if (identical(names(i), c("start", "stop", "step"))) {
    value_na <- is.na(i)
    i[value_na] <- c(0L, n, 1L)[value_na]
    i <- if (i["start"] >= i["stop"]) integer() else i
  } else if (is.numeric(i)) {
    if (length(i) == 0L) {
      i <- integer()
    } else if ((length(i) == 1L) && is.finite(i)) {
      i <- c(start = i - 1L, stop = i, step = 1L)
    } else {
      if (any(!is.finite(i))) {
        stop("numeric index vectors must be finite in `grd_subset()`", call. = FALSE)
      }

      step <- unique(diff(i))
      if ((length(step) != 1) || (step <= 0)) {
        stop("numeric index vectors must be equally spaced and ascending", call. = FALSE)
      }

      i <- c(start = min(i) - 1L, stop = max(i), step = step)
    }
  } else {
    stop(
      "index vectors must be NULL, numeric, or c(start = , stop =, step =)",
      call. = FALSE
    )
  }

  i
}

# used by extractors to handle out-of-bounds points and/or cells
ij_handle_out_of_bounds2 <- function(ij, n, out_of_bounds) {
  if (out_of_bounds == "keep") {
    return(ij)
  }

  oob_i <- !is.na(ij$i) & ((ij$i > n[[1]]) | (ij$i < 1L))
  oob_j <- !is.na(ij$j) & ((ij$j > n[[2]]) | (ij$j < 1L))
  oob_either <- oob_i | oob_j
  if (!any(oob_either)) {
    return(ij)
  }

  if (out_of_bounds == "censor") {
    ij$i[oob_either] <- NA_integer_
    ij$j[oob_either] <- NA_integer_
  } else if (out_of_bounds == "discard") {
    ij$i <- ij$i[!oob_either]
    ij$j <- ij$j[!oob_either]
  } else if (out_of_bounds == "squish") {
    ij$i[!is.na(ij$i) & (ij$i < 1L)] <- 1L
    ij$j[!is.na(ij$j) & (ij$j < 1L)] <- 1L
    ij$i[!is.na(ij$i) & (ij$i > n[[1]])] <- n[[1]]
    ij$j[!is.na(ij$j) & (ij$j > n[[2]])] <- n[[2]]
  } else {
    stop(
      "`out_of_bounds` must be one of 'censor', 'keep', 'discard', or 'squish'",
      call. = FALSE
    )
  }

  ij
}

#' Index snap functions
#'
#' These functions can be used in [grd_cell()] and
#' [grd_cell_range()]. These functions differ in the way
#' they round 0.5: [grd_snap_next()] always rounds up
#' and [grd_snap_previous()] always rounds down. You can
#' also use [floor()] and [ceiling()] as index
#' snap functions.
#'
#' @param x A vector of rescaled but non-integer indices
#'
#' @return A vector of integer indices
#' @export
#'
#' @examples
#' grd_snap_next(seq(0, 2, 0.25))
#' grd_snap_previous(seq(0, 2, 0.25))
#'
grd_snap_next <- function(x) {
  ifelse(((x + 0.5) %% 1L) == 0, ceiling(x), round(x))
}

#' @rdname grd_snap_next
#' @export
grd_snap_previous <- function(x) {
  ifelse(((x + 0.5) %% 1L) == 0, floor(x), round(x))
}

#' Use data.frame with wk
#'
#' @inheritParams wk_handle
#' @inheritParams wk_crs
#' @inheritParams wk_translate
#' @inheritParams wk_identity
#' @inheritParams wk_is_geodesic
#'
#' @export
#'
#' @examples
#' wk_handle(data.frame(a = wkt("POINT (0 1)")), wkb_writer())
#' wk_translate(wkt("POINT (0 1)"), data.frame(col_name = wkb()))
#' wk_translate(data.frame(a = wkt("POINT (0 1)")), data.frame(wkb()))
#'
wk_handle.data.frame <- function(handleable, handler, ...) {
  col <- handleable_column_name(handleable)
  wk_handle(handleable[[col]], handler, ...)
}

#' @export
wk_writer.data.frame <- function(handleable, ...) {
  col <- handleable_column_name(handleable)
  wk_writer(handleable[[col]], ...)
}

#' @export
wk_crs.data.frame <- function(x) {
  col <- handleable_column_name(x)
  wk_crs(x[[col]])
}

#' @export
wk_set_crs.data.frame <- function(x, crs) {
  col <- handleable_column_name(x)
  x[[col]] <- wk_set_crs(x[[col]], crs)
  x
}

#' @export
wk_is_geodesic.data.frame <- function(x) {
  col <- handleable_column_name(x)
  wk_is_geodesic(x[[col]])
}

#' @export
wk_set_geodesic.data.frame <- function(x, geodesic) {
  col <- handleable_column_name(x)
  x[[col]] <- wk_set_geodesic(x[[col]], geodesic)
  x
}

#' @rdname wk_handle.data.frame
#' @export
wk_restore.data.frame <- function(handleable, result, ...) {
  col <- handleable_column_name(handleable)
  if(nrow(handleable) == length(result)) {
    handleable[[col]] <- result
    handleable
  } else if (nrow(handleable) == 1) {
    handleable <- handleable[rep(1L, length(result)), , drop = FALSE]
    handleable[[col]] <- result
    handleable
  } else {
    stop(
      sprintf(
        "Can't assign result of length %d to data frame with %d rows",
        length(result), nrow(handleable)
      ),
      call. = FALSE
    )
  }
}

#' @rdname wk_handle.data.frame
#' @export
wk_restore.tbl_df <- function(handleable, result, ...) {
  tibble::as_tibble(wk_restore.data.frame(handleable, result, ...))
}

#' @rdname wk_handle.data.frame
#' @export
wk_translate.data.frame <- function(handleable, to, ...) {
  col <- handleable_column_name(to)
  col_value <- wk_translate(handleable, to[[col]], ...)

  if (inherits(handleable, "data.frame")) {
    handleable_col <- handleable_column_name(handleable)
    attributes(handleable) <- list(names = names(handleable))
    handleable[handleable_col] <- list(col_value)
    new_data_frame(handleable)
  } else {
    df_raw <- list(col_value)
    names(df_raw) <- col
    new_data_frame(df_raw)
  }
}

#' @rdname wk_handle.data.frame
#' @export
wk_translate.tbl_df <- function(handleable, to, ...) {
  tibble::as_tibble(wk_translate.data.frame(handleable, to, ...))
}

#' @rdname wk_handle_slice
#' @export
wk_handle_slice.data.frame <- function(handleable, handler,
                                       from = NULL, to = NULL, ...) {
  handleable_col <- handleable_column_name(handleable)
  wk_handle_slice(
    handleable[[handleable_col]], handler,
    from = from,
    to = to,
    ...
  )
}

handleable_column_name <- function(df) {
  has_method <- vapply(df, is_handleable, FUN.VALUE = logical(1))

  if (!any(has_method)) {
    stop(
      "To be used with wk_handle(), a data.frame must have at least one handleable column.",
      call. = FALSE
    )
  }

  names(df)[which(has_method)[1L]]
}

#' Set coordinate values
#'
#' @inheritParams wk_handle
#' @param z,m A vector of Z or M values applied feature-wise and recycled
#'    along `handleable`. Use `NA` to keep the existing value of a given
#'    feature.
#' @param value An [xy()], [xyz()], [xym()], or [xyzm()] of coordinates
#'   used to replace values in the input. Use `NA` to keep the existing
#'   value.
#' @param use_z,use_m Used to declare the output type. Use `TRUE` to
#'   ensure the output has that dimension, `FALSE` to ensure it does not,
#'   and `NA` to leave the dimension unchanged.
#'
#' @export
#'
#' @examples
#' wk_set_z(wkt("POINT (0 1)"), 2)
#' wk_set_m(wkt("POINT (0 1)"), 2)
#' wk_drop_z(wkt("POINT ZM (0 1 2 3)"))
#' wk_drop_m(wkt("POINT ZM (0 1 2 3)"))
#'
wk_set_z <- function(handleable, z, ...) {
  wk_set_base(handleable, wk_trans_set(xyz(NA, NA, z), use_z = TRUE), ...)
}

#' @rdname wk_set_z
#' @export
wk_set_m <- function(handleable, m, ...) {
  wk_set_base(handleable, wk_trans_set(xym(NA, NA, m), use_m = TRUE), ...)
}

#' @rdname wk_set_z
#' @export
wk_drop_z <- function(handleable, ...) {
  wk_set_base(handleable, wk_trans_set(xy(NA, NA), use_z = FALSE), ...)
}

#' @rdname wk_set_z
#' @export
wk_drop_m <- function(handleable, ...) {
  wk_set_base(handleable, wk_trans_set(xy(NA, NA), use_m = FALSE), ...)
}

#' @rdname wk_set_z
#' @export
wk_trans_set <- function(value, use_z = NA, use_m = NA) {
  value <- as_xy(value)
  value <- as_xy(value, dims = c("x", "y", "z", "m"))
  new_wk_trans(
    .Call(wk_c_trans_set_new, value, as.logical(use_z)[1], as.logical(use_m)[1]),
    "wk_trans_set"
  )
}

wk_set_base <- function(handleable, trans, ...) {
  result <- wk_handle(handleable, wk_transform_filter(wk_writer(handleable), trans), ...)
  wk_set_crs(wk_restore(handleable, result), wk_crs(handleable))
}

#' Extract vertices
#'
#' These functions provide ways to extract individual coordinate values.
#' Whereas `wk_vertices()` returns a vector of coordinates as in the same
#' format as the input, `wk_coords()` returns a data frame with coordinates
#' as columns.
#'
#' `wk_coords<-` is the replacement-function version of 'wk_coords'.
#' Using the engine of [wk_trans_explicit()] the coordinates of an object
#' can be transformed in a generic way using R functions as needed.
#'
#' @inheritParams wk_handle
#' @param add_details Use `TRUE` to add a "wk_details" attribute, which
#'   contains columns `feature_id`, `part_id`, and `ring_id`.
#' @inheritParams wk_trans_set
#'
#' @return
#'   - `wk_vertices()` extracts vertices and returns the in the same format as
#'     the handler
#'   - `wk_coords()` returns a data frame with columns columns `feature_id`
#'     (the index of the feature from whence it came), `part_id` (an arbitrary
#'     integer identifying the point, line, or polygon from whence it came),
#'     `ring_id` (an arbitrary integer identifying individual rings within
#'     polygons), and one column per coordinate (`x`, `y`, and/or `z` and/or `m`).
#' @export
#'
#' @examples
#' wk_vertices(wkt("LINESTRING (0 0, 1 1)"))
#' wk_coords(wkt("LINESTRING (0 0, 1 1)"))
#'
#' # wk_coords() replacement function
#' x <- xy(1:5, 1:5)
#' y <- as_wkt(x)
#' wk_coords(y) <- cbind(5:1, 0:4)
#' wk_coords(x) <- y[5:1]
#' y
#' x
#'
wk_vertices <- function(handleable, ...) {
  # the results of this handler are not necessarily the same length as the input,
  # so we need to special-case data frames
  if (is.data.frame(handleable))  {
    result <- wk_handle(
      handleable,
      wk_vertex_filter(wk_writer(handleable), add_details = TRUE),
      ...
    )
    feature_id <- attr(result, "wk_details", exact = TRUE)$feature_id
    attr(result, "wk_details") <- NULL
    result <- wk_restore(handleable[feature_id, , drop = FALSE], result, ...)
  } else {
    result <- wk_handle(handleable, wk_vertex_filter(wk_writer(handleable, generic = TRUE)), ...)
    result <- wk_restore(handleable, result, ...)
  }

  wk_set_crs(result, wk_crs(handleable))
}

#' @rdname wk_vertices
#' @export
wk_coords <- function(handleable, ...) {
  UseMethod("wk_coords")
}

#' @export
wk_coords.default <- function(handleable, ...) {
  result <- wk_handle(
    handleable,
    wk_vertex_filter(xy_writer(), add_details = TRUE),
    ...
  )

  details <- attr(result, "wk_details", exact = TRUE)
  attr(result, "wk_details") <- NULL
  new_data_frame(c(details, unclass(result)))
}

#' @rdname wk_vertices
#' @export
`wk_coords<-` <- function(handleable, use_z = NA, use_m = NA, value) {
  wk_transform(handleable, wk_trans_explicit(value, use_z = use_z, use_m = use_m))
}

#' @rdname wk_vertices
#' @export
wk_vertex_filter <- function(handler, add_details = FALSE) {
  new_wk_handler(
    .Call("wk_c_vertex_filter_new", as_wk_handler(handler), as.logical(add_details)[1]),
    "wk_vertex_filter"
  )
}

#' @export
wk_coords.wk_xy <- function(handleable, ...) {
  feature_id <- seq_along(handleable)
  is_na <- Reduce("&", lapply(unclass(handleable), is.na))
  has_coord <- !is_na

  if (!all(has_coord)) {
    handleable <- handleable[has_coord]
    feature_id <- feature_id[has_coord]
  }

  new_data_frame(
    c(
      list(
        feature_id = feature_id,
        part_id = feature_id,
        ring_id = rep_len(0L, length(feature_id))
      ),
      unclass(handleable)
    )
  )
}

#' Mark lists of raw vectors as well-known binary
#'
#' @param x A [list()] of [raw()] vectors or `NULL`.
#' @inheritParams new_wk_wkb
#' @param ... Unused
#'
#' @return A [new_wk_wkb()]
#' @export
#'
#' @examples
#' as_wkb("POINT (20 10)")
#'
wkb <- function(x = list(), crs = wk_crs_auto(), geodesic = FALSE) {
  crs <- wk_crs_auto_value(x, crs)
  attributes(x) <- NULL
  wkb <- new_wk_wkb(x, crs = crs, geodesic = geodesic_attr(geodesic))
  validate_wk_wkb(wkb)
  wkb
}

#' @rdname wkb
#' @export
parse_wkb <- function(x, crs = wk_crs_auto(), geodesic = FALSE) {
  crs <- wk_crs_auto_value(x, crs)
  attributes(x) <- NULL
  wkb <- new_wk_wkb(x, crs = crs, geodesic = geodesic_attr(geodesic))
  parse_base(wkb, wk_problems(wkb))
}

#' @rdname wkb
#' @export
wk_platform_endian <- function() {
  match(.Platform$endian, c("big", "little")) - 1L
}

#' @rdname wkb
#' @export
as_wkb <- function(x, ...) {
  UseMethod("as_wkb")
}

#' @rdname wkb
#' @export
as_wkb.default <- function(x, ...) {
  wk_translate(
    x,
    new_wk_wkb(crs = wk_crs_inherit(), geodesic = wk_geodesic_inherit()),
    ...
  )
}

#' @rdname wkb
#' @export
as_wkb.character <- function(x, ..., crs = NULL, geodesic = FALSE) {
  as_wkb(wkt(x, crs = crs, geodesic = geodesic), ...)
}

#' @rdname wkb
#' @export
as_wkb.wk_wkb <- function(x, ...) {
  x
}

#' @rdname wkb
#' @export
as_wkb.blob <- function(x, ..., crs = NULL, geodesic = FALSE) {
  as_wkb(wkb(x, crs = crs, geodesic = geodesic), ...)
}

#' @rdname wkb
#' @export
as_wkb.WKB <- function(x, ..., crs = NULL, geodesic = FALSE) {
  as_wkb(wkb(x, crs = crs, geodesic = geodesic), ...)
}

#' S3 Details for wk_wkb
#'
#' @param x A (possibly) [wkb()] vector
#' @param crs A value to be propagated as the CRS for this vector.
#' @inheritParams wk_is_geodesic
#'
#' @export
#'
new_wk_wkb <- function(x = list(), crs = NULL, geodesic = NULL) {
  if (typeof(x) != "list" || !is.null(attributes(x))) {
    stop("wkb input must be a list without attributes",  call. = FALSE)
  }

  structure(x, class = c("wk_wkb", "wk_vctr"), crs = crs, geodesic = geodesic)
}

#' @rdname new_wk_wkb
#' @export
validate_wk_wkb <- function(x) {
  if (typeof(x) != "list") {
    stop("wkb() must be of type list()", call. = FALSE)
  }

  good_types <- .Call(wk_c_wkb_is_raw_or_null, x)
  if (!all(good_types)) {
    stop("items in wkb input must be raw() or NULL", call. = FALSE)
  }

  if (!inherits(x, "wk_wkb") || !inherits(x, "wk_vctr")) {
    attributes(x) <- NULL
    problems <- wk_problems(new_wk_wkb(x))
  } else {
    problems <- wk_problems(x)
  }

  stop_for_problems(problems)

  invisible(x)
}

#' @rdname new_wk_wkb
#' @export
is_wk_wkb <- function(x) {
  inherits(x, "wk_wkb")
}

#' @export
`[<-.wk_wkb` <- function(x, i, value) {
  replacement <- as_wkb(value)
  crs_out <- wk_crs_output(x, replacement)
  geodesic_out <- wk_is_geodesic_output(x, replacement)
  x <- unclass(x)
  x[i] <- replacement
  attr(x, "crs") <- NULL
  attr(x, "geodesic") <- NULL
  new_wk_wkb(x, crs = crs_out, geodesic = geodesic_attr(geodesic_out))
}

#' @export
is.na.wk_wkb <- function(x) {
  .Call(wk_c_wkb_is_na, x)
}

#' @export
format.wk_wkb <- function(x, ...) {
  paste0("<", wk_format(x), ">")
}

# as far as I can tell, this is the only way to change
# how the object appears in the viewer
#' @export
as.character.wk_wkb <- function(x, ...) {
  format(x, ...)
}


#' Convert well-known binary to hex
#'
#' @param x A [wkb()] vector
#'
#' @return A hex encoded [wkb()] vector
#' @export
#'
#' @examples
#' x <- as_wkb(xyz(1:5, 6:10, 11:15))
#' wkb_to_hex(x)
#'
wkb_to_hex <- function(x) {
  .Call(wk_c_wkb_to_hex, as_wkb(x))
}

#' Apply coordinate transformations
#'
#' @inheritParams wk_handle
#' @param trans An external pointer to a wk_trans object
#'
#' @export
#'
#' @examples
#' wk_transform(xy(0, 0), wk_affine_translate(2, 3))
#'
wk_transform <- function(handleable, trans, ...) {
  result <- wk_handle(
    handleable,
    wk_transform_filter(wk_writer(handleable), trans),
    ...
  )
  wk_restore(handleable, result, ...)
}

#' @rdname wk_transform
#' @export
wk_transform_filter <- function(handler, trans) {
  new_wk_handler(
    .Call(wk_c_trans_filter_new, as_wk_handler(handler), as_wk_trans(trans)),
    "wk_transform_filter"
  )
}

#' Generic transform class
#'
#' @param ... Passed to S3 methods
#' @param trans_ptr An external pointer to a wk_trans_t transform
#'   struct.
#' @param subclass An optional subclass to apply to the pointer
#' @param x An object to be converted to a transform.
#' @inheritParams wk_transform
#'
#' @export
#'
wk_trans_inverse <- function(trans, ...) {
  UseMethod("wk_trans_inverse")
}

#' @rdname wk_trans_inverse
#' @export
as_wk_trans <- function(x, ...) {
  UseMethod("as_wk_trans")
}

#' @rdname wk_trans_inverse
#' @export
as_wk_trans.wk_trans <- function(x, ...) {
  x
}

#' @rdname wk_trans_inverse
#' @export
new_wk_trans <- function(trans_ptr, subclass = character()) {
  stopifnot(typeof(trans_ptr) == "externalptr")
  structure(trans_ptr, class = union(subclass, "wk_trans"))
}

#' Extract values from a grid
#'
#' Unlike [grd_subset()], which subsets like a matrix, [grd_extract()] returns
#' values.
#'
#' @inheritParams grd_summary
#' @inheritParams grd_subset
#' @inheritParams grd_cell
#' @param i,j Index values as in [grd_subset()] except recycled to a common
#'   size.
#'
#' @return A matrix or vector with two fewer dimensions than the input.
#' @export
#'
grd_extract <- function(grid, i = NULL, j = NULL) {
  grd_data_extract(grid$data, i, j)
}

#' @rdname grd_extract
#' @export
grd_extract_nearest <- function(grid, point, out_of_bounds = c("censor", "squish")) {
  out_of_bounds <- match.arg(out_of_bounds)
  s <- grd_summary(grid)
  ij <- grd_cell(grid, point)
  ij <- ij_handle_out_of_bounds2(ij, list(s$ny, s$nx), out_of_bounds)
  grd_data_extract(grid$data, ij)
}

#' @rdname grd_extract
#' @export
grd_data_extract <- function(grid_data, i = NULL, j = NULL) {
  ij <- ij_from_args(i, j)

  # This doesn't make sense in this context where ij is more like a data.frame
  stopifnot(!is.null(ij$i), !is.null(ij$j))

  ij <- recycle_common(i = ij$i, j = ij$j)

  # Again, the nativeRaster is silently row-major
  if (inherits(grid_data, "nativeRaster")) {
    flat_index <- (ij$i - 1L) * dim(grid_data)[2] + (ij$j - 1L) + 1L
    return(array(grid_data[flat_index]))
  }

  # Only implemented for the first two dimensions right now
  if (length(dim(grid_data)) == 2L ||
      prod(dim(grid_data)) == prod(dim(grid_data)[1:2])) {
    flat_index <- (ij$j - 1L) * dim(grid_data)[1] + (ij$i - 1L) + 1L

    result <- array(grid_data[flat_index])

    # Restore missing dimensions
    dim(result) <- c(length(flat_index), dim(grid_data)[-c(1L, 2L)])
    result
  } else {
    stop("grd_data_extract() not implemented for non-matrix-like data")
  }
}

#' Plot grid objects
#'
#' @inheritParams wk_plot
#' @param image A raster or nativeRaster to pass to [graphics::rasterImage()].
#'   use `NULL` to do a quick-and-dirty rescale of the data such that the low
#'   value is black and the high value is white.
#' @param oversample A scale on the number of pixels on the device to use for
#'   sampling estimation of large raster values. Use `Inf` to disable.
#' @param border Color to use for polygon borders. Use `NULL` for the default
#'   and `NA` to skip plotting borders.
#' @param interpolate Use `TRUE` to perform interpolation between color values.
#'
#' @return `x`, invisibly.
#' @export
#' @importFrom graphics plot
#'
#' @examples
#' plot(grd_rct(volcano))
#' plot(grd_xy(volcano))
#'
plot.wk_grd_xy <- function(x, ...) {
  plot(as_xy(x), ...)
  invisible(x)
}

#' @rdname plot.wk_grd_xy
#' @export
plot.wk_grd_rct <- function(x, ...,
                         image = NULL,
                         interpolate = FALSE,
                         oversample = 4,
                         border = NA,
                         asp = 1, bbox = NULL, xlab = "", ylab = "",
                         add = FALSE) {
  if (!add) {
    bbox <- unclass(bbox)
    bbox <- bbox %||% unclass(wk_bbox(x))
    xlim <- c(bbox$xmin, bbox$xmax)
    ylim <- c(bbox$ymin, bbox$ymax)

    graphics::plot(
      numeric(0),
      numeric(0),
      xlim = xlim,
      ylim = ylim,
      xlab = xlab,
      ylab = ylab,
      asp = asp
    )
  }

  # empty raster can skip plotting
  rct <- unclass(x$bbox)
  if (identical(rct$xmax - rct$xmin, -Inf) || identical(rct$ymax - rct$ymin, -Inf)) {
    return(invisible(x))
  }

  # as.raster() takes care of the default details here
  # call with native = TRUE, but realize this isn't implemented
  # everywhere (so we may get a regular raster back)
  if (is.null(image)) {

    # calculate an image based on a potential downsampling of the original
    usr <- graphics::par("usr")
    x_downsample_step <- grd_calculate_plot_step(x, oversample = oversample, usr = usr)

    # if we're so zoomed out that nothing should be plotted, we are done
    if (any(is.na(x_downsample_step))) {
      return(invisible(x))
    }

    x_downsample <- grd_crop(
      x,
      rct(usr[1], usr[3], usr[2], usr[4], crs = wk_crs(x)),
      step = x_downsample_step
    )

    # update bbox with cropped version and check for empty result
    rct <- unclass(x_downsample$bbox)
    if (identical(rct$xmax - rct$xmin, -Inf) || identical(rct$ymax - rct$ymin, -Inf)) {
      return(invisible(x))
    }

    image <- as.raster(x_downsample, native = TRUE)
  }

  if (!inherits(image, "nativeRaster")) {
    image <- as.raster(image, native = TRUE)
  }

  graphics::rasterImage(
    image,
    rct$xmin, rct$ymin, rct$xmax, rct$ymax,
    interpolate = interpolate
  )

  if (!identical(border, NA)) {
    if (is.null(border)) {
      border <- graphics::par("fg")
    }

    # simplify borders by drawing segments
    nx <- dim(x$data)[2]
    ny <- dim(x$data)[1]
    width <- rct$xmax - rct$xmin
    height <- rct$ymax - rct$ymin
    xs <- seq(rct$xmin, rct$xmax, by = width / nx)
    ys <- seq(rct$ymin, rct$ymax, by = height / ny)
    graphics::segments(xs, rct$ymin, xs, rct$ymax, col = border)
    graphics::segments(rct$xmin, ys, rct$xmax, ys, col = border)
  }

  invisible(x)
}

grd_calculate_plot_step <- function(grid, oversample = c(2, 2),
                                    usr = graphics::par("usr"),
                                    device = NULL) {
  # estimate resolution
  usr <- graphics::par("usr")
  usr_x <- usr[1:2]
  usr_y <- usr[3:4]

  device_x <- graphics::grconvertX(usr_x, to = "device")
  device_y <- graphics::grconvertY(usr_y, to = "device")

  # Use resolution of 1 at the device level, scale to usr coords.
  # this is sort of like pixels but not always; an oversample of
  # about 4 is needed for the operation to be invisible to the user
  scale_x <- abs(diff(device_x) / diff(usr_x))
  scale_y <- abs(diff(device_y) / diff(usr_y))
  resolution_x <- 1 / scale_x
  resolution_y <- 1 / scale_y

  # we need to know how many cells are going to be resolved by a crop
  # to see how many fewer of them we need to sample
  ranges <- grd_cell_range(grid, rct(usr_x[1], usr_y[1], usr_x[2], usr_y[2]))
  nx <- ranges$j["stop"] - ranges$j["start"]
  ny <- ranges$i["stop"] - ranges$i["start"]
  dx <- abs(diff(usr_x) / nx)
  dy <- abs(diff(usr_y) / ny)

  # calculate which step value is closest (rounding down, clamping to valid limits)
  step <- (c(resolution_y, resolution_x) / oversample) %/% c(dy, dx)
  step <- pmax(1L, step)

  # if the step is more than the number of pixels, it really shouldn't be
  # displayed at all
  if (any(step > c(ny, nx))) {
    return(c(NA_integer_, NA_integer_))
  }

  step
}

#' @export
#' @importFrom grDevices as.raster
as.raster.wk_grd_rct <- function(x, ..., i = NULL, j = NULL, native = NA) {
  # as.raster() works when values are [0..1]. We can emulate
  # this default by rescaling the image data if it's not already
  # a raster or nativeRaster.
  if (inherits(x$data, "nativeRaster") || grDevices::is.raster(x$data)) {
    grd_data_subset(x$data, i = i, j = j)
  } else if (prod(dim(x)) == 0) {
    as.raster(matrix(nrow = dim(x)[1], ncol = dim(x)[2]))
  } else if (length(dim(x)) == 2L || all(dim(x)[c(-1L, -2L)] == 1L)) {
    # try to interpret character() as hex colours, else
    # try to resolve x$data as a double() array
    if (is.character(x$data)) {
      return(as.raster(grd_data_subset(x$data, i = i, j = j)))
    }

    data <- grd_data_subset(x$data, i = i, j = j)
    storage.mode(data) <- "double"

    # we've checked that it's safe to drop the non-xy dimensions and
    # collected the data so that we know the axis order is R-native
    dim(data) <- dim(data)[1:2]

    range <- suppressWarnings(range(data, finite = TRUE))
    if (all(is.finite(range)) && (diff(range) > .Machine$double.eps)) {
      image <- (data - range[1]) / diff(range)
    } else if (all(is.finite(range))) {
      # constant value
      image <- data
      image[] <- 0.5
    } else {
      # all NA values
      image <- matrix(nrow = dim(data)[1], ncol = dim(data)[2])
    }

    as.raster(image)
  } else {
    stop(
      "Can't convert non-numeric or non-matrix grid to raster image",
      call. = FALSE
    )
  }
}

#' @rdname wk_writer
#' @export
wkt_writer <- function(precision = 16L, trim = TRUE) {
  new_wk_handler(
    .Call(
      wk_c_wkt_writer,
      as.integer(precision)[1],
      as.logical(trim)[1]
    ),
    "wk_wkt_writer"
  )
}

#' 2D rectangle vectors
#'
#' @param xmin,ymin,xmax,ymax Rectangle bounds.
#' @param x An object to be converted to a [rct()].
#' @param ... Extra arguments passed to `as_rct()`.
#' @inheritParams new_wk_wkb
#'
#' @return A vector along the recycled length of bounds.
#' @export
#'
#' @examples
#' rct(1, 2, 3, 4)
#'
rct <- function(xmin = double(), ymin = double(), xmax = double(), ymax = double(),
                crs = wk_crs_auto()) {
  vec <- new_wk_rct(
    recycle_common(
      xmin = as.double(xmin),
      ymin = as.double(ymin),
      xmax = as.double(xmax),
      ymax = as.double(ymax)
    ),
    crs = wk_crs_auto_value(xmin, crs)
  )

  validate_wk_rct(vec)
  vec
}

#' @rdname rct
#' @export
as_rct <- function(x, ...) {
  UseMethod("as_rct")
}

#' @rdname rct
#' @export
as_rct.wk_rct <- function(x, ...) {
  x
}

#' @rdname rct
#' @export
as_rct.matrix <- function(x, ..., crs = NULL) {
  if (ncol(x) == 4) {
    colnames(x) <- c("xmin", "ymin", "xmax", "ymax")
  }

  as_rct(as.data.frame(x), ..., crs = crs)
}

#' @rdname rct
#' @export
as_rct.data.frame <- function(x, ..., crs = NULL) {
  stopifnot(all(c("xmin", "ymin", "xmax", "ymax") %in% names(x)))
  new_wk_rct(
    lapply(x[c("xmin", "ymin", "xmax", "ymax")], as.double),
    crs = crs
  )
}

validate_wk_rct <- function(x) {
  validate_wk_rcrd(x)
  stopifnot(
    identical(names(unclass(x)), c("xmin", "ymin", "xmax", "ymax"))
  )
  invisible(x)
}

#' S3 details for rct objects
#'
#' @param x A [rct()]
#' @inheritParams new_wk_wkb
#'
#' @export
#'
new_wk_rct <- function(x = list(xmin = double(), ymin = double(), xmax = double(), ymax = double()),
                       crs = NULL) {
  structure(x, class = c("wk_rct", "wk_rcrd"), crs = crs)
}

#' @export
format.wk_rct <- function(x, ...) {
  x <- unclass(x)
  sprintf(
    "[%s %s %s %s]",
    format(x$xmin, ...), format(x$ymin, ...),
    format(x$xmax, ...), format(x$ymax, ...)
  )
}

#' @export
`[<-.wk_rct` <- function(x, i, value) {
  replacement <- as_rct(value)
  result <- Map("[<-", unclass(x), i, unclass(replacement))
  names(result) <- c("xmin", "ymin", "xmax", "ymax")
  new_wk_rct(
    result,
    crs = wk_crs_output(x, replacement)
  )
}

#' Rectangle accessors and operators
#'
#' @param x,y [rct()] vectors
#'
#' @return
#'   - `rct_xmin()`, `rct_xmax()`, `rct_ymin()`, and `rct_ymax()` return
#'     the components of the [rct()].
#' @export
#'
#' @examples
#' x <- rct(0, 0, 10, 10)
#' y <- rct(5, 5, 15, 15)
#'
#' rct_xmin(x)
#' rct_ymin(x)
#' rct_xmax(x)
#' rct_ymax(x)
#' rct_height(x)
#' rct_width(x)
#' rct_intersects(x, y)
#' rct_intersection(x, y)
#' rct_contains(x, y)
#' rct_contains(x, rct(4, 4, 6, 6))
#'
rct_xmin <- function(x) {
  x <- as_rct(x)
  unclass(x)$xmin
}

#' @rdname rct_xmin
#' @export
rct_ymin <- function(x) {
  x <- as_rct(x)
  unclass(x)$ymin
}

#' @rdname rct_xmin
#' @export
rct_xmax <- function(x) {
  x <- as_rct(x)
  unclass(x)$xmax
}

#' @rdname rct_xmin
#' @export
rct_ymax <- function(x) {
  x <- as_rct(x)
  unclass(x)$ymax
}

#' @rdname rct_xmin
#' @export
rct_width <- function(x) {
  x <- as_rct(x)
  x <- unclass(x)
  x$xmax - x$xmin
}

#' @rdname rct_xmin
#' @export
rct_height <- function(x) {
  x <- as_rct(x)
  x <- unclass(x)
  x$ymax - x$ymin
}

#' @rdname rct_xmin
#' @export
rct_intersects <- function(x, y) {
  x <- as_rct(x)
  y <- as_rct(y)
  wk_crs_output(x, y)

  x <- unclass(x)
  y <- unclass(y)

  limits <- list(
    xmin = pmax(x$xmin, y$xmin),
    xmax = pmin(x$xmax, y$xmax),
    ymin = pmax(x$ymin, y$ymin),
    ymax = pmin(x$ymax, y$ymax)
  )

  (limits$xmax >= limits$xmin) & (limits$ymax >= limits$ymin)
}

#' @rdname rct_xmin
#' @export
rct_contains <- function(x, y) {
  x <- as_rct(x)
  y <- wk_envelope(y)
  wk_crs_output(x, y)

  x <- unclass(x)
  y <- unclass(y)

  (y$xmin >= x$xmin) &
    (y$xmax <= x$xmax) &
    (y$ymin >= x$ymin) &
    (y$ymax <= x$ymax)
}

#' @rdname rct_xmin
#' @export
rct_intersection <- function(x, y) {
  x <- as_rct(x)
  y <- as_rct(y)
  crs <- wk_crs_output(x, y)

  x <- unclass(x)
  y <- unclass(y)

  limits <- list(
    xmin = pmax(x$xmin, y$xmin),
    ymin = pmax(x$ymin, y$ymin),
    xmax = pmin(x$xmax, y$xmax),
    ymax = pmin(x$ymax, y$ymax)
  )

  any_na <- Reduce("|", lapply(limits, is.na))
  not_valid <- any_na | !((limits$xmax >= limits$xmin) & (limits$ymax >= limits$ymin))
  limits$xmin[not_valid] <- NA_real_
  limits$xmax[not_valid] <- NA_real_
  limits$ymin[not_valid] <- NA_real_
  limits$ymax[not_valid] <- NA_real_

  new_wk_rct(limits, crs = crs)
}

#' Common CRS Representations
#'
#' These fixtures are calculated from PROJ version 9.1.0 and the database
#' built from its source. They are used internally to transform and inspect
#' coordinate reference systems.
#'
#' @examples
#' head(wk_proj_crs_view)
#' colnames(wk_proj_crs_json)
#'
"wk_proj_crs_view"

#' @rdname wk_proj_crs_view
"wk_proj_crs_json"

#' Create example geometry objects
#'
#' @param which An example name. Valid example names are
#'   - "nc" (data derived from the sf package)
#'   - "point", "linestring", "polygon", "multipoint",
#'     "multilinestring", "multipolygon", "geometrycollection"
#'   - One of the above with the "_z", "_m", or "_zm" suffix.
#' @inheritParams wk_crs
#' @inheritParams wk_is_geodesic
#'
#' @return A [wkt()] with the specified example.
#' @export
#'
#' @examples
#' wk_example("polygon")
#'
wk_example <- function(which = "nc",
                       crs = NA,
                       geodesic = FALSE) {
  all_examples <- wk::wk_example_wkt
  match.arg(which, names(all_examples))

  handleable <- all_examples[[which]]

  if (!identical(crs, NA)) {
    wk::wk_crs(handleable) <- crs
  }

  wk::wk_is_geodesic(handleable) <- geodesic
  handleable
}

#' @rdname wk_example
"wk_example_wkt"

#' 2D Circle Vectors
#'
#' @param x,y Coordinates of the center
#' @param r Circle radius
#' @param ... Extra arguments passed to `as_crc()`.
#' @inheritParams new_wk_wkb
#'
#' @return A vector along the recycled length of bounds.
#' @export
#'
#' @examples
#' crc(1, 2, 3)
#'
crc <- function(x = double(), y = double(), r = double(), crs = wk_crs_auto()) {
  vec <- new_wk_crc(
    recycle_common(
      x = as.double(x),
      y = as.double(y),
      r = as.double(r)
    ),
    crs = wk_crs_auto_value(x, crs)
  )

  validate_wk_crc(vec)
  vec
}

#' @rdname crc
#' @export
as_crc <- function(x, ...) {
  UseMethod("as_crc")
}

#' @rdname crc
#' @export
as_crc.wk_crc <- function(x, ...) {
  x
}

#' @rdname crc
#' @export
as_crc.matrix <- function(x, ..., crs = NULL) {
  if (ncol(x) == 3) {
    colnames(x) <- c("x", "y", "r")
  }

  as_crc(as.data.frame(x), ..., crs = crs)
}

#' @rdname crc
#' @export
as_crc.data.frame <- function(x, ..., crs = NULL) {
  stopifnot(all(c("x", "y", "r") %in% names(x)))
  new_wk_crc(lapply(x[c("x", "y", "r")], as.double), crs = crs)
}

validate_wk_crc <- function(x) {
  validate_wk_rcrd(x)
  stopifnot(
    identical(names(unclass(x)), c("x", "y", "r"))
  )
  invisible(x)
}

#' S3 details for crc objects
#'
#' @param x A [crc()]
#' @inheritParams new_wk_wkb
#'
#' @export
#'
new_wk_crc <- function(x = list(x = double(), y = double(), r = double()),
                       crs = NULL) {
  structure(x, class = c("wk_crc", "wk_rcrd"), crs = crs)
}

#' @export
format.wk_crc <- function(x, ...) {
  x <- unclass(x)
  sprintf(
    "[%s %s, r = %s]",
    format(x$x, ...), format(x$y, ...),
    format(x$r, ...)
  )
}

#' @export
`[<-.wk_crc` <- function(x, i, value) {
  replacement <- as_crc(value)
  result <- Map("[<-", unclass(x), i, unclass(replacement))
  names(result) <- c("x", "y", "r")
  new_wk_crc(result, crs = wk_crs_output(x, replacement))
}


#' Circle accessors
#'
#' @param x A [crc()] vector
#'
#' @return Components of the [crc()] vector
#' @export
#'
#' @examples
#' x <- crc(1, 2, r = 3)
#' crc_x(x)
#' crc_y(x)
#' crc_r(x)
#' crc_center(x)
#'
crc_x <- function(x) {
  unclass(as_crc(x))$x
}

#' @rdname crc_x
#' @export
crc_y <- function(x) {
  unclass(as_crc(x))$y
}

#' @rdname crc_x
#' @export
crc_center <- function(x) {
  x <- as_crc(x)
  crs <- wk_crs(x)
  x <- unclass(x)
  xy(x$x, x$y, crs = crs)
}

#' @rdname crc_x
#' @export
crc_r <- function(x) {
  unclass(as_crc(x))$r
}

#' Plot well-known geometry vectors
#'
#' @param x A [wkb()] or [wkt()]
#' @param add Should a new plot be created, or should `handleable` be added to the
#'   existing plot?
#' @param ... Passed to plotting functions for features: [graphics::points()]
#'   for point and multipoint geometries, [graphics::lines()] for linestring
#'   and multilinestring geometries, and [graphics::polypath()] for polygon
#'   and multipolygon geometries.
#' @param bbox The limits of the plot as a [rct()] or compatible object
#' @param asp,xlab,ylab Passed to [graphics::plot()]
#' @param rule The rule to use for filling polygons (see [graphics::polypath()])
#' @inheritParams wk_handle
#'
#' @return The input, invisibly.
#' @importFrom graphics plot
#' @export
#'
#' @examples
#' plot(as_wkt("LINESTRING (0 0, 1 1)"))
#' plot(as_wkb("LINESTRING (0 0, 1 1)"))
#'
wk_plot <- function(handleable, ...,
                    asp = 1, bbox = NULL, xlab = "", ylab = "",
                    rule = "evenodd", add = FALSE) {
  UseMethod("wk_plot")
}

#' @rdname wk_plot
#' @export
wk_plot.default <- function(handleable, ...,
                            asp = 1, bbox = NULL, xlab = "", ylab = "",
                            rule = "evenodd", add = FALSE) {
  # this is too hard without vctrs (already in Suggests)
  if (!requireNamespace("vctrs", quietly = TRUE)) {
    stop("Package 'vctrs' is required for wk_plot()", call. = FALSE) # nocov
  }

  if (isTRUE(wk_is_geodesic(handleable))) {
    stop(
      paste0(
        "wk_plot.default() can't plot geodesic objects.\n",
        "Use `wk_set_geodesic(x, FALSE)` to ignore geodesic edge specification"
      ),
      call. = FALSE
    )
  }

  # should be refactored
  x <- handleable

  if (!add) {
    bbox <- unclass(bbox)
    bbox <- bbox %||% unclass(wk_bbox(x))
    xlim <- c(bbox$xmin, bbox$xmax)
    ylim <- c(bbox$ymin, bbox$ymax)

    graphics::plot(
      numeric(0),
      numeric(0),
      xlim = xlim,
      ylim = ylim,
      xlab = xlab,
      ylab = ylab,
      asp = asp
    )
  }

  # for everything below we'll need to be able to subset
  if (!vctrs::vec_is(x)) {
    wk_plot(as_wkb(x), ..., rule = rule, add = TRUE) # nocov
    return(invisible(x)) # nocov
  }

  # get some background info
  size <- vctrs::vec_size(x)
  meta <- wk_meta(x)

  # points can be handled by as_xy()
  if (all(meta$geometry_type == 1L, na.rm = TRUE)) {
    coords <- unclass(as_xy(x))
    graphics::points(coords, ...)
    return(invisible(x))
  }

  # evaluate the dots
  dots <- list(..., rule = rule)
  is_scalar <- !vapply(dots, vctrs::vec_is, logical(1))
  dots[is_scalar] <- lapply(dots[is_scalar], list)
  dots_length <- vapply(dots, vctrs::vec_size, integer(1))
  dots_constant <- all(dots_length == 1L)
  is_rule <- length(dots)

  # point + multipoint is probably faster with a single coord vector
  if (all(meta$geometry_type %in% c(1, 4), na.rm = TRUE)) {
    coords <- wk_coords(x)
    if (dots_constant) {
      graphics::points(coords[c("x", "y")], ...)
    } else {
      dots$rule <- NULL
      dots <- vctrs::vec_recycle_common(!!!dots, .size = size)
      dots_tbl <- vctrs::new_data_frame(dots, n = size)
      do.call(graphics::points, c(coords[c("x", "y")], dots_tbl[coords$feature_id, , drop = FALSE]))
    }
    return(invisible(x))
  }

  # it's not faster to flatten big vectors into a single go for anything else
  dots <- vctrs::vec_recycle_common(!!!dots, .size = size)
  for (i in seq_len(size)) {
    xi <- vctrs::vec_slice(x, i)
    dotsi <- lapply(dots, "[[", i)

    if (meta$geometry_type[i] %in% c(1, 4)) {
      wk_plot_point_or_multipoint(xi, dotsi[-is_rule])
    } else if (meta$geometry_type[i] %in% c(2, 5)) {
      wk_plot_line_or_multiline(xi, dotsi[-is_rule])
    } else if (meta$geometry_type[i] %in% c(3, 6)) {
      wk_plot_poly_or_multi_poly(xi, dotsi)
    } else {
      do.call(wk_plot, c(list(wk_flatten(xi, max_depth = .Machine$integer.max), add = TRUE), dotsi))
    }
  }

  invisible(x)
}

wk_plot_point_or_multipoint <- function(x, dots) {
  dots_without_border <- dots[setdiff(names(dots), "border")]
  coords <- wk_coords(x)
  do.call(graphics::points, c(coords[c("x", "y")], dots_without_border))
}

wk_plot_line_or_multiline <- function(x, dots) {
  coords <- wk_coords(x)
  if (nrow(coords) == 0) {
    return()
  }

  geom_id <- coords$part_id
  geom_id_lag <- c(-1L, geom_id[-length(geom_id)])
  new_geom <- geom_id != geom_id_lag
  na_shift <- cumsum(new_geom) - 1L
  coords_seq <- seq_along(geom_id)

  coord_x <- rep(NA_real_, length(geom_id) + sum(new_geom) - 1L)
  coord_y <- rep(NA_real_, length(geom_id) + sum(new_geom) - 1L)

  coord_x[coords_seq + na_shift] <- coords$x
  coord_y[coords_seq + na_shift] <- coords$y

  dots$rule <- NULL
  do.call(graphics::lines, c(list(coord_x, coord_y), dots))
}

wk_plot_poly_or_multi_poly <- function(x, dots) {
  coords <- wk_coords(x)
  if (nrow(coords) == 0) {
    return()
  }

  # for polygons we can use the coord vectors directly
  # because the graphics device expects open loops
  geom_id <- coords$ring_id
  n <- length(geom_id)
  # leave the last loop closed the avoid a trailing NA (which results in error)
  geom_id_lead <- c(geom_id[-1L], geom_id[n])
  new_geom_next <- geom_id != geom_id_lead

  coords$x[new_geom_next] <- NA_real_
  coords$y[new_geom_next] <- NA_real_

  do.call(graphics::polypath, c(coords[c("x", "y")], dots))
}

#' @rdname wk_plot
#' @export
plot.wk_wkt <- function(x, ..., asp = 1, bbox = NULL, xlab = "", ylab = "",
                        rule = "evenodd", add = FALSE) {
  wk_plot(
    x,
    ...,
    asp = asp,
    bbox = bbox,
    xlab = xlab,
    ylab = ylab,
    rule = rule,
    add = add
  )

  invisible(x)
}

#' @rdname wk_plot
#' @export
plot.wk_wkb <- function(x, ..., asp = 1, bbox = NULL, xlab = "", ylab = "",
                        rule = "evenodd", add = FALSE) {
  wk_plot(
    x,
    ...,
    asp = asp,
    bbox = bbox,
    xlab = xlab,
    ylab = ylab,
    rule = rule,
    add = add
  )

  invisible(x)
}

#' @rdname wk_plot
#' @export
plot.wk_xy <- function(x, ..., asp = 1, bbox = NULL, xlab = "", ylab = "", add = FALSE) {
  x_bare <- unclass(x)

  if (!add) {
    graphics::plot(
      double(), double(),
      xlim = range(x_bare$x, finite = TRUE),
      ylim = range(x_bare$y, finite = TRUE),
      xlab = xlab,
      ylab = ylab,
      asp = asp
    )
  }

  graphics::points(x_bare$x, x_bare$y, ...)

  invisible(x)
}

#' @rdname wk_plot
#' @export
plot.wk_rct <- function(x, ..., asp = 1, bbox = NULL, xlab = "", ylab = "", add = FALSE) {
  x_bare <- unclass(x)

  if (!add) {
    xlim_min <- range(x_bare$xmin, finite = TRUE)
    xlim_max <- range(x_bare$xmax, finite = TRUE)
    ylim_min <- range(x_bare$ymin, finite = TRUE)
    ylim_max <- range(x_bare$ymax, finite = TRUE)

    graphics::plot(
      double(), double(),
      xlim = range(c(xlim_min, xlim_max), finite = TRUE),
      ylim = range(c(ylim_min, ylim_max), finite = TRUE),
      xlab = xlab,
      ylab = ylab,
      asp = asp
    )
  }

  graphics::rect(x_bare$xmin, x_bare$ymin, x_bare$xmax, x_bare$ymax, ...)
  invisible(x)
}

#' @rdname wk_plot
#' @export
plot.wk_crc <- function(x, ..., asp = 1, bbox = NULL, xlab = "", ylab = "",
                        add = FALSE) {
  x_bare <- unclass(x)

  if (!add) {
    xlim_min <- range(x_bare$x + x_bare$r, finite = TRUE)
    xlim_max <- range(x_bare$x - x_bare$r, finite = TRUE)
    ylim_min <- range(x_bare$y + x_bare$r, finite = TRUE)
    ylim_max <- range(x_bare$y - x_bare$r, finite = TRUE)

    graphics::plot(
      double(), double(),
      xlim = range(c(xlim_min, xlim_max), finite = TRUE),
      ylim = range(c(ylim_min, ylim_max), finite = TRUE),
      xlab = xlab,
      ylab = ylab,
      asp = asp
    )
  }

  # estimate resolution for turning circles into segments
  usr <- graphics::par("usr")
  usr_x <- usr[1:2]
  usr_y <- usr[3:4]
  device_x <- graphics::grconvertX(usr_x, to = "device")
  device_y <- graphics::grconvertY(usr_y, to = "device")

  # Use resolution of 1 at the device level, scale to usr coords.
  # Changing this number to 2 or 4 doesn't really affect the speed
  # at which these plot; a value of 1 tends to give very good
  # resolution and is acceptable even when a plot in the interactive
  # device is zoomed.
  scale_x <- diff(device_x) / diff(usr_x)
  scale_y <- diff(device_y) / diff(usr_y)
  scale <- min(abs(scale_x), abs(scale_y))
  resolution_usr <- 1 / scale

  plot(
    wk_handle(x, wkb_writer(), resolution = resolution_usr),
    ...,
    add = TRUE
  )

  invisible(x)
}

#' Copy a geometry vector
#'
#' @inheritParams wk_handle
#' @param result The result of a filter operation intended to be a
#'   transformation.
#'
#' @return A copy of `handleable`.
#' @export
#'
#' @examples
#' wk_identity(wkt("POINT (1 2)"))
#'
wk_identity <- function(handleable, ...) {
  result <- wk_handle(handleable, wk_identity_filter(wk_writer(handleable)), ...)
  result <- wk_restore(handleable, result, ...)
  result <- wk_set_crs(result, wk_crs(handleable))
  wk_set_geodesic(result, wk_is_geodesic(handleable))
}

#' @rdname wk_identity
#' @export
wk_identity_filter <- function(handler) {
  new_wk_handler(.Call("wk_c_identity_filter_new", as_wk_handler(handler)), "wk_identity_filter")
}

#' @rdname wk_identity
#' @export
wk_restore <- function(handleable, result, ...) {
  UseMethod("wk_restore")
}

#' @rdname wk_identity
#' @export
wk_restore.default <- function(handleable, result, ...) {
  result
}

#' Handle specific regions of objects
#'
#' @inheritParams wk_handle
#' @param from 1-based index of the feature to start from
#' @param to 1-based index of the feature to end at
#'
#' @return A subset of `handleable`
#' @export
#'
#' @examples
#' wk_handle_slice(xy(1:5, 1:5), wkt_writer(), from = 3, to = 5)
#' wk_handle_slice(
#'   data.frame(let = letters[1:5], geom = xy(1:5, 1:5)),
#'   wkt_writer(),
#'   from = 3, to = 5
#' )
#'
wk_handle_slice <- function(handleable, handler = wk_writer(handleable),
                            from = NULL, to = NULL, ...) {
  UseMethod("wk_handle_slice")
}

#' @rdname wk_handle_slice
#' @export
wk_handle_slice.default <- function(handleable, handler = wk_writer(handleable),
                                    from = NULL, to = NULL, ...) {
  # make sure we're dealing with a handleable and a vector
  stopifnot(is_handleable(handleable), is_vector_class(handleable))

  from <- from %||% 1L
  to <- to %||% length(handleable)
  from <- max(from, 1L)
  to <- min(to, length(handleable))

  if (to >= from) {
    wk_handle(handleable[from:to], handler, ...)
  } else {
    wk_handle(handleable[integer(0)], handler, ...)
  }
}

#' @export
print.wk_vctr <- function(x, ...) {
  crs <- wk_crs(x)
  is_geodesic <- wk_is_geodesic(x)
  header <- sprintf("%s[%s]", class(x)[1], length(x))

  if (!is.null(crs)) {
    header <- paste0(header, " with CRS=", wk_crs_format(crs))
  }

  if (isTRUE(is_geodesic)) {
    header <- paste0("geodesic ", header)
  }

  cat(sprintf("<%s>\n", header))

  if (length(x) == 0) {
    return(invisible(x))
  }

  max_print <- getOption("max.print", 1000)
  x_head <- format(utils::head(x, max_print))
  out <- stats::setNames(format(x_head), names(x_head))

  print(out, quote = FALSE)

  if (length(x) > max_print) {
    cat(sprintf("Reached max.print (%s)\n", max_print))
  }

  invisible(x)
}

# lifted from vctrs::obj_leaf()
#' @export
str.wk_vctr <- function(object, ..., indent.str = "", width = getOption("width")) {
  if (length(object) == 0) {
    cat(paste0(" ", class(object)[1], "[0]\n"))
    return(invisible(object))
  }

  # estimate possible number of elements that could be displayed
  # to avoid formatting too many
  width <- width - nchar(indent.str) - 2
  length <- min(length(object), ceiling(width / 5))
  formatted <- format(object[seq_len(length)], trim = TRUE)

  title <- paste0(" ", class(object)[1], "[1:", length(object), "]")
  cat(
    paste0(
      title,
      " ",
      strtrim(paste0(formatted, collapse = ", "), width - nchar(title)),
      "\n"
    )
  )
  invisible(object)
}

#' @export
`[.wk_vctr` <- function(x, i) {
  new_wk_vctr(NextMethod(), x)
}

#' @export
`[[.wk_vctr` <- function(x, i) {
  x[i]
}

#' @export
`[[<-.wk_vctr` <- function(x, i, value) {
  x[i] <- value
  x
}

#' @export
c.wk_vctr <- function(...) {
  dots <- list(...)
  classes <- lapply(dots, class)
  first_class <- classes[[1]]
  if (!all(vapply(classes, identical, first_class, FUN.VALUE = logical(1)))) {
    stop("Can't combine 'wk_vctr' objects that do not have identical classes.", call. = FALSE)
  }

  # compute output crs, geodesic
  attr(dots[[1]], "crs") <- wk_crs_output(...)
  geodesic <- wk_is_geodesic_output(...)
  attr(dots[[1]], "geodesic") <- if (geodesic) TRUE else NULL

  new_wk_vctr(NextMethod(), dots[[1]])
}

#' @export
rep.wk_vctr <- function(x, ...) {
  new_wk_vctr(NextMethod(), x)
}

#' @method rep_len wk_vctr
#' @export
rep_len.wk_vctr <- function(x, ...) {
  new_wk_vctr(NextMethod(), x)
}

# data.frame() will call as.data.frame() with optional = TRUE
#' @export
as.data.frame.wk_vctr <- function(x, ..., optional = FALSE) {
  if (!optional) {
    stop(sprintf("cannot coerce object of tyoe '%s' to data.frame", class(x)[1]))
  } else {
    new_data_frame(list(x))
  }
}

new_wk_vctr <- function(x, template) {
  structure(
    x,
    class = unique(class(template)),
    crs = attr(template, "crs", exact = TRUE),
    geodesic = attr(template, "geodesic", exact = TRUE)
  )
}

parse_base <- function(x, problems) {
  x[!is.na(problems)] <- x[NA_integer_]
  problems_df <- action_for_problems(
    problems,
    function(msg) warning(paste0(msg, '\nSee attr(, "problems") for details.'), call. = FALSE)
  )

  if (nrow(problems_df) > 0) {
    problems_df$actual <- unclass(x)[problems_df$row]
    attr(x, "problems") <- problems_df
  }

  x
}

stop_for_problems <- function(problems)  {
  action_for_problems(problems, stop, call. = FALSE)
}

action_for_problems <- function(problems, action, ...) {
  if (any(!is.na(problems))) {
    n_problems <- sum(!is.na(problems))
    summary_problems <- utils::head(which(!is.na(problems)))
    problem_summary <- paste0(
      sprintf("[%s] %s", summary_problems, problems[summary_problems]),
      collapse = "\n"
    )

    if (n_problems > length(summary_problems)) {
      problem_summary <- paste0(
        problem_summary,
        sprintf("\n...and %s more problems", n_problems - length(summary_problems))
      )
    }

    action(
      sprintf(
        "Encountered %s parse problem%s:\n%s",
        n_problems,
        if (n_problems == 1) "" else "s",
        problem_summary
      ),
      ...
    )
  }

  data.frame(
    row = which(!is.na(problems)),
    col = rep_len(NA_integer_, sum(!is.na(problems))),
    expected = problems[!is.na(problems)],
    stringsAsFactors = FALSE
  )
}

#' Efficient point vectors
#'
#' @param x,y,z,m Coordinate values.
#' @param dims A set containing one or more of `c("x", "y", "z", "m")`.
#' @param ... Passed to methods.
#' @inheritParams new_wk_wkb
#'
#' @return A vector of coordinate values.
#' @export
#'
#' @examples
#' xy(1:5, 1:5)
#' xyz(1:5, 1:5, 10)
#' xym(1:5, 1:5, 10)
#' xyzm(1:5, 1:5, 10, 12)
#'
#' # NA, NA maps to a null/na feature; NaN, NaN maps to EMPTY
#' as_wkt(xy(NaN, NaN))
#' as_wkt(xy(NA, NA))
#'
xy <- function(x = double(), y = double(), crs = wk_crs_auto()) {
  vec <- new_wk_xy(recycle_common(x = as.double(x), y = as.double(y)), crs = wk_crs_auto_value(x, crs))
  validate_wk_xy(vec)
  vec
}

#' @rdname xy
#' @export
xyz <- function(x = double(), y = double(), z = double(), crs = wk_crs_auto()) {
  vec <- new_wk_xyz(recycle_common(x = as.double(x), y = as.double(y), z = as.double(z)), crs = wk_crs_auto_value(x, crs))
  validate_wk_xyz(vec)
  vec
}

#' @rdname xy
#' @export
xym <- function(x = double(), y = double(), m = double(), crs = wk_crs_auto()) {
  vec <- new_wk_xym(recycle_common(x = as.double(x), y = as.double(y), m = as.double(m)), crs = wk_crs_auto_value(x, crs))
  validate_wk_xym(vec)
  vec
}

#' @rdname xy
#' @export
xyzm <- function(x = double(), y = double(), z = double(), m = double(), crs = wk_crs_auto()) {
  vec <- new_wk_xyzm(
    recycle_common(
      x = as.double(x),
      y = as.double(y),
      z = as.double(z),
      m = as.double(m)
    ),
    crs = wk_crs_auto_value(x, crs)
  )
  validate_wk_xyzm(vec)
  vec
}

#' @rdname xy
#' @export
xy_dims <- function(x) {
  names(unclass(x))
}

#' @rdname xy
#' @export
as_xy <- function(x, ...) {
  UseMethod("as_xy")
}

#' @rdname xy
#' @export
as_xy.default <- function(x, ..., dims = NULL) {
  result <- wk_handle(x, xy_writer())
  wk_crs(result) <- wk_crs(x)

  if (is.null(dims)) {
    result
  } else {
    as_xy(result, dims = dims)
  }
}

#' @rdname xy
#' @export
as_xy.wk_xy <- function(x, ..., dims = NULL) {
  if (is.null(dims)) {
    x
  } else if (setequal(dims, c("x", "y"))) {
    new_wk_xy(fill_missing_dims(unclass(x), c("x", "y"), length(x)), crs = wk_crs(x))

  } else if (setequal(dims, c("x", "y", "z"))) {
    new_wk_xyz(fill_missing_dims(unclass(x), c("x", "y", "z"), length(x)), crs = wk_crs(x))

  } else if (setequal(dims, c("x", "y", "m"))) {
    new_wk_xym(fill_missing_dims(unclass(x), c("x", "y", "m"), length(x)), crs = wk_crs(x))

  } else if (setequal(dims, c("x", "y", "z", "m"))) {
    new_wk_xyzm(fill_missing_dims(unclass(x), c("x", "y", "z", "m"), length(x)), crs = wk_crs(x))

  } else {
    stop("Unknown dims in as_xy().", call. = FALSE)
  }
}

#' @rdname xy
#' @export
as_xy.matrix <- function(x, ..., crs = NULL) {
  x[] <- as.numeric(x)
  colnames(x) <- tolower(colnames(x))
  cols <- colnames(x)

  if (!is.null(cols)) {
    dim_cols <- intersect(c("x", "y", "z", "m"), cols)
    if (length(dim_cols) == 0) {
      stop(
        paste0(
          "Can't guess dimensions of matrix with column names\n",
          paste0("'", cols, "'", collapse = ", ")
        ),
        call. = FALSE
      )
    }

    if (!identical(dim_cols, colnames(x))) {
      x <- x[, dim_cols, drop = FALSE]
    }
  }

  # prevent named subsets
  dimnames(x) <- NULL

  if (ncol(x) == 2) {
    new_wk_xy(
      list(
        x = x[, 1, drop = TRUE],
        y = x[, 2, drop = TRUE]
      ),
      crs = crs
    )
  } else if (ncol(x) == 4) {
    new_wk_xyzm(
      list(
        x = x[, 1, drop = TRUE],
        y = x[, 2, drop = TRUE],
        z = x[, 3, drop = TRUE],
        m = x[, 4, drop = TRUE]
      ),
      crs = crs
    )
  } else if (identical(cols, c("x", "y", "m"))) {
    new_wk_xym(
      list(
        x = x[, 1, drop = TRUE],
        y = x[, 2, drop = TRUE],
        m = x[, 3, drop = TRUE]
      ),
      crs = crs
    )
  } else if (ncol(x) == 3) {
    new_wk_xyz(
      list(
        x = x[, 1, drop = TRUE],
        y = x[, 2, drop = TRUE],
        z = x[, 3, drop = TRUE]
      ),
      crs = crs
    )
  } else {
    stop(
      sprintf("Can't guess dimensions of matrix with %s columns", ncol(x)),
      call. = FALSE
    )
  }
}

#' @rdname xy
#' @export
as_xy.data.frame <- function(x, ..., dims = NULL, crs = NULL) {
  col_handleable <- vapply(x, is_handleable, logical(1))
  if (any(col_handleable)) {
    stopifnot(missing(crs))
    return(as_xy.default(x[[which(col_handleable)[1]]], dims = dims))
  }

  if (is.null(dims)) {
    dims <- intersect(c("x", "y", "z", "m"), names(x))
  }

  if (setequal(dims, c("x", "y"))) {
    new_wk_xy(fill_missing_dims(unclass(x), c("x", "y"), nrow(x)), crs = crs)

  } else if (setequal(dims, c("x", "y", "z"))) {
    new_wk_xyz(fill_missing_dims(unclass(x), c("x", "y", "z"), nrow(x)), crs = crs)

  } else if (setequal(dims, c("x", "y", "m"))) {
    new_wk_xym(fill_missing_dims(unclass(x), c("x", "y", "m"), nrow(x)), crs = crs)

  } else if (setequal(dims, c("x", "y", "z", "m"))) {
    new_wk_xyzm(fill_missing_dims(unclass(x), c("x", "y", "z", "m"), nrow(x)), crs = crs)

  } else {
    stop("Unknown dims in as_xy.data.frame().", call. = FALSE)
  }
}

fill_missing_dims <- function(x, dims, len) {
  missing_dims <- setdiff(dims, names(x))
  x[missing_dims] <- lapply(
    stats::setNames(missing_dims, missing_dims),
    function(x) rep_len(NA_real_, len)
  )
  lapply(x[dims], as.double)
}

#' S3 details for xy objects
#'
#' @param x A [xy()] object.
#' @inheritParams new_wk_wkb
#'
#' @export
#'
new_wk_xy <- function(x = list(x = double(), y = double()), crs = NULL) {
  structure(x, class = c("wk_xy", "wk_rcrd"), crs = crs)
}

#' @rdname new_wk_xy
#' @export
new_wk_xyz <- function(x = list(x = double(), y = double(), z = double()), crs = NULL) {
  structure(x, class = c("wk_xyz", "wk_xy", "wk_rcrd"), crs = crs)
}

#' @rdname new_wk_xy
#' @export
new_wk_xym <- function(x = list(x = double(), y = double(), m = double()), crs = NULL) {
  structure(x, class = c("wk_xym", "wk_xy", "wk_rcrd"), crs = crs)
}

#' @rdname new_wk_xy
#' @export
new_wk_xyzm <- function(x = list(x = double(), y = double(), z = double(), m = double()), crs = NULL) {
  structure(x, class = c("wk_xyzm", "wk_xyz", "wk_xym", "wk_xy", "wk_rcrd"), crs = crs)
}

#' @rdname new_wk_xy
#' @export
validate_wk_xy <- function(x) {
  validate_wk_rcrd(x)
  stopifnot(identical(names(unclass(x)), c("x", "y")))
  invisible(x)
}

#' @rdname new_wk_xy
#' @export
validate_wk_xyz <- function(x) {
  validate_wk_rcrd(x)
  stopifnot(identical(names(unclass(x)), c("x", "y", "z")))
  invisible(x)
}

#' @rdname new_wk_xy
#' @export
validate_wk_xym <- function(x) {
  validate_wk_rcrd(x)
  stopifnot(identical(names(unclass(x)), c("x", "y", "m")))
  invisible(x)
}

#' @rdname new_wk_xy
#' @export
validate_wk_xyzm <- function(x) {
  validate_wk_rcrd(x)
  stopifnot(identical(names(unclass(x)), c("x", "y", "z", "m")))
  invisible(x)
}

#' @export
format.wk_xy <- function(x, ...) {
  x <- unclass(x)
  sprintf("(%s %s)", format(x$x, ...), format(x$y, ...))
}

#' @export
format.wk_xyz <- function(x, ...) {
  x <- unclass(x)
  sprintf("Z (%s %s %s)", format(x$x, ...), format(x$y, ...), format(x$z, ...))
}

#' @export
format.wk_xym <- function(x, ...) {
  x <- unclass(x)
  sprintf("M (%s %s %s)", format(x$x, ...), format(x$y, ...), format(x$m, ...))
}

#' @export
format.wk_xyzm <- function(x, ...) {
  x <- unclass(x)
  sprintf("ZM (%s %s %s %s)", format(x$x, ...), format(x$y, ...), format(x$z, ...), format(x$m, ...))
}

#' @export
`[<-.wk_xy` <- function(x, i, value) {
  replacement <- as_xy(value)
  result <- Map(
    "[<-",
    unclass(x),
    list(i),
    fill_missing_dims(unclass(replacement), xy_dims(x), length(replacement))
  )

  names(result) <- names(unclass(x))
  structure(result, class = class(x), crs = wk_crs_output(x, replacement))
}

#' @export
is.na.wk_xy <- function(x, ...) {
  is_na <- Reduce("&", lapply(unclass(x), is.na))
  is_nan <- Reduce("&", lapply(unclass(x), is.nan))
  is_na & !is_nan
}


#' XY vector extractors
#'
#' @param x An [xy()] vector
#'
#' @return Components of the [xy()] vector or NULL if the dimension is missing
#' @export
#'
#' @examples
#' x <- xyz(1:5, 6:10, 11:15)
#' xy_x(x)
#' xy_y(x)
#' xy_z(x)
#' xy_m(x)
#'
xy_x <- function(x) {
  unclass(as_xy(x))$x
}

#' @rdname xy_x
#' @export
xy_y <- function(x) {
  unclass(as_xy(x))$y
}

#' @rdname xy_x
#' @export
xy_z <- function(x) {
  unclass(as_xy(x))$z
}

#' @rdname xy_x
#' @export
xy_m <- function(x) {
  unclass(as_xy(x))$m
}

#' 2D bounding rectangles
#'
#' @inheritParams wk_handle
#'
#' @return A [rct()] of length 1.
#' @export
#'
#' @examples
#' wk_bbox(wkt("LINESTRING (1 2, 3 5)"))
#'
wk_bbox <- function(handleable, ...) {
  UseMethod("wk_bbox")
}

#' @rdname wk_bbox
#' @export
wk_envelope <- function(handleable, ...) {
  UseMethod("wk_envelope")
}

#' @rdname wk_bbox
#' @export
wk_bbox.default <- function(handleable, ...) {
  if (wk_is_geodesic(handleable)) {
    stop("Can't compute bbox for geodesic object", call. = FALSE)
  }

  result <- wk_handle(handleable, wk_bbox_handler(), ...)
  wk_crs(result) <- wk_crs(handleable)
  result
}

#' @rdname wk_bbox
#' @export
wk_envelope.default <- function(handleable, ...) {
  if (wk_is_geodesic(handleable)) {
    stop("Can't compute envelope for geodesic object", call. = FALSE)
  }

  result <- wk_handle(handleable, wk_envelope_handler(), ...)
  wk_crs(result) <- wk_crs(handleable)
  result
}

#' @rdname wk_bbox
#' @export
wk_envelope.wk_rct <- function(handleable, ...) {
  handleable
}

#' @rdname wk_bbox
#' @export
wk_envelope.wk_crc <- function(handleable, ...) {
  unclassed <- unclass(handleable)

  rct_data <- list(
    xmin = unclassed$x - unclassed$r,
    ymin = unclassed$y - unclassed$r,
    xmax = unclassed$x + unclassed$r,
    ymax = unclassed$y + unclassed$r
  )

  new_wk_rct(rct_data, crs = attr(handleable, "crs", exact = TRUE))
}

#' @rdname wk_bbox
#' @export
wk_envelope.wk_xy <- function(handleable, ...) {
  unclassed <- unclass(handleable)
  rct_data <- c(unclassed[1:2], unclassed[1:2])
  names(rct_data) <- c("xmin", "ymin", "xmax", "ymax")
  new_wk_rct(rct_data, crs = attr(handleable, "crs", exact = TRUE))
}

# Note to future self: re-implementing wk_bbox() using range()
# for record-style vectors is not faster than the default method

#' @rdname wk_bbox
#' @export
wk_bbox_handler <- function() {
  new_wk_handler(.Call(wk_c_bbox_handler_new), "wk_bbox_handler")
}

#' @rdname wk_bbox
#' @export
wk_envelope_handler <- function() {
  new_wk_handler(.Call(wk_c_envelope_handler_new), "wk_envelope_handler")
}

# registered in zzz.R
output_column_wk <- function(x) {
  out <- as.character(as_wkt(x))
  out[is.na(x)] <- NA_character_
  out
}

output_column.wk_wkt <- function(x, name) {
  output_column_wk(x)
}

output_column.wk_wkb <- function(x, name) {
  output_column_wk(x)
}

output_column.wk_xy <- function(x, name) {
  output_column_wk(x)
}

output_column.wk_crc <- function(x, name) {
  output_column_wk(x)
}

output_column.wk_rct <- function(x, name) {
  output_column_wk(x)
}

#' Transform using explicit coordinate values
#'
#' A [wk_trans][wk::wk_transform] implementation that replaces coordinate values
#' using a vector of pre-calculated coordinates. This is used to perform generic
#' transforms using R functions and system calls that are impossible or impractical
#' to implement at the C level.
#'
#' @inheritParams wk_trans_set
#'
#' @export
#'
#' @seealso [wk_coords()] which has a replacement version  "`wk_coords<-`"
#' @examples
#' trans <- wk_trans_explicit(xy(1:5, 1:5))
#' wk_transform(rep(xy(0, 0), 5), trans)
wk_trans_explicit <- function(value, use_z = NA, use_m = NA) {
  value <- wk::as_xy(value)
  value <- wk::as_xy(value, dims = c("x", "y", "z", "m"))
  wk::new_wk_trans(
    .Call(wk_c_trans_explicit_new, value, as.logical(use_z)[1], as.logical(use_m)[1]),
    "wk_trans_explicit"
  )
}

#' Chunking strategies
#'
#' It is often impractical, inefficient, or impossible to perform
#' an operation on a vector of geometries with all the geometries loaded
#' into memory at the same time. These functions help generalize the
#' pattern of split-apply-combine to one or more handlers recycled along a
#' common length. These functions are designed for developers rather than users
#' and should be considered experimental.
#'
#' @param reduce For [wk_chunk_strategy_coordinates()] this refers to
#'   the function used with [Reduce()] to combine coordinate counts
#'   from more than one handleable.
#' @param n_chunks,chunk_size Exactly one of the number of
#'   chunks or the chunk size. For [wk_chunk_strategy_feature()]
#'   the chunk size refers to the number of features; for
#'   [wk_chunk_strategy_coordinates()] this refers to the number
#'   of coordinates as calculated from multiple handleables
#'   using `reduce`.
#'
#' @return A function that returns a `data.frame` with columns `from` and `to`
#'   when called with a `handleable` and the feature count.
#' @export
#'
#' @examples
#' feat <- c(as_wkt(xy(1:4, 1:4)), wkt("LINESTRING (1 1, 2 2)"))
#' wk_chunk_strategy_single()(list(feat), 5)
#' wk_chunk_strategy_feature(chunk_size = 2)(list(feat), 5)
#' wk_chunk_strategy_coordinates(chunk_size = 2)(list(feat), 5)
#'
wk_chunk_strategy_single <- function() {
  function(handleables, n_features) {
    new_data_frame(list(from = 1, to = n_features))
  }
}

#' @rdname wk_chunk_strategy_single
#' @export
wk_chunk_strategy_feature <- function(n_chunks = NULL, chunk_size = NULL) {
  force(n_chunks)
  force(chunk_size)

  function(handleables, n_features) {
    chunk_info <- chunk_info(n_features, n_chunks = n_chunks, chunk_size = chunk_size)

    from <- (chunk_info$chunk_size * (seq_len(chunk_info$n_chunks) - 1L)) + 1L
    to <- chunk_info$chunk_size * seq_len(chunk_info$n_chunks)
    to[chunk_info$n_chunks] <- n_features
    new_data_frame(list(from = from, to = to))
  }
}

#' @rdname wk_chunk_strategy_single
#' @export
wk_chunk_strategy_coordinates <- function(n_chunks = NULL, chunk_size = NULL, reduce = "*") {
  force(n_chunks)
  force(reduce)

  function(handleables, n_features) {
    coord_count <- lapply(handleables, function(handleable) {
      vm <- wk_vector_meta(handleable)
      if (identical(vm$geometry_type, 1L)) {
        1L
      } else {
        wk_count(handleable)$n_coord
      }
    })

    coord_count <- Reduce(reduce, coord_count)
    if (identical(coord_count, 1L)) {
      return(wk_chunk_strategy_feature(n_chunks, chunk_size)(handleables, n_features))
    }

    coord_count <- rep_len(coord_count, n_features)

    coord_count_total <- sum(coord_count)
    chunk_info <- chunk_info(coord_count_total, n_chunks, chunk_size)

    from <- rep(NA_integer_, chunk_info$n_chunks)
    to <- rep(NA_integer_, chunk_info$n_chunks)
    from[1] <- 1L

    coord_count_chunk <- (coord_count_total / chunk_info$n_chunks)
    coord_count_feat <- cumsum(coord_count)

    for (chunk_id in seq_len(chunk_info$n_chunks - 1L)) {
      next_coord_gt <- coord_count_feat >= coord_count_chunk
      if (!any(next_coord_gt)) {
        to[chunk_id] <- n_features
        break
      }

      i <- max(min(which(next_coord_gt)), from[chunk_id] + 1L)
      to[chunk_id] <- i
      from[chunk_id + 1L] <- i + 1L
      coord_count[1:i] <- 0L
      coord_count_feat <- cumsum(coord_count)
    }

    valid <- !is.na(from)
    from <- from[valid]
    to <- to[valid]

    if (is.na(to[length(to)])) {
      to[length(to)] <- n_features
    }

    new_data_frame(list(from = from, to = to))
  }
}

chunk_info <- function(n_features, n_chunks = NULL, chunk_size = NULL) {
  if (is.null(n_chunks) && is.null(chunk_size)) {
    stop("Must specify exactly one of `n_chunks` or `chunk_size`", call. = FALSE)
  } else if (is.null(n_chunks)) {
    n_chunks <- ((n_features - 1L) %/% chunk_size) + 1L
  } else if (is.null(chunk_size)) {
    if (n_features == 0) {
      n_chunks <- 0L
      chunk_size <- 1L
    } else {
      chunk_size <- ((n_features - 1L) %/% n_chunks) + 1L
    }
  } else {
    stop("Must specify exactly one of `n_chunks` or `chunk_size`", call. = FALSE)
  }

  list(n_chunks = n_chunks, chunk_size = chunk_size)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/transform.R
\name{wk_transform}
\alias{wk_transform}
\alias{wk_transform_filter}
\title{Apply coordinate transformations}
\usage{
wk_transform(handleable, trans, ...)

wk_transform_filter(handler, trans)
}
\arguments{
\item{handleable}{A geometry vector (e.g., \code{\link[=wkb]{wkb()}}, \code{\link[=wkt]{wkt()}}, \code{\link[=xy]{xy()}},
\code{\link[=rct]{rct()}}, or \code{\link[sf:sfc]{sf::st_sfc()}}) for which \code{\link[=wk_handle]{wk_handle()}} is defined.}

\item{trans}{An external pointer to a wk_trans object}

\item{...}{Passed to the \code{\link[=wk_handle]{wk_handle()}} method.}

\item{handler}{A \link[=wk_handle]{wk_handler} object.}
}
\description{
Apply coordinate transformations
}
\examples{
wk_transform(xy(0, 0), wk_affine_translate(2, 3))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/xyzm.R
\name{new_wk_xy}
\alias{new_wk_xy}
\alias{new_wk_xyz}
\alias{new_wk_xym}
\alias{new_wk_xyzm}
\alias{validate_wk_xy}
\alias{validate_wk_xyz}
\alias{validate_wk_xym}
\alias{validate_wk_xyzm}
\title{S3 details for xy objects}
\usage{
new_wk_xy(x = list(x = double(), y = double()), crs = NULL)

new_wk_xyz(x = list(x = double(), y = double(), z = double()), crs = NULL)

new_wk_xym(x = list(x = double(), y = double(), m = double()), crs = NULL)

new_wk_xyzm(
  x = list(x = double(), y = double(), z = double(), m = double()),
  crs = NULL
)

validate_wk_xy(x)

validate_wk_xyz(x)

validate_wk_xym(x)

validate_wk_xyzm(x)
}
\arguments{
\item{x}{A \code{\link[=xy]{xy()}} object.}

\item{crs}{A value to be propagated as the CRS for this vector.}
}
\description{
S3 details for xy objects
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/meta.R
\name{wk_meta}
\alias{wk_meta}
\alias{wk_meta.default}
\alias{wk_vector_meta}
\alias{wk_vector_meta.default}
\alias{wk_meta_handler}
\alias{wk_vector_meta_handler}
\alias{wk_geometry_type_label}
\alias{wk_geometry_type}
\title{Extract feature-level meta}
\usage{
wk_meta(handleable, ...)

\method{wk_meta}{default}(handleable, ...)

wk_vector_meta(handleable, ...)

\method{wk_vector_meta}{default}(handleable, ...)

wk_meta_handler()

wk_vector_meta_handler()

wk_geometry_type_label(geometry_type)

wk_geometry_type(geometry_type_label)
}
\arguments{
\item{handleable}{A geometry vector (e.g., \code{\link[=wkb]{wkb()}}, \code{\link[=wkt]{wkt()}}, \code{\link[=xy]{xy()}},
\code{\link[=rct]{rct()}}, or \code{\link[sf:sfc]{sf::st_sfc()}}) for which \code{\link[=wk_handle]{wk_handle()}} is defined.}

\item{...}{Passed to the \code{\link[=wk_handle]{wk_handle()}} method.}

\item{geometry_type}{An integer code for the geometry type. These
integers follow the WKB specification (e.g., 1 for point,
7 for geometrycollection).}

\item{geometry_type_label}{A character vector of (lowercase)
geometry type labels as would be found in WKT (e.g., point,
geometrycollection).}
}
\value{
A data.frame with columns:
\itemize{
\item \code{geometry_type}: An integer identifying the geometry type.
A value of 0 indicates that the types of geometry in the vector
are not known without parsing the entire vector.
\item \code{size}: For points and linestrings, the number of coordinates; for
polygons, the number of rings; for collections, the number of
child geometries. A value of zero indicates an EMPTY geometry.
A value of \code{NA} means this value is unknown without parsing the
entire geometry.
\item \code{has_z}: \code{TRUE} if coordinates contain a Z value. A value of \code{NA}
means this value is unknown without parsing the entire vector.
\item \code{has_m}: \code{TRUE} if coordinates contain an M value. A value of \code{NA}
means this value is unknown without parsing the entire vector.
\item \code{srid}: An integer identifying a CRS or NA if this value was not
provided.
\item \code{precision}: A grid size or 0.0 if a grid size was not provided.
Note that coordinate values may not have been rounded; the grid
size only refers to the level of detail with which they should
be interpreted.
\item \code{is_empty}: \code{TRUE} if there is at least one non-empty coordinate.
For the purposes of this value, a non-empty coordinate is one that
contains at least one value that is not \code{NA} or \code{NaN}.
}
}
\description{
These functions return the non-coordinate information of a geometry
and/or vector. They do not parse an entire geometry/vector and are
intended to be very fast even for large vectors.
}
\examples{
wk_vector_meta(as_wkt("LINESTRING (0 0, 1 1)"))
wk_meta(as_wkt("LINESTRING (0 0, 1 1)"))
wk_meta(as_wkb("LINESTRING (0 0, 1 1)"))

wk_geometry_type_label(1:7)
wk_geometry_type(c("point", "geometrycollection"))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/xyzm.R
\name{xy}
\alias{xy}
\alias{xyz}
\alias{xym}
\alias{xyzm}
\alias{xy_dims}
\alias{as_xy}
\alias{as_xy.default}
\alias{as_xy.wk_xy}
\alias{as_xy.matrix}
\alias{as_xy.data.frame}
\title{Efficient point vectors}
\usage{
xy(x = double(), y = double(), crs = wk_crs_auto())

xyz(x = double(), y = double(), z = double(), crs = wk_crs_auto())

xym(x = double(), y = double(), m = double(), crs = wk_crs_auto())

xyzm(
  x = double(),
  y = double(),
  z = double(),
  m = double(),
  crs = wk_crs_auto()
)

xy_dims(x)

as_xy(x, ...)

\method{as_xy}{default}(x, ..., dims = NULL)

\method{as_xy}{wk_xy}(x, ..., dims = NULL)

\method{as_xy}{matrix}(x, ..., crs = NULL)

\method{as_xy}{data.frame}(x, ..., dims = NULL, crs = NULL)
}
\arguments{
\item{x, y, z, m}{Coordinate values.}

\item{crs}{A value to be propagated as the CRS for this vector.}

\item{...}{Passed to methods.}

\item{dims}{A set containing one or more of \code{c("x", "y", "z", "m")}.}
}
\value{
A vector of coordinate values.
}
\description{
Efficient point vectors
}
\examples{
xy(1:5, 1:5)
xyz(1:5, 1:5, 10)
xym(1:5, 1:5, 10)
xyzm(1:5, 1:5, 10, 12)

# NA, NA maps to a null/na feature; NaN, NaN maps to EMPTY
as_wkt(xy(NaN, NaN))
as_wkt(xy(NA, NA))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/grd.R
\name{grd}
\alias{grd}
\alias{grd_rct}
\alias{grd_xy}
\alias{as_grd_rct}
\alias{as_grd_rct.wk_grd_rct}
\alias{as_grd_rct.wk_grd_xy}
\alias{as_grd_xy}
\alias{as_grd_xy.wk_grd_xy}
\alias{as_grd_xy.wk_grd_rct}
\title{Raster-like objects}
\usage{
grd(
  bbox = NULL,
  nx = NULL,
  ny = NULL,
  dx = NULL,
  dy = NULL,
  type = c("polygons", "corners", "centers")
)

grd_rct(data, bbox = rct(0, 0, dim(data)[2], dim(data)[1]))

grd_xy(data, bbox = rct(0, 0, dim(data)[2] - 1, dim(data)[1] - 1))

as_grd_rct(x, ...)

\method{as_grd_rct}{wk_grd_rct}(x, ...)

\method{as_grd_rct}{wk_grd_xy}(x, ...)

as_grd_xy(x, ...)

\method{as_grd_xy}{wk_grd_xy}(x, ...)

\method{as_grd_xy}{wk_grd_rct}(x, ...)
}
\arguments{
\item{bbox}{A \code{\link[=rct]{rct()}} containing the bounds and CRS of the object. You can
specify a \code{\link[=rct]{rct()}} with \code{xmin > xmax} or \code{ymin > ymax} which will flip
the underlying data and return an object with a normalized bounding
box and data.}

\item{nx, ny, dx, dy}{Either a number of cells in the x- and y- directions
or delta in the x- and y-directions (in which case \code{bbox} must
be specified).}

\item{type}{Use "polygons" to return a grid whose objects can be
represented using an \code{\link[=rct]{rct()}}; use "centers" to return a grid whose
objects are the center of the \code{\link[=rct]{rct()}} grid; use "corners" to return
a grid along the corners of \code{bbox}.}

\item{data}{An object with two or more dimensions. Most usefully, a matrix.}

\item{x}{An object to convert to a grid}

\item{...}{Passed to S3 methods}
}
\value{
\itemize{
\item \code{grd()} returns a \code{grd_rct()} for \verb{type == "polygons} or
a \code{grd_xy()} otherwise.
\item \code{grd_rct()} returns an object of class "wk_grd_rct".
\item \code{grd_xy()} returns an object of class "wk_grd_xy".
}
}
\description{
\code{\link[=grd]{grd()}} objects are just an array (any object with more than
two \code{\link[=dim]{dim()}}s) and a bounding box (a \code{\link[=rct]{rct()}}, which may or
may not have a \code{\link[=wk_crs]{wk_crs()}} attached). The ordering of the dimensions
is y (indices increasing downwards), x (indices increasing to the right).
This follows the ordering of \code{\link[=as.raster]{as.raster()}}/\code{\link[=rasterImage]{rasterImage()}} and aligns
with the printing of matrices.
}
\examples{
# create a grid with no data (just for coordinates)
(grid <- grd(nx = 2, ny = 2))
as_rct(grid)
as_xy(grid)
plot(grid, border = "black")

# more usefully, wraps a matrix or nd array + bbox
# approx volcano in New Zealand Transverse Mercator
bbox <- rct(
  5917000,       1757000 + 870,
  5917000 + 610, 1757000,
  crs = "EPSG:2193"
)
(grid <- grd_rct(volcano, bbox))

# these come with a reasonable default plot method for matrix data
plot(grid)

# you can set the data or the bounding box after creation
grid$bbox <- rct(0, 0, 1, 1)

# subset by indices or rct
plot(grid[1:2, 1:2])
plot(grid[c(start = NA, stop = NA, step = 2), c(start = NA, stop = NA, step = 2)])
plot(grid[rct(0, 0, 0.5, 0.5)])

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/make.R
\name{wk_linestring}
\alias{wk_linestring}
\alias{wk_polygon}
\alias{wk_collection}
\alias{wk_linestring_filter}
\alias{wk_polygon_filter}
\alias{wk_collection_filter}
\title{Create lines, polygons, and collections}
\usage{
wk_linestring(handleable, feature_id = 1L, ..., geodesic = NULL)

wk_polygon(handleable, feature_id = 1L, ring_id = 1L, ..., geodesic = NULL)

wk_collection(
  handleable,
  geometry_type = wk_geometry_type("geometrycollection"),
  feature_id = 1L,
  ...
)

wk_linestring_filter(handler, feature_id = 1L)

wk_polygon_filter(handler, feature_id = 1L, ring_id = 1L)

wk_collection_filter(
  handler,
  geometry_type = wk_geometry_type("geometrycollection"),
  feature_id = 1L
)
}
\arguments{
\item{handleable}{A geometry vector (e.g., \code{\link[=wkb]{wkb()}}, \code{\link[=wkt]{wkt()}}, \code{\link[=xy]{xy()}},
\code{\link[=rct]{rct()}}, or \code{\link[sf:sfc]{sf::st_sfc()}}) for which \code{\link[=wk_handle]{wk_handle()}} is defined.}

\item{feature_id}{An identifier where changes in sequential
values indicate a new feature. This is recycled silently
as needed.}

\item{...}{Passed to the \code{\link[=wk_handle]{wk_handle()}} method.}

\item{geodesic}{Use \code{TRUE} or \code{FALSE} to explicitly force
the geodesic-ness of the output.}

\item{ring_id}{An identifier where changes in sequential
values indicate a new ring. Rings are automatically
closed. This is recycled silently as needed.}

\item{geometry_type}{The collection type to create.}

\item{handler}{A \link[=wk_handle]{wk_handler} object.}
}
\value{
An object of the same class as \code{handleable} with
whose coordinates have been assembled into the given
type.
}
\description{
Create lines, polygons, and collections
}
\examples{
wk_linestring(xy(c(1, 1), c(2, 3)))
wk_polygon(xy(c(0, 1, 0), c(0, 0, 1)))
wk_collection(xy(c(1, 1), c(2, 3)))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/crc.R
\name{crc_x}
\alias{crc_x}
\alias{crc_y}
\alias{crc_center}
\alias{crc_r}
\title{Circle accessors}
\usage{
crc_x(x)

crc_y(x)

crc_center(x)

crc_r(x)
}
\arguments{
\item{x}{A \code{\link[=crc]{crc()}} vector}
}
\value{
Components of the \code{\link[=crc]{crc()}} vector
}
\description{
Circle accessors
}
\examples{
x <- crc(1, 2, r = 3)
crc_x(x)
crc_y(x)
crc_r(x)
crc_center(x)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/grd.R
\name{new_wk_grd}
\alias{new_wk_grd}
\title{S3 details for grid objects}
\usage{
new_wk_grd(x, subclass = character())
}
\arguments{
\item{x}{A \code{\link[=grd]{grd()}}}

\item{subclass}{An optional subclass.}
}
\value{
An object inheriting from 'grd'
}
\description{
S3 details for grid objects
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/crc.R
\name{new_wk_crc}
\alias{new_wk_crc}
\title{S3 details for crc objects}
\usage{
new_wk_crc(x = list(x = double(), y = double(), r = double()), crs = NULL)
}
\arguments{
\item{x}{A \code{\link[=crc]{crc()}}}

\item{crs}{A value to be propagated as the CRS for this vector.}
}
\description{
S3 details for crc objects
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/handle-wkt.R
\name{handle_wkt_without_vector_size}
\alias{handle_wkt_without_vector_size}
\title{Test handlers for handling of unknown size vectors}
\usage{
handle_wkt_without_vector_size(handleable, handler)
}
\arguments{
\item{handleable}{A geometry vector (e.g., \code{\link[=wkb]{wkb()}}, \code{\link[=wkt]{wkt()}}, \code{\link[=xy]{xy()}},
\code{\link[=rct]{rct()}}, or \code{\link[sf:sfc]{sf::st_sfc()}}) for which \code{\link[=wk_handle]{wk_handle()}} is defined.}

\item{handler}{A \link[=wk_handle]{wk_handler} object.}
}
\description{
Test handlers for handling of unknown size vectors
}
\examples{
handle_wkt_without_vector_size(wkt(), wk_vector_meta_handler())

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/class-data-frame.R, R/pkg-sf.R
\name{wk_handle.data.frame}
\alias{wk_handle.data.frame}
\alias{wk_restore.data.frame}
\alias{wk_restore.tbl_df}
\alias{wk_translate.data.frame}
\alias{wk_translate.tbl_df}
\alias{wk_translate.sf}
\alias{wk_restore.sf}
\title{Use data.frame with wk}
\usage{
\method{wk_handle}{data.frame}(handleable, handler, ...)

\method{wk_restore}{data.frame}(handleable, result, ...)

\method{wk_restore}{tbl_df}(handleable, result, ...)

\method{wk_translate}{data.frame}(handleable, to, ...)

\method{wk_translate}{tbl_df}(handleable, to, ...)

\method{wk_translate}{sf}(handleable, to, ...)

\method{wk_restore}{sf}(handleable, result, ...)
}
\arguments{
\item{handleable}{A geometry vector (e.g., \code{\link[=wkb]{wkb()}}, \code{\link[=wkt]{wkt()}}, \code{\link[=xy]{xy()}},
\code{\link[=rct]{rct()}}, or \code{\link[sf:sfc]{sf::st_sfc()}}) for which \code{\link[=wk_handle]{wk_handle()}} is defined.}

\item{handler}{A \link[=wk_handle]{wk_handler} object.}

\item{...}{Passed to the \code{\link[=wk_handle]{wk_handle()}} method.}

\item{result}{The result of a filter operation intended to be a
transformation.}

\item{to}{A prototype object.}
}
\description{
Use data.frame with wk
}
\examples{
wk_handle(data.frame(a = wkt("POINT (0 1)")), wkb_writer())
wk_translate(wkt("POINT (0 1)"), data.frame(col_name = wkb()))
wk_translate(data.frame(a = wkt("POINT (0 1)")), data.frame(wkb()))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pkg-sf.R, R/sfc-writer.R, R/wkb-writer.R,
%   R/wkt-writer.R, R/writer.R, R/xy-writer.R
\name{wk_writer.sfc}
\alias{wk_writer.sfc}
\alias{wk_writer.sf}
\alias{sfc_writer}
\alias{wkb_writer}
\alias{wkt_writer}
\alias{wk_writer}
\alias{wk_writer.default}
\alias{wk_writer.wk_wkt}
\alias{wk_writer.wk_wkb}
\alias{wk_writer.wk_xy}
\alias{xy_writer}
\title{Write geometry vectors}
\usage{
\method{wk_writer}{sfc}(handleable, ...)

\method{wk_writer}{sf}(handleable, ...)

sfc_writer(promote_multi = FALSE)

wkb_writer(buffer_size = 2048L, endian = NA_integer_)

wkt_writer(precision = 16L, trim = TRUE)

wk_writer(handleable, ..., generic = FALSE)

\method{wk_writer}{default}(handleable, ...)

\method{wk_writer}{wk_wkt}(handleable, ..., precision = 16, trim = TRUE)

\method{wk_writer}{wk_wkb}(handleable, ...)

\method{wk_writer}{wk_xy}(handleable, ..., generic = FALSE)

xy_writer()
}
\arguments{
\item{handleable}{A geometry vector (e.g., \code{\link[=wkb]{wkb()}}, \code{\link[=wkt]{wkt()}}, \code{\link[=xy]{xy()}},
\code{\link[=rct]{rct()}}, or \code{\link[sf:sfc]{sf::st_sfc()}}) for which \code{\link[=wk_handle]{wk_handle()}} is defined.}

\item{...}{Passed to the writer constructor.}

\item{promote_multi}{Use TRUE to promote all simple geometries to a multi
type when reading to sfc. This is useful to increase the likelihood that
the sfc will contain a single geometry type.}

\item{buffer_size}{Control the initial buffer size used when writing WKB.}

\item{endian}{Use 1 for little endian, 0 for big endian, or NA for
system endian.}

\item{precision}{If \code{trim} is \code{TRUE}, the total number of significant digits to keep
for each result or the number of digits after the decimal place otherwise.}

\item{trim}{Use \code{FALSE} to keep trailing zeroes after the decimal place.}

\item{generic}{Use \code{TRUE} to obtain a writer that can write all geometry
types.}
}
\value{
A \link[=wk_handle]{wk_handler}.
}
\description{
When writing transformation functions, it is often useful to know which
handler should be used to create a (potentially modified) version
of an object. Some transformers (e.g., \code{\link[=wk_vertices]{wk_vertices()}}) modify
the geometry type of an object, in which case a generic writer is needed.
This defaults to \code{\link[=wkb_writer]{wkb_writer()}} because it is fast and can handle
all geometry types.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/grd.R
\name{grd_summary}
\alias{grd_summary}
\title{Grid information}
\usage{
grd_summary(grid)
}
\arguments{
\item{grid}{A \code{\link[=grd_xy]{grd_xy()}}, \code{\link[=grd_rct]{grd_rct()}}, or other object
implementing \verb{grd_*()} methods.}
}
\value{
\itemize{
\item \code{grd_summary()} returns a \code{list()} with components
\code{xmin}, \code{ymin}, \code{xmax}, \code{ymax},
\code{nx}, \code{ny}, \code{dx}, \code{dy}, \code{width}, and \code{height}.
}
}
\description{
Grid information
}
\examples{
grd_summary(grd(nx = 3, ny = 2))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{wk_example}
\alias{wk_example}
\alias{wk_example_wkt}
\title{Create example geometry objects}
\format{
An object of class \code{list} of length 29.
}
\usage{
wk_example(which = "nc", crs = NA, geodesic = FALSE)

wk_example_wkt
}
\arguments{
\item{which}{An example name. Valid example names are
\itemize{
\item "nc" (data derived from the sf package)
\item "point", "linestring", "polygon", "multipoint",
"multilinestring", "multipolygon", "geometrycollection"
\item One of the above with the "_z", "_m", or "_zm" suffix.
}}

\item{crs}{An object that can be interpreted as a CRS}

\item{geodesic}{\code{TRUE} if edges must be interpolated as geodesics when
coordinates are spherical, \code{FALSE} otherwise.}
}
\value{
A \code{\link[=wkt]{wkt()}} with the specified example.
}
\description{
Create example geometry objects
}
\examples{
wk_example("polygon")

}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/chunk.R
\name{wk_chunk_strategy_single}
\alias{wk_chunk_strategy_single}
\alias{wk_chunk_strategy_feature}
\alias{wk_chunk_strategy_coordinates}
\title{Chunking strategies}
\usage{
wk_chunk_strategy_single()

wk_chunk_strategy_feature(n_chunks = NULL, chunk_size = NULL)

wk_chunk_strategy_coordinates(n_chunks = NULL, chunk_size = NULL, reduce = "*")
}
\arguments{
\item{n_chunks, chunk_size}{Exactly one of the number of
chunks or the chunk size. For \code{\link[=wk_chunk_strategy_feature]{wk_chunk_strategy_feature()}}
the chunk size refers to the number of features; for
\code{\link[=wk_chunk_strategy_coordinates]{wk_chunk_strategy_coordinates()}} this refers to the number
of coordinates as calculated from multiple handleables
using \code{reduce}.}

\item{reduce}{For \code{\link[=wk_chunk_strategy_coordinates]{wk_chunk_strategy_coordinates()}} this refers to
the function used with \code{\link[=Reduce]{Reduce()}} to combine coordinate counts
from more than one handleable.}
}
\value{
A function that returns a \code{data.frame} with columns \code{from} and \code{to}
when called with a \code{handleable} and the feature count.
}
\description{
It is often impractical, inefficient, or impossible to perform
an operation on a vector of geometries with all the geometries loaded
into memory at the same time. These functions help generalize the
pattern of split-apply-combine to one or more handlers recycled along a
common length. These functions are designed for developers rather than users
and should be considered experimental.
}
\examples{
feat <- c(as_wkt(xy(1:4, 1:4)), wkt("LINESTRING (1 1, 2 2)"))
wk_chunk_strategy_single()(list(feat), 5)
wk_chunk_strategy_feature(chunk_size = 2)(list(feat), 5)
wk_chunk_strategy_coordinates(chunk_size = 2)(list(feat), 5)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot.R
\name{wk_plot}
\alias{wk_plot}
\alias{wk_plot.default}
\alias{plot.wk_wkt}
\alias{plot.wk_wkb}
\alias{plot.wk_xy}
\alias{plot.wk_rct}
\alias{plot.wk_crc}
\title{Plot well-known geometry vectors}
\usage{
wk_plot(
  handleable,
  ...,
  asp = 1,
  bbox = NULL,
  xlab = "",
  ylab = "",
  rule = "evenodd",
  add = FALSE
)

\method{wk_plot}{default}(
  handleable,
  ...,
  asp = 1,
  bbox = NULL,
  xlab = "",
  ylab = "",
  rule = "evenodd",
  add = FALSE
)

\method{plot}{wk_wkt}(
  x,
  ...,
  asp = 1,
  bbox = NULL,
  xlab = "",
  ylab = "",
  rule = "evenodd",
  add = FALSE
)

\method{plot}{wk_wkb}(
  x,
  ...,
  asp = 1,
  bbox = NULL,
  xlab = "",
  ylab = "",
  rule = "evenodd",
  add = FALSE
)

\method{plot}{wk_xy}(x, ..., asp = 1, bbox = NULL, xlab = "", ylab = "", add = FALSE)

\method{plot}{wk_rct}(x, ..., asp = 1, bbox = NULL, xlab = "", ylab = "", add = FALSE)

\method{plot}{wk_crc}(x, ..., asp = 1, bbox = NULL, xlab = "", ylab = "", add = FALSE)
}
\arguments{
\item{handleable}{A geometry vector (e.g., \code{\link[=wkb]{wkb()}}, \code{\link[=wkt]{wkt()}}, \code{\link[=xy]{xy()}},
\code{\link[=rct]{rct()}}, or \code{\link[sf:sfc]{sf::st_sfc()}}) for which \code{\link[=wk_handle]{wk_handle()}} is defined.}

\item{...}{Passed to plotting functions for features: \code{\link[graphics:points]{graphics::points()}}
for point and multipoint geometries, \code{\link[graphics:lines]{graphics::lines()}} for linestring
and multilinestring geometries, and \code{\link[graphics:polypath]{graphics::polypath()}} for polygon
and multipolygon geometries.}

\item{asp, xlab, ylab}{Passed to \code{\link[graphics:plot.default]{graphics::plot()}}}

\item{bbox}{The limits of the plot as a \code{\link[=rct]{rct()}} or compatible object}

\item{rule}{The rule to use for filling polygons (see \code{\link[graphics:polypath]{graphics::polypath()}})}

\item{add}{Should a new plot be created, or should \code{handleable} be added to the
existing plot?}

\item{x}{A \code{\link[=wkb]{wkb()}} or \code{\link[=wkt]{wkt()}}}
}
\value{
The input, invisibly.
}
\description{
Plot well-known geometry vectors
}
\examples{
plot(as_wkt("LINESTRING (0 0, 1 1)"))
plot(as_wkb("LINESTRING (0 0, 1 1)"))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/xyzm.R
\name{xy_x}
\alias{xy_x}
\alias{xy_y}
\alias{xy_z}
\alias{xy_m}
\title{XY vector extractors}
\usage{
xy_x(x)

xy_y(x)

xy_z(x)

xy_m(x)
}
\arguments{
\item{x}{An \code{\link[=xy]{xy()}} vector}
}
\value{
Components of the \code{\link[=xy]{xy()}} vector or NULL if the dimension is missing
}
\description{
XY vector extractors
}
\examples{
x <- xyz(1:5, 6:10, 11:15)
xy_x(x)
xy_y(x)
xy_z(x)
xy_m(x)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/grd-tile.R
\name{grd_tile}
\alias{grd_tile}
\alias{grd_tile.wk_grd_rct}
\alias{grd_tile.wk_grd_xy}
\title{Extract normalized grid tiles}
\usage{
grd_tile(grid, level, i, j = NULL)

\method{grd_tile}{wk_grd_rct}(grid, level, i, j = NULL)

\method{grd_tile}{wk_grd_xy}(grid, level, i, j = NULL)
}
\arguments{
\item{grid}{A \code{\link[=grd_xy]{grd_xy()}}, \code{\link[=grd_rct]{grd_rct()}}, or other object
implementing \verb{grd_*()} methods.}

\item{level}{An integer describing the overview level. This is related to
the \code{step} value by a power of 2 (i.e., a level of \code{1} indicates a step of
\code{2}, a level of \code{2} indicates a step of \code{4}, etc.).}

\item{i, j}{1-based index values. \code{i} indices correspond to decreasing
\code{y} values; \code{j} indices correspond to increasing \code{x} values.
Values outside the range \code{1:nrow|ncol(data)} will be censored to
\code{NA} including 0 and negative values.}
}
\value{
A \code{\link[=grd_subset]{grd_subset()}}ed version
}
\description{
Unlike \code{\link[=grd_tile_template]{grd_tile_template()}}, which returns a \code{\link[=grd]{grd()}} whose elements are
the boundaries of the specified tiles with no data attached, \code{\link[=grd_tile]{grd_tile()}}
returns the actual tile with the data.
}
\examples{
grid <- grd_rct(volcano)
plot(grd_tile(grid, 4, 1, 1))

plot(grd_tile(grid, 3, 1, 1), add = TRUE)
plot(grd_tile(grid, 3, 1, 2), add = TRUE)
plot(grd_tile(grid, 3, 2, 1), add = TRUE)
plot(grd_tile(grid, 3, 2, 2), add = TRUE)

grid <- as_grd_xy(grd_tile(grid, 4, 1, 1))
plot(grid, add = TRUE, pch = ".")
plot(grd_tile(grid, 3, 1, 1), add = TRUE, col = "green", pch = ".")
plot(grd_tile(grid, 3, 1, 2), add = TRUE, col = "red", pch = ".")
plot(grd_tile(grid, 3, 2, 1), add = TRUE, col = "blue", pch = ".")
plot(grd_tile(grid, 3, 2, 2), add = TRUE, col = "magenta", pch = ".")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/grd-plot.R
\name{plot.wk_grd_xy}
\alias{plot.wk_grd_xy}
\alias{plot.wk_grd_rct}
\title{Plot grid objects}
\usage{
\method{plot}{wk_grd_xy}(x, ...)

\method{plot}{wk_grd_rct}(
  x,
  ...,
  image = NULL,
  interpolate = FALSE,
  oversample = 4,
  border = NA,
  asp = 1,
  bbox = NULL,
  xlab = "",
  ylab = "",
  add = FALSE
)
}
\arguments{
\item{x}{A \code{\link[=wkb]{wkb()}} or \code{\link[=wkt]{wkt()}}}

\item{...}{Passed to plotting functions for features: \code{\link[graphics:points]{graphics::points()}}
for point and multipoint geometries, \code{\link[graphics:lines]{graphics::lines()}} for linestring
and multilinestring geometries, and \code{\link[graphics:polypath]{graphics::polypath()}} for polygon
and multipolygon geometries.}

\item{image}{A raster or nativeRaster to pass to \code{\link[graphics:rasterImage]{graphics::rasterImage()}}.
use \code{NULL} to do a quick-and-dirty rescale of the data such that the low
value is black and the high value is white.}

\item{interpolate}{Use \code{TRUE} to perform interpolation between color values.}

\item{oversample}{A scale on the number of pixels on the device to use for
sampling estimation of large raster values. Use \code{Inf} to disable.}

\item{border}{Color to use for polygon borders. Use \code{NULL} for the default
and \code{NA} to skip plotting borders.}

\item{asp, xlab, ylab}{Passed to \code{\link[graphics:plot.default]{graphics::plot()}}}

\item{bbox}{The limits of the plot as a \code{\link[=rct]{rct()}} or compatible object}

\item{add}{Should a new plot be created, or should \code{handleable} be added to the
existing plot?}
}
\value{
\code{x}, invisibly.
}
\description{
Plot grid objects
}
\examples{
plot(grd_rct(volcano))
plot(grd_xy(volcano))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/crc.R
\name{crc}
\alias{crc}
\alias{as_crc}
\alias{as_crc.wk_crc}
\alias{as_crc.matrix}
\alias{as_crc.data.frame}
\title{2D Circle Vectors}
\usage{
crc(x = double(), y = double(), r = double(), crs = wk_crs_auto())

as_crc(x, ...)

\method{as_crc}{wk_crc}(x, ...)

\method{as_crc}{matrix}(x, ..., crs = NULL)

\method{as_crc}{data.frame}(x, ..., crs = NULL)
}
\arguments{
\item{x, y}{Coordinates of the center}

\item{r}{Circle radius}

\item{crs}{A value to be propagated as the CRS for this vector.}

\item{...}{Extra arguments passed to \code{as_crc()}.}
}
\value{
A vector along the recycled length of bounds.
}
\description{
2D Circle Vectors
}
\examples{
crc(1, 2, 3)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pkg-sf.R, R/translate.R
\name{wk_translate.sfc}
\alias{wk_translate.sfc}
\alias{wk_translate}
\alias{wk_translate.default}
\title{Translate geometry vectors}
\usage{
\method{wk_translate}{sfc}(handleable, to, ...)

wk_translate(handleable, to, ...)

\method{wk_translate}{default}(handleable, to, ...)
}
\arguments{
\item{handleable}{A geometry vector (e.g., \code{\link[=wkb]{wkb()}}, \code{\link[=wkt]{wkt()}}, \code{\link[=xy]{xy()}},
\code{\link[=rct]{rct()}}, or \code{\link[sf:sfc]{sf::st_sfc()}}) for which \code{\link[=wk_handle]{wk_handle()}} is defined.}

\item{to}{A prototype object.}

\item{...}{Passed to the \code{\link[=wk_handle]{wk_handle()}} method.}
}
\description{
Translate geometry vectors
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pkg-vctrs.R
\name{vctrs-methods}
\alias{vctrs-methods}
\alias{vec_cast.wk_wkb}
\alias{vec_ptype2.wk_wkb}
\alias{vec_cast.wk_wkt}
\alias{vec_ptype2.wk_wkt}
\alias{vec_cast.wk_xy}
\alias{vec_ptype2.wk_xy}
\alias{vec_cast.wk_xyz}
\alias{vec_ptype2.wk_xyz}
\alias{vec_cast.wk_xym}
\alias{vec_ptype2.wk_xym}
\alias{vec_cast.wk_xyzm}
\alias{vec_ptype2.wk_xyzm}
\alias{vec_cast.wk_rct}
\alias{vec_ptype2.wk_rct}
\alias{vec_cast.wk_crc}
\alias{vec_ptype2.wk_crc}
\title{Vctrs methods}
\usage{
vec_cast.wk_wkb(x, to, ...)

vec_ptype2.wk_wkb(x, y, ...)

vec_cast.wk_wkt(x, to, ...)

vec_ptype2.wk_wkt(x, y, ...)

vec_cast.wk_xy(x, to, ...)

vec_ptype2.wk_xy(x, y, ...)

vec_cast.wk_xyz(x, to, ...)

vec_ptype2.wk_xyz(x, y, ...)

vec_cast.wk_xym(x, to, ...)

vec_ptype2.wk_xym(x, y, ...)

vec_cast.wk_xyzm(x, to, ...)

vec_ptype2.wk_xyzm(x, y, ...)

vec_cast.wk_rct(x, to, ...)

vec_ptype2.wk_rct(x, y, ...)

vec_cast.wk_crc(x, to, ...)

vec_ptype2.wk_crc(x, y, ...)
}
\arguments{
\item{x, y, to, ...}{See \code{\link[vctrs:vec_cast]{vctrs::vec_cast()}} and \code{\link[vctrs:vec_ptype2]{vctrs::vec_ptype2()}}.}
}
\description{
Vctrs methods
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/grd-handle.R
\name{wk_handle.wk_grd_xy}
\alias{wk_handle.wk_grd_xy}
\alias{wk_handle.wk_grd_rct}
\title{Handler interface for grid objects}
\usage{
\method{wk_handle}{wk_grd_xy}(handleable, handler, ..., data_order = c("y", "x"))

\method{wk_handle}{wk_grd_rct}(handleable, handler, ..., data_order = c("y", "x"))
}
\arguments{
\item{handleable}{A geometry vector (e.g., \code{\link[=wkb]{wkb()}}, \code{\link[=wkt]{wkt()}}, \code{\link[=xy]{xy()}},
\code{\link[=rct]{rct()}}, or \code{\link[sf:sfc]{sf::st_sfc()}}) for which \code{\link[=wk_handle]{wk_handle()}} is defined.}

\item{handler}{A \link[=wk_handle]{wk_handler} object.}

\item{...}{Passed to the \code{\link[=wk_handle]{wk_handle()}} method.}

\item{data_order}{A vector of length 2 describing the order in which
values should appear. The default, \code{c("y", "x")}, will output values
in the same order as the default matrix storage in R (column-major).
You can prefix a dimension with \code{-} to reverse the order of a
dimension (e.g., \code{c("-y", "x")}).}
}
\value{
The result of the \code{handler}.
}
\description{
Handler interface for grid objects
}
\examples{
wk_handle(grd(nx = 3, ny = 3), wkt_writer())
wk_handle(grd(nx = 3, ny = 3, type = "centers"), wkt_writer())

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/wk-package.R
\docType{package}
\name{wk-package}
\alias{wk}
\alias{wk-package}
\title{wk: Lightweight Well-Known Geometry Parsing}
\description{
Provides a minimal R and C++ API for parsing well-known binary and well-known text representation of geometries to and from R-native formats. Well-known binary is compact and fast to parse; well-known text is human-readable and is useful for writing tests. These formats are useful in R only if the information they contain can be accessed in R, for which high-performance functions are provided here.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://paleolimbot.github.io/wk/}
  \item \url{https://github.com/paleolimbot/wk}
  \item Report bugs at \url{https://github.com/paleolimbot/wk/issues}
}

}
\author{
\strong{Maintainer}: Dewey Dunnington \email{dewey@fishandwhistle.net} (\href{https://orcid.org/0000-0002-9415-4582}{ORCID})

Authors:
\itemize{
  \item Edzer Pebesma \email{edzer.pebesma@uni-muenster.de} (\href{https://orcid.org/0000-0001-8049-7069}{ORCID})
}

Other contributors:
\itemize{
  \item Anthony North \email{anthony.jl.north@gmail.com} [contributor]
}

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/affine.R
\name{wk_trans_affine}
\alias{wk_trans_affine}
\alias{wk_affine_identity}
\alias{wk_affine_rotate}
\alias{wk_affine_scale}
\alias{wk_affine_translate}
\alias{wk_affine_fit}
\alias{wk_affine_rescale}
\alias{wk_affine_compose}
\alias{wk_affine_invert}
\title{Affine transformer}
\usage{
wk_trans_affine(trans_matrix)

wk_affine_identity()

wk_affine_rotate(rotation_deg)

wk_affine_scale(scale_x = 1, scale_y = 1)

wk_affine_translate(dx = 0, dy = 0)

wk_affine_fit(src, dst)

wk_affine_rescale(rct_in, rct_out)

wk_affine_compose(...)

wk_affine_invert(x)
}
\arguments{
\item{trans_matrix}{A 3x3 transformation matrix}

\item{rotation_deg}{A rotation to apply in degrees counterclockwise.}

\item{scale_x, scale_y}{Scale factor to apply in the x and y directions, respectively}

\item{dx, dy}{Coordinate offsets in the x and y direction}

\item{src, dst}{Point vectors of control points used to estimate the affine mapping
(using \code{\link[base:qr]{base::qr.solve()}}).}

\item{rct_in, rct_out}{The input and output bounds}

\item{...}{Zero or more transforms in the order they should be applied.}

\item{x}{A \code{\link[=wk_trans_affine]{wk_trans_affine()}}}
}
\description{
Affine transformer
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/wk-crs.R
\name{wk_crs_inherit}
\alias{wk_crs_inherit}
\alias{wk_crs_longlat}
\alias{wk_crs_auto}
\alias{wk_crs_auto_value}
\title{Special CRS values}
\usage{
wk_crs_inherit()

wk_crs_longlat(crs = NULL)

wk_crs_auto()

wk_crs_auto_value(x, crs)
}
\arguments{
\item{crs}{A value for the coordinate reference system supplied by
the user.}

\item{x}{A raw input to a construuctor whose length and crs attributte
is used to determine the default CRS returned by \code{\link[=wk_crs_auto]{wk_crs_auto()}}.}
}
\description{
The CRS handling in the wk package requires two sentinel CRS values.
The first, \code{\link[=wk_crs_inherit]{wk_crs_inherit()}}, signals that the vector should inherit
a CRS of another vector if combined. This is useful for empty, \code{NULL},
and/or zero-length geometries. The second, \code{\link[=wk_crs_auto]{wk_crs_auto()}}, is used
as the default argument of \code{crs} for constructors so that zero-length
geometries are assigned a CRS of \code{wk_crs_inherit()} by default.
}
\examples{
wk_crs_auto_value(list(), wk_crs_auto())
wk_crs_auto_value(list(), 1234)
wk_crs_auto_value(list(NULL), wk_crs_auto())

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/wk-crs.R
\name{wk_crs_equal}
\alias{wk_crs_equal}
\alias{wk_crs_equal_generic}
\title{Compare CRS objects}
\usage{
wk_crs_equal(x, y)

wk_crs_equal_generic(x, y, ...)
}
\arguments{
\item{x, y}{Objects stored in the \code{crs} attribute of a vector.}

\item{...}{Unused}
}
\value{
\code{TRUE} if \code{x} and \code{y} can be considered equal, \code{FALSE} otherwise.
}
\description{
The \code{\link[=wk_crs_equal]{wk_crs_equal()}} function uses special S3 dispatch on \code{\link[=wk_crs_equal_generic]{wk_crs_equal_generic()}}
to evaluate whether or not two CRS values can be considered equal. When implementing
\code{\link[=wk_crs_equal_generic]{wk_crs_equal_generic()}}, every attempt should be made to make \code{wk_crs_equal(x, y)}
and \code{wk_crs_equal(y, x)} return identically.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/trans-explicit.R
\name{wk_trans_explicit}
\alias{wk_trans_explicit}
\title{Transform using explicit coordinate values}
\usage{
wk_trans_explicit(value, use_z = NA, use_m = NA)
}
\arguments{
\item{value}{An \code{\link[=xy]{xy()}}, \code{\link[=xyz]{xyz()}}, \code{\link[=xym]{xym()}}, or \code{\link[=xyzm]{xyzm()}} of coordinates
used to replace values in the input. Use \code{NA} to keep the existing
value.}

\item{use_z, use_m}{Used to declare the output type. Use \code{TRUE} to
ensure the output has that dimension, \code{FALSE} to ensure it does not,
and \code{NA} to leave the dimension unchanged.}
}
\description{
A \link[=wk_transform]{wk_trans} implementation that replaces coordinate values
using a vector of pre-calculated coordinates. This is used to perform generic
transforms using R functions and system calls that are impossible or impractical
to implement at the C level.
}
\examples{
trans <- wk_trans_explicit(xy(1:5, 1:5))
wk_transform(rep(xy(0, 0), 5), trans)
}
\seealso{
\code{\link[=wk_coords]{wk_coords()}} which has a replacement version  "\verb{wk_coords<-}"
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/format.R
\name{wk_format}
\alias{wk_format}
\alias{wkt_format_handler}
\title{Format well-known geometry for printing}
\usage{
wk_format(handleable, precision = 7, trim = TRUE, max_coords = 6, ...)

wkt_format_handler(precision = 7, trim = TRUE, max_coords = 6)
}
\arguments{
\item{handleable}{A geometry vector (e.g., \code{\link[=wkb]{wkb()}}, \code{\link[=wkt]{wkt()}}, \code{\link[=xy]{xy()}},
\code{\link[=rct]{rct()}}, or \code{\link[sf:sfc]{sf::st_sfc()}}) for which \code{\link[=wk_handle]{wk_handle()}} is defined.}

\item{precision}{If \code{trim} is \code{TRUE}, the total number of significant digits to keep
for each result or the number of digits after the decimal place otherwise.}

\item{trim}{Use \code{FALSE} to keep trailing zeroes after the decimal place.}

\item{max_coords}{The maximum number of coordinates to include
in the output.}

\item{...}{Passed to the \code{\link[=wk_handle]{wk_handle()}} method.}
}
\value{
A character vector of abbreviated well-known text.
}
\description{
Provides an abbreviated version of the well-known text
representation of a geometry. This returns a constant
number of coordinates for each geometry, so is safe to
use for geometry vectors with many (potentially large)
features. Parse errors are passed on to the format string
and do not cause this handler to error.
}
\examples{
wk_format(wkt("MULTIPOLYGON (((0 0, 10 0, 0 10, 0 0)))"))
wk_format(new_wk_wkt("POINT ENTPY"))
wk_handle(
  wkt("MULTIPOLYGON (((0 0, 10 0, 0 10, 0 0)))"),
  wkt_format_handler()
)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/grd-subset.R
\name{grd_subset}
\alias{grd_subset}
\alias{grd_crop}
\alias{grd_extend}
\alias{grd_crop.wk_grd_rct}
\alias{grd_crop.wk_grd_xy}
\alias{grd_extend.wk_grd_rct}
\alias{grd_extend.wk_grd_xy}
\alias{grd_data_subset}
\title{Subset grid objects}
\usage{
grd_subset(grid, i = NULL, j = NULL, ...)

grd_crop(grid, bbox, ..., step = 1L, snap = NULL)

grd_extend(grid, bbox, ..., step = 1L, snap = NULL)

\method{grd_crop}{wk_grd_rct}(grid, bbox, ..., step = 1L, snap = NULL)

\method{grd_crop}{wk_grd_xy}(grid, bbox, ..., step = 1L, snap = NULL)

\method{grd_extend}{wk_grd_rct}(grid, bbox, ..., step = 1L, snap = NULL)

\method{grd_extend}{wk_grd_xy}(grid, bbox, ..., step = 1L, snap = NULL)

grd_data_subset(grid_data, i = NULL, j = NULL)
}
\arguments{
\item{grid}{A \code{\link[=grd_xy]{grd_xy()}}, \code{\link[=grd_rct]{grd_rct()}}, or other object
implementing \verb{grd_*()} methods.}

\item{i, j}{1-based index values. \code{i} indices correspond to decreasing
\code{y} values; \code{j} indices correspond to increasing \code{x} values.
Values outside the range \code{1:nrow|ncol(data)} will be censored to
\code{NA} including 0 and negative values.}

\item{...}{Passed to subset methods}

\item{bbox}{An \code{\link[=rct]{rct()}} object.}

\item{step}{The difference between adjascent indices in the output}

\item{snap}{A function that transforms real-valued indices to integer
indices (e.g., \code{\link[=floor]{floor()}}, \code{\link[=ceiling]{ceiling()}}, or \code{\link[=round]{round()}}).
For \code{\link[=grd_cell_range]{grd_cell_range()}}, a \code{list()} with exactly two elements to be called
for the minimum and maximum index values, respectively.}

\item{grid_data}{The \code{data} member of a \code{\link[=grd]{grd()}}. This is typically an
array but can also be an S3 object with an array-like subset method.
The \link[grDevices:as.raster]{native raster} is special-cased as its
subset method requires non-standard handling.}
}
\value{
A modified \code{grid} whose cell centres have not changed location
as a result of the subset.
}
\description{
The \code{\link[=grd_subset]{grd_subset()}} method handles the subsetting of a \code{\link[=grd]{grd()}}
in x-y space. Ordering of indices is not considered and logical
indies are recycled silently along dimensions. The result of
a \code{\link[=grd_subset]{grd_subset()}} is always a \code{\link[=grd]{grd()}} of the same type whose
relationship to x-y space has not changed.
}
\examples{
grid <- grd_rct(volcano)
grd_subset(grid, 1:20, 1:30)
grd_crop(grid, rct(-10, -10, 10, 10))
grd_extend(grid, rct(-10, -10, 10, 10))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/handle-crc.R, R/handle-rct.R, R/handle-sfc.R,
%   R/handle-wkb.R, R/handle-wkt.R, R/handle-xy.R, R/handler.R, R/pkg-sf.R
\name{wk_handle.wk_crc}
\alias{wk_handle.wk_crc}
\alias{wk_handle.wk_rct}
\alias{wk_handle.sfc}
\alias{wk_handle.wk_wkb}
\alias{wk_handle.wk_wkt}
\alias{wk_handle.wk_xy}
\alias{wk_handle}
\alias{is_handleable}
\alias{new_wk_handler}
\alias{is_wk_handler}
\alias{as_wk_handler}
\alias{wk_handle.sfg}
\alias{wk_handle.sf}
\alias{wk_handle.bbox}
\title{Read geometry vectors}
\usage{
\method{wk_handle}{wk_crc}(
  handleable,
  handler,
  ...,
  n_segments = getOption("wk.crc_n_segments", NULL),
  resolution = getOption("wk.crc_resolution", NULL)
)

\method{wk_handle}{wk_rct}(handleable, handler, ...)

\method{wk_handle}{sfc}(handleable, handler, ...)

\method{wk_handle}{wk_wkb}(handleable, handler, ...)

\method{wk_handle}{wk_wkt}(handleable, handler, ...)

\method{wk_handle}{wk_xy}(handleable, handler, ...)

wk_handle(handleable, handler, ...)

is_handleable(handleable)

new_wk_handler(handler_ptr, subclass = character())

is_wk_handler(handler)

as_wk_handler(handler, ...)

\method{wk_handle}{sfg}(handleable, handler, ...)

\method{wk_handle}{sf}(handleable, handler, ...)

\method{wk_handle}{bbox}(handleable, handler, ...)
}
\arguments{
\item{handleable}{A geometry vector (e.g., \code{\link[=wkb]{wkb()}}, \code{\link[=wkt]{wkt()}}, \code{\link[=xy]{xy()}},
\code{\link[=rct]{rct()}}, or \code{\link[sf:sfc]{sf::st_sfc()}}) for which \code{\link[=wk_handle]{wk_handle()}} is defined.}

\item{handler}{A \link[=wk_handle]{wk_handler} object.}

\item{...}{Passed to the \code{\link[=wk_handle]{wk_handle()}} method.}

\item{n_segments, resolution}{The number of segments to use when approximating
a circle. The default uses \code{getOption("wk.crc_n_segments")} so that
this value can be set for implicit conversions (e.g., \code{as_wkb()}).
Alternatively, set the minimum distance between points on the circle
(used to estimate \code{n_segments}). The default is obtained
using \code{getOption("wk.crc_resolution")}.}

\item{handler_ptr}{An external pointer to a newly created WK handler}

\item{subclass}{The handler subclass}
}
\value{
A WK handler.
}
\description{
The handler is the basic building block of the wk package. In
particular, the \code{\link[=wk_handle]{wk_handle()}} generic allows operations written
as handlers to "just work" with many different input types. The
wk package provides the \code{\link[=wk_void]{wk_void()}} handler, the \code{\link[=wk_format]{wk_format()}}
handler, the \code{\link[=wk_debug]{wk_debug()}} handler, the \code{\link[=wk_problems]{wk_problems()}} handler,
and \code{\link[=wk_writer]{wk_writer()}}s for \code{\link[=wkb]{wkb()}}, \code{\link[=wkt]{wkt()}}, \code{\link[=xy]{xy()}}, and \code{\link[sf:sfc]{sf::st_sfc()}})
vectors.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/grd-tile.R
\name{grd_tile_template}
\alias{grd_tile_template}
\alias{grd_tile_summary}
\title{Compute overview grid tile}
\usage{
grd_tile_template(grid, level)

grd_tile_summary(grid, levels = NULL)
}
\arguments{
\item{grid}{A \code{\link[=grd_xy]{grd_xy()}}, \code{\link[=grd_rct]{grd_rct()}}, or other object
implementing \verb{grd_*()} methods.}

\item{level}{An integer describing the overview level. This is related to
the \code{step} value by a power of 2 (i.e., a level of \code{1} indicates a step of
\code{2}, a level of \code{2} indicates a step of \code{4}, etc.).}

\item{levels}{A vector of \code{level} values or \code{NULL} to use a sequence from
0 to the level that would result in a 1 x 1 grid.}
}
\value{
A \code{\link[=grd]{grd()}}
}
\description{
A useful workflow for raster data in a memory bounded environment is to
chunk a grid into sections or tiles. These functions compute tiles
suitable for such processing. Use \code{\link[=grd_tile_summary]{grd_tile_summary()}} to generate
statistics for \code{level} values to choose for your application.
}
\examples{
grid <- grd_rct(volcano)
grd_tile_summary(grid)
grd_tile_template(grid, 3)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/wkb.R
\name{wkb_to_hex}
\alias{wkb_to_hex}
\title{Convert well-known binary to hex}
\usage{
wkb_to_hex(x)
}
\arguments{
\item{x}{A \code{\link[=wkb]{wkb()}} vector}
}
\value{
A hex encoded \code{\link[=wkb]{wkb()}} vector
}
\description{
Convert well-known binary to hex
}
\examples{
x <- as_wkb(xyz(1:5, 6:10, 11:15))
wkb_to_hex(x)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/wk-crs.R
\name{wk_is_geodesic}
\alias{wk_is_geodesic}
\alias{wk_set_geodesic}
\alias{wk_is_geodesic<-}
\alias{wk_geodesic_inherit}
\title{Set and get vector geodesic edge interpolation}
\usage{
wk_is_geodesic(x)

wk_set_geodesic(x, geodesic)

wk_is_geodesic(x) <- value

wk_geodesic_inherit()
}
\arguments{
\item{x}{An R object that contains edges}

\item{geodesic}{\code{TRUE} if edges must be interpolated as geodesics when
coordinates are spherical, \code{FALSE} otherwise.}

\item{value}{See \code{geodesic}.}
}
\value{
\code{TRUE} if edges must be interpolated as geodesics when
coordinates are spherical, \code{FALSE} otherwise.
}
\description{
Set and get vector geodesic edge interpolation
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/grd-subset.R
\name{grd_cell}
\alias{grd_cell}
\alias{grd_cell_range}
\alias{grd_cell_rct}
\alias{grd_cell_rct.wk_grd_rct}
\alias{grd_cell_rct.wk_grd_xy}
\alias{grd_cell_xy}
\alias{grd_cell_xy.wk_grd_rct}
\alias{grd_cell_xy.wk_grd_xy}
\title{Grid cell operators}
\usage{
grd_cell(grid, point, ..., snap = grd_snap_next)

grd_cell_range(
  grid,
  bbox = wk_bbox(grid),
  ...,
  step = 1L,
  snap = grd_snap_next
)

grd_cell_rct(grid, i, j = NULL, ...)

\method{grd_cell_rct}{wk_grd_rct}(grid, i, j = NULL, ..., out_of_bounds = "keep")

\method{grd_cell_rct}{wk_grd_xy}(grid, i, j = NULL, ..., out_of_bounds = "keep")

grd_cell_xy(grid, i, j = NULL, ...)

\method{grd_cell_xy}{wk_grd_rct}(grid, i, j = NULL, ..., out_of_bounds = "keep")

\method{grd_cell_xy}{wk_grd_xy}(grid, i, j = NULL, ..., out_of_bounds = "keep")
}
\arguments{
\item{grid}{A \code{\link[=grd_xy]{grd_xy()}}, \code{\link[=grd_rct]{grd_rct()}}, or other object
implementing \verb{grd_*()} methods.}

\item{point}{A \link[=wk_handle]{handleable} of points.}

\item{...}{Unused}

\item{snap}{A function that transforms real-valued indices to integer
indices (e.g., \code{\link[=floor]{floor()}}, \code{\link[=ceiling]{ceiling()}}, or \code{\link[=round]{round()}}).
For \code{\link[=grd_cell_range]{grd_cell_range()}}, a \code{list()} with exactly two elements to be called
for the minimum and maximum index values, respectively.}

\item{bbox}{An \code{\link[=rct]{rct()}} object.}

\item{step}{The difference between adjascent indices in the output}

\item{i, j}{1-based index values. \code{i} indices correspond to decreasing
\code{y} values; \code{j} indices correspond to increasing \code{x} values.
Values outside the range \code{1:nrow|ncol(data)} will be censored to
\code{NA} including 0 and negative values.}

\item{out_of_bounds}{One of 'keep', 'censor', 'discard', or 'squish'}
}
\value{
\itemize{
\item \code{grd_cell()}: returns a \code{list(i, j)} of index values corresponding
to the input points and adjusted according to \code{snap}. Index values
will be outside \code{dim(grid)} for points outside \code{wk_bbox(grid)} including
negative values.
\item \code{grd_cell_range()} returns a slice describing the range of indices
in the \code{i} and \code{j} directions.
\item \code{grd_cell_rct()} returns a \code{\link[=rct]{rct()}} of the cell extent at \verb{i, j}.
\item \code{grd_cell_xy()} returns a \code{\link[=xy]{xy()}} of the cell center at \verb{i, j}.
}
}
\description{
Grid cell operators
}
\examples{
grid <- grd(nx = 3, ny = 2)
grd_cell(grid, xy(0.5, 0.5))
grd_cell_range(grid, grid$bbox)
grd_cell_rct(grid, 1, 1)
grd_cell_xy(grid, 1, 1)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rct.R
\name{new_wk_rct}
\alias{new_wk_rct}
\title{S3 details for rct objects}
\usage{
new_wk_rct(
  x = list(xmin = double(), ymin = double(), xmax = double(), ymax = double()),
  crs = NULL
)
}
\arguments{
\item{x}{A \code{\link[=rct]{rct()}}}

\item{crs}{A value to be propagated as the CRS for this vector.}
}
\description{
S3 details for rct objects
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/transform.R
\name{wk_trans_inverse}
\alias{wk_trans_inverse}
\alias{as_wk_trans}
\alias{as_wk_trans.wk_trans}
\alias{new_wk_trans}
\title{Generic transform class}
\usage{
wk_trans_inverse(trans, ...)

as_wk_trans(x, ...)

\method{as_wk_trans}{wk_trans}(x, ...)

new_wk_trans(trans_ptr, subclass = character())
}
\arguments{
\item{trans}{An external pointer to a wk_trans object}

\item{...}{Passed to S3 methods}

\item{x}{An object to be converted to a transform.}

\item{trans_ptr}{An external pointer to a wk_trans_t transform
struct.}

\item{subclass}{An optional subclass to apply to the pointer}
}
\description{
Generic transform class
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/problems.R
\name{wk_problems}
\alias{wk_problems}
\alias{wk_problems_handler}
\title{Validate well-known binary and well-known text}
\usage{
wk_problems(handleable, ...)

wk_problems_handler()
}
\arguments{
\item{handleable}{A geometry vector (e.g., \code{\link[=wkb]{wkb()}}, \code{\link[=wkt]{wkt()}}, \code{\link[=xy]{xy()}},
\code{\link[=rct]{rct()}}, or \code{\link[sf:sfc]{sf::st_sfc()}}) for which \code{\link[=wk_handle]{wk_handle()}} is defined.}

\item{...}{Passed to the \code{\link[=wk_handle]{wk_handle()}} method.}
}
\value{
A character vector of parsing errors. \code{NA} signifies
that there was no parsing error.
}
\description{
The problems handler returns a character vector of parse
errors and can be used to validate input of any type
for which \code{\link[=wk_handle]{wk_handle()}} is defined.
}
\examples{
wk_problems(new_wk_wkt(c("POINT EMTPY", "POINT (20 30)")))
wk_handle(
  new_wk_wkt(c("POINT EMTPY", "POINT (20 30)")),
  wk_problems_handler()
)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/wk-crs.R
\name{wk_crs_proj_definition}
\alias{wk_crs_proj_definition}
\alias{wk_crs_projjson}
\alias{wk_crs_proj_definition.NULL}
\alias{wk_crs_proj_definition.wk_crs_inherit}
\alias{wk_crs_proj_definition.character}
\alias{wk_crs_proj_definition.double}
\alias{wk_crs_proj_definition.integer}
\title{CRS object generic methods}
\usage{
wk_crs_proj_definition(crs, proj_version = NULL, verbose = FALSE)

wk_crs_projjson(crs)

\method{wk_crs_proj_definition}{`NULL`}(crs, proj_version = NULL, verbose = FALSE)

\method{wk_crs_proj_definition}{wk_crs_inherit}(crs, proj_version = NULL, verbose = FALSE)

\method{wk_crs_proj_definition}{character}(crs, proj_version = NULL, verbose = FALSE)

\method{wk_crs_proj_definition}{double}(crs, proj_version = NULL, verbose = FALSE)

\method{wk_crs_proj_definition}{integer}(crs, proj_version = NULL, verbose = FALSE)
}
\arguments{
\item{crs}{An arbitrary R object}

\item{proj_version}{A \code{\link[=package_version]{package_version()}} of the PROJ version, or
\code{NULL} if the PROJ version is unknown.}

\item{verbose}{Use \code{TRUE} to request a more verbose version of the
PROJ definition (e.g., PROJJSON). The default of \code{FALSE} should return
the most compact version that completely describes the CRS. An
authority:code string (e.g., "OGC:CRS84") is the recommended way
to represent a CRS when \code{verbose} is \code{FALSE}, if possible, falling
back to the most recent version of WKT2 or PROJJSON.}
}
\value{
\itemize{
\item \code{wk_crs_proj_definition()} Returns a string used to represent the
CRS in PROJ. For recent PROJ version you'll want to return PROJJSON;
however you should check \code{proj_version} if you want this to work with
older versions of PROJ.
\item \code{wk_crs_projjson()} Returns a PROJJSON string or NA_character_ if this
representation is unknown or can't be calculated.
}
}
\description{
CRS object generic methods
}
\examples{
wk_crs_proj_definition("EPSG:4326")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{wk_proj_crs_view}
\alias{wk_proj_crs_view}
\alias{wk_proj_crs_json}
\title{Common CRS Representations}
\format{
An object of class \code{data.frame} with 13387 rows and 7 columns.

An object of class \code{data.frame} with 13387 rows and 3 columns.
}
\usage{
wk_proj_crs_view

wk_proj_crs_json
}
\description{
These fixtures are calculated from PROJ version 9.1.0 and the database
built from its source. They are used internally to transform and inspect
coordinate reference systems.
}
\examples{
head(wk_proj_crs_view)
colnames(wk_proj_crs_json)

}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bbox.R
\name{wk_bbox}
\alias{wk_bbox}
\alias{wk_envelope}
\alias{wk_bbox.default}
\alias{wk_envelope.default}
\alias{wk_envelope.wk_rct}
\alias{wk_envelope.wk_crc}
\alias{wk_envelope.wk_xy}
\alias{wk_bbox_handler}
\alias{wk_envelope_handler}
\title{2D bounding rectangles}
\usage{
wk_bbox(handleable, ...)

wk_envelope(handleable, ...)

\method{wk_bbox}{default}(handleable, ...)

\method{wk_envelope}{default}(handleable, ...)

\method{wk_envelope}{wk_rct}(handleable, ...)

\method{wk_envelope}{wk_crc}(handleable, ...)

\method{wk_envelope}{wk_xy}(handleable, ...)

wk_bbox_handler()

wk_envelope_handler()
}
\arguments{
\item{handleable}{A geometry vector (e.g., \code{\link[=wkb]{wkb()}}, \code{\link[=wkt]{wkt()}}, \code{\link[=xy]{xy()}},
\code{\link[=rct]{rct()}}, or \code{\link[sf:sfc]{sf::st_sfc()}}) for which \code{\link[=wk_handle]{wk_handle()}} is defined.}

\item{...}{Passed to the \code{\link[=wk_handle]{wk_handle()}} method.}
}
\value{
A \code{\link[=rct]{rct()}} of length 1.
}
\description{
2D bounding rectangles
}
\examples{
wk_bbox(wkt("LINESTRING (1 2, 3 5)"))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/void.R
\name{wk_void}
\alias{wk_void}
\alias{wk_void_handler}
\title{Do nothing}
\usage{
wk_void(handleable, ...)

wk_void_handler()
}
\arguments{
\item{handleable}{A geometry vector (e.g., \code{\link[=wkb]{wkb()}}, \code{\link[=wkt]{wkt()}}, \code{\link[=xy]{xy()}},
\code{\link[=rct]{rct()}}, or \code{\link[sf:sfc]{sf::st_sfc()}}) for which \code{\link[=wk_handle]{wk_handle()}} is defined.}

\item{...}{Passed to the \code{\link[=wk_handle]{wk_handle()}} method.}
}
\value{
\code{NULL}
}
\description{
This handler does nothing and returns \code{NULL}. It is useful for
benchmarking readers and handlers and when using filters
that have side-effects (e.g., \code{\link[=wk_debug]{wk_debug()}}). Note that this
handler stops on the first parse error; to see a list of parse
errors see the \code{\link[=wk_problems]{wk_problems()}} handler.
}
\examples{
wk_void(wkt("POINT (1 4)"))
wk_handle(wkt("POINT (1 4)"), wk_void_handler())

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/grd-subset.R
\name{grd_snap_next}
\alias{grd_snap_next}
\alias{grd_snap_previous}
\title{Index snap functions}
\usage{
grd_snap_next(x)

grd_snap_previous(x)
}
\arguments{
\item{x}{A vector of rescaled but non-integer indices}
}
\value{
A vector of integer indices
}
\description{
These functions can be used in \code{\link[=grd_cell]{grd_cell()}} and
\code{\link[=grd_cell_range]{grd_cell_range()}}. These functions differ in the way
they round 0.5: \code{\link[=grd_snap_next]{grd_snap_next()}} always rounds up
and \code{\link[=grd_snap_previous]{grd_snap_previous()}} always rounds down. You can
also use \code{\link[=floor]{floor()}} and \code{\link[=ceiling]{ceiling()}} as index
snap functions.
}
\examples{
grd_snap_next(seq(0, 2, 0.25))
grd_snap_previous(seq(0, 2, 0.25))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/wkt.R
\name{wkt}
\alias{wkt}
\alias{parse_wkt}
\alias{as_wkt}
\alias{as_wkt.default}
\alias{as_wkt.character}
\alias{as_wkt.wk_wkt}
\title{Mark character vectors as well-known text}
\usage{
wkt(x = character(), crs = wk_crs_auto(), geodesic = FALSE)

parse_wkt(x, crs = wk_crs_auto(), geodesic = FALSE)

as_wkt(x, ...)

\method{as_wkt}{default}(x, ...)

\method{as_wkt}{character}(x, ..., crs = NULL, geodesic = FALSE)

\method{as_wkt}{wk_wkt}(x, ...)
}
\arguments{
\item{x}{A \code{\link[=character]{character()}} vector containing well-known text.}

\item{crs}{A value to be propagated as the CRS for this vector.}

\item{geodesic}{\code{TRUE} if edges must be interpolated as geodesics when
coordinates are spherical, \code{FALSE} otherwise.}

\item{...}{Unused}
}
\value{
A \code{\link[=new_wk_wkt]{new_wk_wkt()}}
}
\description{
Mark character vectors as well-known text
}
\examples{
wkt("POINT (20 10)")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/wkb.R
\name{wkb}
\alias{wkb}
\alias{parse_wkb}
\alias{wk_platform_endian}
\alias{as_wkb}
\alias{as_wkb.default}
\alias{as_wkb.character}
\alias{as_wkb.wk_wkb}
\alias{as_wkb.blob}
\alias{as_wkb.WKB}
\title{Mark lists of raw vectors as well-known binary}
\usage{
wkb(x = list(), crs = wk_crs_auto(), geodesic = FALSE)

parse_wkb(x, crs = wk_crs_auto(), geodesic = FALSE)

wk_platform_endian()

as_wkb(x, ...)

\method{as_wkb}{default}(x, ...)

\method{as_wkb}{character}(x, ..., crs = NULL, geodesic = FALSE)

\method{as_wkb}{wk_wkb}(x, ...)

\method{as_wkb}{blob}(x, ..., crs = NULL, geodesic = FALSE)

\method{as_wkb}{WKB}(x, ..., crs = NULL, geodesic = FALSE)
}
\arguments{
\item{x}{A \code{\link[=list]{list()}} of \code{\link[=raw]{raw()}} vectors or \code{NULL}.}

\item{crs}{A value to be propagated as the CRS for this vector.}

\item{geodesic}{\code{TRUE} if edges must be interpolated as geodesics when
coordinates are spherical, \code{FALSE} otherwise.}

\item{...}{Unused}
}
\value{
A \code{\link[=new_wk_wkb]{new_wk_wkb()}}
}
\description{
Mark lists of raw vectors as well-known binary
}
\examples{
as_wkb("POINT (20 10)")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/grd-extract.R
\name{grd_extract}
\alias{grd_extract}
\alias{grd_extract_nearest}
\alias{grd_data_extract}
\title{Extract values from a grid}
\usage{
grd_extract(grid, i = NULL, j = NULL)

grd_extract_nearest(grid, point, out_of_bounds = c("censor", "squish"))

grd_data_extract(grid_data, i = NULL, j = NULL)
}
\arguments{
\item{grid}{A \code{\link[=grd_xy]{grd_xy()}}, \code{\link[=grd_rct]{grd_rct()}}, or other object
implementing \verb{grd_*()} methods.}

\item{i, j}{Index values as in \code{\link[=grd_subset]{grd_subset()}} except recycled to a common
size.}

\item{point}{A \link[=wk_handle]{handleable} of points.}

\item{out_of_bounds}{One of 'keep', 'censor', 'discard', or 'squish'}

\item{grid_data}{The \code{data} member of a \code{\link[=grd]{grd()}}. This is typically an
array but can also be an S3 object with an array-like subset method.
The \link[grDevices:as.raster]{native raster} is special-cased as its
subset method requires non-standard handling.}
}
\value{
A matrix or vector with two fewer dimensions than the input.
}
\description{
Unlike \code{\link[=grd_subset]{grd_subset()}}, which subsets like a matrix, \code{\link[=grd_extract]{grd_extract()}} returns
values.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/filter.R
\name{wk_identity}
\alias{wk_identity}
\alias{wk_identity_filter}
\alias{wk_restore}
\alias{wk_restore.default}
\title{Copy a geometry vector}
\usage{
wk_identity(handleable, ...)

wk_identity_filter(handler)

wk_restore(handleable, result, ...)

\method{wk_restore}{default}(handleable, result, ...)
}
\arguments{
\item{handleable}{A geometry vector (e.g., \code{\link[=wkb]{wkb()}}, \code{\link[=wkt]{wkt()}}, \code{\link[=xy]{xy()}},
\code{\link[=rct]{rct()}}, or \code{\link[sf:sfc]{sf::st_sfc()}}) for which \code{\link[=wk_handle]{wk_handle()}} is defined.}

\item{...}{Passed to the \code{\link[=wk_handle]{wk_handle()}} method.}

\item{handler}{A \link[=wk_handle]{wk_handler} object.}

\item{result}{The result of a filter operation intended to be a
transformation.}
}
\value{
A copy of \code{handleable}.
}
\description{
Copy a geometry vector
}
\examples{
wk_identity(wkt("POINT (1 2)"))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vertex-filter.R
\name{wk_vertices}
\alias{wk_vertices}
\alias{wk_coords}
\alias{wk_coords<-}
\alias{wk_vertex_filter}
\title{Extract vertices}
\usage{
wk_vertices(handleable, ...)

wk_coords(handleable, ...)

wk_coords(handleable, use_z = NA, use_m = NA) <- value

wk_vertex_filter(handler, add_details = FALSE)
}
\arguments{
\item{handleable}{A geometry vector (e.g., \code{\link[=wkb]{wkb()}}, \code{\link[=wkt]{wkt()}}, \code{\link[=xy]{xy()}},
\code{\link[=rct]{rct()}}, or \code{\link[sf:sfc]{sf::st_sfc()}}) for which \code{\link[=wk_handle]{wk_handle()}} is defined.}

\item{...}{Passed to the \code{\link[=wk_handle]{wk_handle()}} method.}

\item{use_z, use_m}{Used to declare the output type. Use \code{TRUE} to
ensure the output has that dimension, \code{FALSE} to ensure it does not,
and \code{NA} to leave the dimension unchanged.}

\item{value}{An \code{\link[=xy]{xy()}}, \code{\link[=xyz]{xyz()}}, \code{\link[=xym]{xym()}}, or \code{\link[=xyzm]{xyzm()}} of coordinates
used to replace values in the input. Use \code{NA} to keep the existing
value.}

\item{handler}{A \link[=wk_handle]{wk_handler} object.}

\item{add_details}{Use \code{TRUE} to add a "wk_details" attribute, which
contains columns \code{feature_id}, \code{part_id}, and \code{ring_id}.}
}
\value{
\itemize{
\item \code{wk_vertices()} extracts vertices and returns the in the same format as
the handler
\item \code{wk_coords()} returns a data frame with columns columns \code{feature_id}
(the index of the feature from whence it came), \code{part_id} (an arbitrary
integer identifying the point, line, or polygon from whence it came),
\code{ring_id} (an arbitrary integer identifying individual rings within
polygons), and one column per coordinate (\code{x}, \code{y}, and/or \code{z} and/or \code{m}).
}
}
\description{
These functions provide ways to extract individual coordinate values.
Whereas \code{wk_vertices()} returns a vector of coordinates as in the same
format as the input, \code{wk_coords()} returns a data frame with coordinates
as columns.
}
\details{
\verb{wk_coords<-} is the replacement-function version of 'wk_coords'.
Using the engine of \code{\link[=wk_trans_explicit]{wk_trans_explicit()}} the coordinates of an object
can be transformed in a generic way using R functions as needed.
}
\examples{
wk_vertices(wkt("LINESTRING (0 0, 1 1)"))
wk_coords(wkt("LINESTRING (0 0, 1 1)"))

# wk_coords() replacement function
x <- xy(1:5, 1:5)
y <- as_wkt(x)
wk_coords(y) <- cbind(5:1, 0:4)
wk_coords(x) <- y[5:1]
y
x

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/flatten.R
\name{wk_flatten}
\alias{wk_flatten}
\alias{wk_flatten_filter}
\title{Extract simple geometries}
\usage{
wk_flatten(handleable, ..., max_depth = 1)

wk_flatten_filter(handler, max_depth = 1L, add_details = FALSE)
}
\arguments{
\item{handleable}{A geometry vector (e.g., \code{\link[=wkb]{wkb()}}, \code{\link[=wkt]{wkt()}}, \code{\link[=xy]{xy()}},
\code{\link[=rct]{rct()}}, or \code{\link[sf:sfc]{sf::st_sfc()}}) for which \code{\link[=wk_handle]{wk_handle()}} is defined.}

\item{...}{Passed to the \code{\link[=wk_handle]{wk_handle()}} method.}

\item{max_depth}{The maximum (outer) depth to remove.}

\item{handler}{A \link[=wk_handle]{wk_handler} object.}

\item{add_details}{Use \code{TRUE} to add a "wk_details" attribute, which
contains columns \code{feature_id}, \code{part_id}, and \code{ring_id}.}
}
\value{
\code{handleable} transformed such that collections have been
expanded and only simple geometries (point, linestring, polygon)
remain.
}
\description{
Extract simple geometries
}
\examples{
wk_flatten(wkt("MULTIPOINT (1 1, 2 2, 3 3)"))
wk_flatten(
  wkt("GEOMETRYCOLLECTION (GEOMETRYCOLLECTION (GEOMETRYCOLLECTION (POINT (0 1))))"),
  max_depth = 2
)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/deprecated.R
\name{wkb_translate_wkt}
\alias{wkb_translate_wkt}
\alias{wkb_translate_wkb}
\alias{wkt_translate_wkt}
\alias{wkt_translate_wkb}
\title{Deprecated functions}
\usage{
wkb_translate_wkt(wkb, ..., precision = 16, trim = TRUE)

wkb_translate_wkb(wkb, ..., endian = NA_integer_)

wkt_translate_wkt(wkt, ..., precision = 16, trim = TRUE)

wkt_translate_wkb(wkt, ..., endian = NA_integer_)
}
\arguments{
\item{wkb}{A \code{list()} of \code{\link[=raw]{raw()}} vectors, such as that
returned by \code{sf::st_as_binary()}.}

\item{...}{Used to keep backward compatibility with previous
versions of these functions.}

\item{precision}{The rounding precision to use when writing
(number of decimal places).}

\item{trim}{Trim unnecessary zeroes in the output?}

\item{endian}{Force the endian of the resulting WKB.}

\item{wkt}{A character vector containing well-known text.}
}
\description{
These functions are deprecated and will be removed in a future version.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/wk-crs.R
\name{wk_crs}
\alias{wk_crs}
\alias{wk_crs.wk_vctr}
\alias{wk_crs.wk_rcrd}
\alias{wk_crs<-}
\alias{wk_set_crs}
\alias{wk_crs_output}
\alias{wk_is_geodesic_output}
\title{Set and get vector CRS}
\usage{
wk_crs(x)

\method{wk_crs}{wk_vctr}(x)

\method{wk_crs}{wk_rcrd}(x)

wk_crs(x) <- value

wk_set_crs(x, crs)

wk_crs_output(...)

wk_is_geodesic_output(...)
}
\arguments{
\item{x, ...}{Objects whose "crs" attribute is used to carry a CRS.}

\item{value}{See \code{crs}.}

\item{crs}{An object that can be interpreted as a CRS}
}
\description{
The wk package doesn't operate on CRS objects, but does propagate them
through subsetting and concatenation. A CRS object can be any R object,
and x can be any object whose 'crs' attribute carries a CRS. These functions
are S3 generics to keep them from being used
on objects that do not use this system of CRS propagation.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/orient-filter.R
\name{wk_orient}
\alias{wk_orient}
\alias{wk_orient_filter}
\alias{wk_clockwise}
\alias{wk_counterclockwise}
\title{Orient polygon coordinates}
\usage{
wk_orient(handleable, ..., direction = wk_counterclockwise())

wk_orient_filter(handler, direction = wk_counterclockwise())

wk_clockwise()

wk_counterclockwise()
}
\arguments{
\item{handleable}{A geometry vector (e.g., \code{\link[=wkb]{wkb()}}, \code{\link[=wkt]{wkt()}}, \code{\link[=xy]{xy()}},
\code{\link[=rct]{rct()}}, or \code{\link[sf:sfc]{sf::st_sfc()}}) for which \code{\link[=wk_handle]{wk_handle()}} is defined.}

\item{...}{Passed to the \code{\link[=wk_handle]{wk_handle()}} method.}

\item{direction}{The winding polygon winding direction}

\item{handler}{A \link[=wk_handle]{wk_handler} object.}
}
\value{
\code{handleable} with consistently oriented polygons, in \code{direction}
winding order.
}
\description{
Orient polygon coordinates
}
\examples{
wk_orient(wkt("POLYGON ((0 0, 1 0, 1 1, 0 1, 0 0))"))
wk_orient(
  wkt("POLYGON ((0 0, 0 1, 1 1, 1 0, 0 0))"),
  direction = wk_clockwise()
)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/debug.R
\name{wk_debug}
\alias{wk_debug}
\alias{wk_debug_filter}
\title{Debug filters and handlers}
\usage{
wk_debug(handleable, handler = wk_void_handler(), ...)

wk_debug_filter(handler = wk_void_handler())
}
\arguments{
\item{handleable}{A geometry vector (e.g., \code{\link[=wkb]{wkb()}}, \code{\link[=wkt]{wkt()}}, \code{\link[=xy]{xy()}},
\code{\link[=rct]{rct()}}, or \code{\link[sf:sfc]{sf::st_sfc()}}) for which \code{\link[=wk_handle]{wk_handle()}} is defined.}

\item{handler}{A \link[=wk_handle]{wk_handler} object.}

\item{...}{Passed to the \code{\link[=wk_handle]{wk_handle()}} method.}
}
\value{
The result of the \code{handler}.
}
\description{
Debug filters and handlers
}
\examples{
wk_debug(wkt("POINT (1 1)"))
wk_handle(wkt("POINT (1 1)"), wk_debug_filter())

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/class-data-frame.R, R/handle-slice.R
\name{wk_handle_slice.data.frame}
\alias{wk_handle_slice.data.frame}
\alias{wk_handle_slice}
\alias{wk_handle_slice.default}
\title{Handle specific regions of objects}
\usage{
\method{wk_handle_slice}{data.frame}(handleable, handler, from = NULL, to = NULL, ...)

wk_handle_slice(
  handleable,
  handler = wk_writer(handleable),
  from = NULL,
  to = NULL,
  ...
)

\method{wk_handle_slice}{default}(
  handleable,
  handler = wk_writer(handleable),
  from = NULL,
  to = NULL,
  ...
)
}
\arguments{
\item{handleable}{A geometry vector (e.g., \code{\link[=wkb]{wkb()}}, \code{\link[=wkt]{wkt()}}, \code{\link[=xy]{xy()}},
\code{\link[=rct]{rct()}}, or \code{\link[sf:sfc]{sf::st_sfc()}}) for which \code{\link[=wk_handle]{wk_handle()}} is defined.}

\item{handler}{A \link[=wk_handle]{wk_handler} object.}

\item{from}{1-based index of the feature to start from}

\item{to}{1-based index of the feature to end at}

\item{...}{Passed to the \code{\link[=wk_handle]{wk_handle()}} method.}
}
\value{
A subset of \code{handleable}
}
\description{
Handle specific regions of objects
}
\examples{
wk_handle_slice(xy(1:5, 1:5), wkt_writer(), from = 3, to = 5)
wk_handle_slice(
  data.frame(let = letters[1:5], geom = xy(1:5, 1:5)),
  wkt_writer(),
  from = 3, to = 5
)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rct.R
\name{rct}
\alias{rct}
\alias{as_rct}
\alias{as_rct.wk_rct}
\alias{as_rct.matrix}
\alias{as_rct.data.frame}
\title{2D rectangle vectors}
\usage{
rct(
  xmin = double(),
  ymin = double(),
  xmax = double(),
  ymax = double(),
  crs = wk_crs_auto()
)

as_rct(x, ...)

\method{as_rct}{wk_rct}(x, ...)

\method{as_rct}{matrix}(x, ..., crs = NULL)

\method{as_rct}{data.frame}(x, ..., crs = NULL)
}
\arguments{
\item{xmin, ymin, xmax, ymax}{Rectangle bounds.}

\item{crs}{A value to be propagated as the CRS for this vector.}

\item{x}{An object to be converted to a \code{\link[=rct]{rct()}}.}

\item{...}{Extra arguments passed to \code{as_rct()}.}
}
\value{
A vector along the recycled length of bounds.
}
\description{
2D rectangle vectors
}
\examples{
rct(1, 2, 3, 4)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/wkb.R
\name{new_wk_wkb}
\alias{new_wk_wkb}
\alias{validate_wk_wkb}
\alias{is_wk_wkb}
\title{S3 Details for wk_wkb}
\usage{
new_wk_wkb(x = list(), crs = NULL, geodesic = NULL)

validate_wk_wkb(x)

is_wk_wkb(x)
}
\arguments{
\item{x}{A (possibly) \code{\link[=wkb]{wkb()}} vector}

\item{crs}{A value to be propagated as the CRS for this vector.}

\item{geodesic}{\code{TRUE} if edges must be interpolated as geodesics when
coordinates are spherical, \code{FALSE} otherwise.}
}
\description{
S3 Details for wk_wkb
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/set.R
\name{wk_set_z}
\alias{wk_set_z}
\alias{wk_set_m}
\alias{wk_drop_z}
\alias{wk_drop_m}
\alias{wk_trans_set}
\title{Set coordinate values}
\usage{
wk_set_z(handleable, z, ...)

wk_set_m(handleable, m, ...)

wk_drop_z(handleable, ...)

wk_drop_m(handleable, ...)

wk_trans_set(value, use_z = NA, use_m = NA)
}
\arguments{
\item{handleable}{A geometry vector (e.g., \code{\link[=wkb]{wkb()}}, \code{\link[=wkt]{wkt()}}, \code{\link[=xy]{xy()}},
\code{\link[=rct]{rct()}}, or \code{\link[sf:sfc]{sf::st_sfc()}}) for which \code{\link[=wk_handle]{wk_handle()}} is defined.}

\item{z, m}{A vector of Z or M values applied feature-wise and recycled
along \code{handleable}. Use \code{NA} to keep the existing value of a given
feature.}

\item{...}{Passed to the \code{\link[=wk_handle]{wk_handle()}} method.}

\item{value}{An \code{\link[=xy]{xy()}}, \code{\link[=xyz]{xyz()}}, \code{\link[=xym]{xym()}}, or \code{\link[=xyzm]{xyzm()}} of coordinates
used to replace values in the input. Use \code{NA} to keep the existing
value.}

\item{use_z, use_m}{Used to declare the output type. Use \code{TRUE} to
ensure the output has that dimension, \code{FALSE} to ensure it does not,
and \code{NA} to leave the dimension unchanged.}
}
\description{
Set coordinate values
}
\examples{
wk_set_z(wkt("POINT (0 1)"), 2)
wk_set_m(wkt("POINT (0 1)"), 2)
wk_drop_z(wkt("POINT ZM (0 1 2 3)"))
wk_drop_m(wkt("POINT ZM (0 1 2 3)"))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rct.R
\name{rct_xmin}
\alias{rct_xmin}
\alias{rct_ymin}
\alias{rct_xmax}
\alias{rct_ymax}
\alias{rct_width}
\alias{rct_height}
\alias{rct_intersects}
\alias{rct_contains}
\alias{rct_intersection}
\title{Rectangle accessors and operators}
\usage{
rct_xmin(x)

rct_ymin(x)

rct_xmax(x)

rct_ymax(x)

rct_width(x)

rct_height(x)

rct_intersects(x, y)

rct_contains(x, y)

rct_intersection(x, y)
}
\arguments{
\item{x, y}{\code{\link[=rct]{rct()}} vectors}
}
\value{
\itemize{
\item \code{rct_xmin()}, \code{rct_xmax()}, \code{rct_ymin()}, and \code{rct_ymax()} return
the components of the \code{\link[=rct]{rct()}}.
}
}
\description{
Rectangle accessors and operators
}
\examples{
x <- rct(0, 0, 10, 10)
y <- rct(5, 5, 15, 15)

rct_xmin(x)
rct_ymin(x)
rct_xmax(x)
rct_ymax(x)
rct_height(x)
rct_width(x)
rct_intersects(x, y)
rct_intersection(x, y)
rct_contains(x, y)
rct_contains(x, rct(4, 4, 6, 6))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/count.R
\name{wk_count}
\alias{wk_count}
\alias{wk_count.default}
\alias{wk_count_handler}
\title{Count geometry components}
\usage{
wk_count(handleable, ...)

\method{wk_count}{default}(handleable, ...)

wk_count_handler()
}
\arguments{
\item{handleable}{A geometry vector (e.g., \code{\link[=wkb]{wkb()}}, \code{\link[=wkt]{wkt()}}, \code{\link[=xy]{xy()}},
\code{\link[=rct]{rct()}}, or \code{\link[sf:sfc]{sf::st_sfc()}}) for which \code{\link[=wk_handle]{wk_handle()}} is defined.}

\item{...}{Passed to the \code{\link[=wk_handle]{wk_handle()}} method.}
}
\value{
A data.frame with one row for every feature encountered and
columns:
\itemize{
\item \code{n_geom}: The number of geometries encountered, including the
root geometry. Will be zero for a null feature.
\item \code{n_ring}: The number of rings encountered. Will be zero for a
null feature.
\item \code{n_coord}: The number of coordinates encountered. Will be zero
for a null feature.
}
}
\description{
Counts the number of geometries, rings, and coordinates found within
each feature. As opposed to \code{\link[=wk_meta]{wk_meta()}}, this handler will iterate
over the entire geometry.
}
\examples{
wk_count(as_wkt("LINESTRING (0 0, 1 1)"))
wk_count(as_wkb("LINESTRING (0 0, 1 1)"))

}
